{++

  m a p i t a g s . p a s

  Abstract:

    Automatic conversion of mapitags.h.

  Comments:

    This source file automatically converted by
    htrans 0.91 beta 1 Copyright (c) 1997 Alexander Staubo

  Revision history:

    18-06-1997 20:53 alex  [Autogenerated]
    18-06-1997 20:53 alex  Retouched for release

--}

unit MapiTags;

interface

uses
  Windows, SysUtils, ActiveX, Mapidefs;

(*
 *  M A P I T A G S . H
 *
 *  Property tag definitions for standard properties of MAPI
 *  objects.
 *
 *  The following ranges should be used for all property IDs. Note that
 *  property IDs for objects other than messages and recipients should
 *  all fall in the range 0x3000 to 0x3FFF:
 *
 *  From    To      Kind of property
 *  --------------------------------
 *  0001    0BFF    MAPI_defined envelope property
 *  0C00    0DFF    MAPI_defined per-recipient property
 *  0E00    0FFF    MAPI_defined non-transmittable property
 *  1000    2FFF    MAPI_defined message content property
 *
 *  3000    3FFF    MAPI_defined property (usually not message or recipient)
 *
 *  4000    57FF    Transport-defined envelope property
 *  5800    5FFF    Transport-defined per-recipient property
 *  6000    65FF    User-defined non-transmittable property
 *  6600    67FF    Provider-defined internal non-transmittable property
 *  6800    7BFF    Message class-defined content property
 *  7C00    7FFF    Message class-defined non-transmittable
 *                  property
 *
 *  8000    FFFE    User-defined Name-to-id mapped property
 *
 *  The 3000-3FFF range is further subdivided as follows:
 *
 *  From    To      Kind of property
 *  --------------------------------
 *  3000    33FF    Common property such as display name, entry ID
 *  3400    35FF    Message store object
 *  3600    36FF    Folder or AB container
 *  3700    38FF    Attachment
 *  3900    39FF    Address book object
 *  3A00    3BFF    Mail user
 *  3C00    3CFF    Distribution list
 *  3D00    3DFF    Profile section
 *  3E00    3FFF    Status object
 *
 *  Copyright 1986-1996 Microsoft Corporation. All Rights Reserved.
 *)




{ Determine if a property is transmittable. }



(*
 *  Message envelope properties
 *)

const PR_ACKNOWLEDGEMENT_MODE                      =
   (PT_LONG) or (($0001) shl 16);
const PR_ALTERNATE_RECIPIENT_ALLOWED               = 
   (PT_BOOLEAN) or (($0002) shl 16);
const PR_AUTHORIZING_USERS                         =
   (PT_BINARY) or (($0003) shl 16);
const PR_AUTO_FORWARD_COMMENT                      = 
   (PT_TSTRING) or (($0004) shl 16);
const PR_AUTO_FORWARD_COMMENT_W                    = 
   (PT_UNICODE) or (($0004) shl 16);
const PR_AUTO_FORWARD_COMMENT_A                    = 
   (PT_STRING8) or (($0004) shl 16);
const PR_AUTO_FORWARDED                            =
   (PT_BOOLEAN) or (($0005) shl 16);
const PR_CONTENT_CONFIDENTIALITY_ALGORITHM_ID      =
   (PT_BINARY) or (($0006) shl 16);
const PR_CONTENT_CORRELATOR                        =
   (PT_BINARY) or (($0007) shl 16);
const PR_CONTENT_IDENTIFIER                        =
   (PT_TSTRING) or (($0008) shl 16);
const PR_CONTENT_IDENTIFIER_W                      =
   (PT_UNICODE) or (($0008) shl 16);
const PR_CONTENT_IDENTIFIER_A                      = 
   (PT_STRING8) or (($0008) shl 16);
const PR_CONTENT_LENGTH                            =
   (PT_LONG) or (($0009) shl 16);
const PR_CONTENT_RETURN_REQUESTED                  = 
   (PT_BOOLEAN) or (($000A) shl 16);



const PR_CONVERSATION_KEY                          =
   (PT_BINARY) or (($000B) shl 16);

const PR_CONVERSION_EITS                           = 
   (PT_BINARY) or (($000C) shl 16);
const PR_CONVERSION_WITH_LOSS_PROHIBITED           = 
   (PT_BOOLEAN) or (($000D) shl 16);
const PR_CONVERTED_EITS                            = 
   (PT_BINARY) or (($000E) shl 16);
const PR_DEFERRED_DELIVERY_TIME                    = 
   (PT_SYSTIME) or (($000F) shl 16);
const PR_DELIVER_TIME                              = 
   (PT_SYSTIME) or (($0010) shl 16);
const PR_DISCARD_REASON                            = 
   (PT_LONG) or (($0011) shl 16);
const PR_DISCLOSURE_OF_RECIPIENTS                  = 
   (PT_BOOLEAN) or (($0012) shl 16);
const PR_DL_EXPANSION_HISTORY                      =
   (PT_BINARY) or (($0013) shl 16);
const PR_DL_EXPANSION_PROHIBITED                   = 
   (PT_BOOLEAN) or (($0014) shl 16);
const PR_EXPIRY_TIME                               =
   (PT_SYSTIME) or (($0015) shl 16);
const PR_IMPLICIT_CONVERSION_PROHIBITED            = 
   (PT_BOOLEAN) or (($0016) shl 16);
const PR_IMPORTANCE                                = 
   (PT_LONG) or (($0017) shl 16);
const PR_IPM_ID                                    = 
   (PT_BINARY) or (($0018) shl 16);
const PR_LATEST_DELIVERY_TIME                      = 
   (PT_SYSTIME) or (($0019) shl 16);
const PR_MESSAGE_CLASS                             = 
   (PT_TSTRING) or (($001A) shl 16);
const PR_MESSAGE_CLASS_W                           = 
   (PT_UNICODE) or (($001A) shl 16);
const PR_MESSAGE_CLASS_A                           = 
   (PT_STRING8) or (($001A) shl 16);
const PR_MESSAGE_DELIVERY_ID                       =
   (PT_BINARY) or (($001B) shl 16);





const PR_MESSAGE_SECURITY_LABEL                    = 
   (PT_BINARY) or (($001E) shl 16);
const PR_OBSOLETED_IPMS                            = 
   (PT_BINARY) or (($001F) shl 16);
const PR_ORIGINALLY_INTENDED_RECIPIENT_NAME        = 
   (PT_BINARY) or (($0020) shl 16);
const PR_ORIGINAL_EITS                             = 
   (PT_BINARY) or (($0021) shl 16);
const PR_ORIGINATOR_CERTIFICATE                    = 
   (PT_BINARY) or (($0022) shl 16);
const PR_ORIGINATOR_DELIVERY_REPORT_REQUESTED      = 
   (PT_BOOLEAN) or (($0023) shl 16);
const PR_ORIGINATOR_RETURN_ADDRESS                 = 
   (PT_BINARY) or (($0024) shl 16);



const PR_PARENT_KEY                                = 
   (PT_BINARY) or (($0025) shl 16);
const PR_PRIORITY                                  = 
   (PT_LONG) or (($0026) shl 16);



const PR_ORIGIN_CHECK                              = 
   (PT_BINARY) or (($0027) shl 16);
const PR_PROOF_OF_SUBMISSION_REQUESTED             = 
   (PT_BOOLEAN) or (($0028) shl 16);
const PR_READ_RECEIPT_REQUESTED                    = 
   (PT_BOOLEAN) or (($0029) shl 16);
const PR_RECEIPT_TIME                              = 
   (PT_SYSTIME) or (($002A) shl 16);
const PR_RECIPIENT_REASSIGNMENT_PROHIBITED         = 
   (PT_BOOLEAN) or (($002B) shl 16);
const PR_REDIRECTION_HISTORY                       = 
   (PT_BINARY) or (($002C) shl 16);
const PR_RELATED_IPMS                              = 
   (PT_BINARY) or (($002D) shl 16);
const PR_ORIGINAL_SENSITIVITY                      = 
   (PT_LONG) or (($002E) shl 16);
const PR_LANGUAGES                                 = 
   (PT_TSTRING) or (($002F) shl 16);
const PR_LANGUAGES_W                               = 
   (PT_UNICODE) or (($002F) shl 16);
const PR_LANGUAGES_A                               = 
   (PT_STRING8) or (($002F) shl 16);
const PR_REPLY_TIME                                = 
   (PT_SYSTIME) or (($0030) shl 16);
const PR_REPORT_TAG                                = 
   (PT_BINARY) or (($0031) shl 16);
const PR_REPORT_TIME                               = 
   (PT_SYSTIME) or (($0032) shl 16);
const PR_RETURNED_IPM                              = 
   (PT_BOOLEAN) or (($0033) shl 16);
const PR_SECURITY                                  = 
   (PT_LONG) or (($0034) shl 16);
const PR_INCOMPLETE_COPY                           = 
   (PT_BOOLEAN) or (($0035) shl 16);
const PR_SENSITIVITY                               = 
   (PT_LONG) or (($0036) shl 16);
const PR_SUBJECT                                   =
   (PT_TSTRING) or (($0037) shl 16);
const PR_SUBJECT_W                                 = 
   (PT_UNICODE) or (($0037) shl 16);
const PR_SUBJECT_A                                 = 
   (PT_STRING8) or (($0037) shl 16);
const PR_SUBJECT_IPM                               = 
   (PT_BINARY) or (($0038) shl 16);
const PR_CLIENT_SUBMIT_TIME                        = 
   (PT_SYSTIME) or (($0039) shl 16);
const PR_REPORT_NAME                               = 
   (PT_TSTRING) or (($003A) shl 16);
const PR_REPORT_NAME_W                             = 
   (PT_UNICODE) or (($003A) shl 16);
const PR_REPORT_NAME_A                             = 
   (PT_STRING8) or (($003A) shl 16);
const PR_SENT_REPRESENTING_SEARCH_KEY              =
   (PT_BINARY) or (($003B) shl 16);
const PR_X400_CONTENT_TYPE                         = 
   (PT_BINARY) or (($003C) shl 16);
const PR_SUBJECT_PREFIX                            = 
   (PT_TSTRING) or (($003D) shl 16);
const PR_SUBJECT_PREFIX_W                          = 
   (PT_UNICODE) or (($003D) shl 16);
const PR_SUBJECT_PREFIX_A                          = 
   (PT_STRING8) or (($003D) shl 16);
const PR_NON_RECEIPT_REASON                        = 
   (PT_LONG) or (($003E) shl 16);
const PR_RECEIVED_BY_ENTRYID                       = 
   (PT_BINARY) or (($003F) shl 16);
const PR_RECEIVED_BY_NAME                          = 
   (PT_TSTRING) or (($0040) shl 16);
const PR_RECEIVED_BY_NAME_W                        = 
   (PT_UNICODE) or (($0040) shl 16);
const PR_RECEIVED_BY_NAME_A                        = 
   (PT_STRING8) or (($0040) shl 16);
const PR_SENT_REPRESENTING_ENTRYID                 = 
   (PT_BINARY) or (($0041) shl 16);
const PR_SENT_REPRESENTING_NAME                    = 
   (PT_TSTRING) or (($0042) shl 16);
const PR_SENT_REPRESENTING_NAME_W                  = 
   (PT_UNICODE) or (($0042) shl 16);
const PR_SENT_REPRESENTING_NAME_A                  = 
   (PT_STRING8) or (($0042) shl 16);
const PR_RCVD_REPRESENTING_ENTRYID                 = 
   (PT_BINARY) or (($0043) shl 16);
const PR_RCVD_REPRESENTING_NAME                    = 
   (PT_TSTRING) or (($0044) shl 16);
const PR_RCVD_REPRESENTING_NAME_W                  = 
   (PT_UNICODE) or (($0044) shl 16);
const PR_RCVD_REPRESENTING_NAME_A                  = 
   (PT_STRING8) or (($0044) shl 16);
const PR_REPORT_ENTRYID                            = 
   (PT_BINARY) or (($0045) shl 16);
const PR_READ_RECEIPT_ENTRYID                      = 
   (PT_BINARY) or (($0046) shl 16);
const PR_MESSAGE_SUBMISSION_ID                     = 
   (PT_BINARY) or (($0047) shl 16);
const PR_PROVIDER_SUBMIT_TIME                      = 
   (PT_SYSTIME) or (($0048) shl 16);
const PR_ORIGINAL_SUBJECT                          = 
   (PT_TSTRING) or (($0049) shl 16);
const PR_ORIGINAL_SUBJECT_W                        = 
   (PT_UNICODE) or (($0049) shl 16);
const PR_ORIGINAL_SUBJECT_A                        = 
   (PT_STRING8) or (($0049) shl 16);
const PR_DISC_VAL                                  =
   (PT_BOOLEAN) or (($004A) shl 16);
const PR_ORIG_MESSAGE_CLASS                        =
   (PT_TSTRING) or (($004B) shl 16);
const PR_ORIG_MESSAGE_CLASS_W                      =
   (PT_UNICODE) or (($004B) shl 16);
const PR_ORIG_MESSAGE_CLASS_A                      = 
   (PT_STRING8) or (($004B) shl 16);
const PR_ORIGINAL_AUTHOR_ENTRYID                   =
   (PT_BINARY) or (($004C) shl 16);
const PR_ORIGINAL_AUTHOR_NAME                      = 
   (PT_TSTRING) or (($004D) shl 16);
const PR_ORIGINAL_AUTHOR_NAME_W                    = 
   (PT_UNICODE) or (($004D) shl 16);
const PR_ORIGINAL_AUTHOR_NAME_A                    = 
   (PT_STRING8) or (($004D) shl 16);
const PR_ORIGINAL_SUBMIT_TIME                      = 
   (PT_SYSTIME) or (($004E) shl 16);
const PR_REPLY_RECIPIENT_ENTRIES                   = 
   (PT_BINARY) or (($004F) shl 16);
const PR_REPLY_RECIPIENT_NAMES                     = 
   (PT_TSTRING) or (($0050) shl 16);
const PR_REPLY_RECIPIENT_NAMES_W                   = 
   (PT_UNICODE) or (($0050) shl 16);
const PR_REPLY_RECIPIENT_NAMES_A                   = 
   (PT_STRING8) or (($0050) shl 16);

const PR_RECEIVED_BY_SEARCH_KEY                    = 
   (PT_BINARY) or (($0051) shl 16);
const PR_RCVD_REPRESENTING_SEARCH_KEY              = 
   (PT_BINARY) or (($0052) shl 16);
const PR_READ_RECEIPT_SEARCH_KEY                   = 
   (PT_BINARY) or (($0053) shl 16);
const PR_REPORT_SEARCH_KEY                         =
   (PT_BINARY) or (($0054) shl 16);
const PR_ORIGINAL_DELIVERY_TIME                    = 
   (PT_SYSTIME) or (($0055) shl 16);
const PR_ORIGINAL_AUTHOR_SEARCH_KEY                = 
   (PT_BINARY) or (($0056) shl 16);

const PR_MESSAGE_TO_ME                             = 
   (PT_BOOLEAN) or (($0057) shl 16);
const PR_MESSAGE_CC_ME                             = 
   (PT_BOOLEAN) or (($0058) shl 16);
const PR_MESSAGE_RECIP_ME                          = 
   (PT_BOOLEAN) or (($0059) shl 16);

const PR_ORIGINAL_SENDER_NAME                      = 
   (PT_TSTRING) or (($005A) shl 16);
const PR_ORIGINAL_SENDER_NAME_W                    = 
   (PT_UNICODE) or (($005A) shl 16);
const PR_ORIGINAL_SENDER_NAME_A                    = 
   (PT_STRING8) or (($005A) shl 16);
const PR_ORIGINAL_SENDER_ENTRYID                   =
   (PT_BINARY) or (($005B) shl 16);
const PR_ORIGINAL_SENDER_SEARCH_KEY                = 
   (PT_BINARY) or (($005C) shl 16);
const PR_ORIGINAL_SENT_REPRESENTING_NAME           =
   (PT_TSTRING) or (($005D) shl 16);
const PR_ORIGINAL_SENT_REPRESENTING_NAME_W         = 
   (PT_UNICODE) or (($005D) shl 16);
const PR_ORIGINAL_SENT_REPRESENTING_NAME_A         = 
   (PT_STRING8) or (($005D) shl 16);
const PR_ORIGINAL_SENT_REPRESENTING_ENTRYID        =
   (PT_BINARY) or (($005E) shl 16);
const PR_ORIGINAL_SENT_REPRESENTING_SEARCH_KEY     = 
   (PT_BINARY) or (($005F) shl 16);

const PR_START_DATE                                = 
   (PT_SYSTIME) or (($0060) shl 16);
const PR_END_DATE                                  = 
   (PT_SYSTIME) or (($0061) shl 16);
const PR_OWNER_APPT_ID                             = 
   (PT_LONG) or (($0062) shl 16);
const PR_RESPONSE_REQUESTED                        = 
   (PT_BOOLEAN) or (($0063) shl 16);

const PR_SENT_REPRESENTING_ADDRTYPE                = 
   (PT_TSTRING) or (($0064) shl 16);
const PR_SENT_REPRESENTING_ADDRTYPE_W              = 
   (PT_UNICODE) or (($0064) shl 16);
const PR_SENT_REPRESENTING_ADDRTYPE_A              = 
   (PT_STRING8) or (($0064) shl 16);
const PR_SENT_REPRESENTING_EMAIL_ADDRESS           = 
   (PT_TSTRING) or (($0065) shl 16);
const PR_SENT_REPRESENTING_EMAIL_ADDRESS_W         =
   (PT_UNICODE) or (($0065) shl 16);
const PR_SENT_REPRESENTING_EMAIL_ADDRESS_A         =
   (PT_STRING8) or (($0065) shl 16);

const PR_ORIGINAL_SENDER_ADDRTYPE                  = 
   (PT_TSTRING) or (($0066) shl 16);
const PR_ORIGINAL_SENDER_ADDRTYPE_W                = 
   (PT_UNICODE) or (($0066) shl 16);
const PR_ORIGINAL_SENDER_ADDRTYPE_A                = 
   (PT_STRING8) or (($0066) shl 16);
const PR_ORIGINAL_SENDER_EMAIL_ADDRESS             = 
   (PT_TSTRING) or (($0067) shl 16);
const PR_ORIGINAL_SENDER_EMAIL_ADDRESS_W           = 
   (PT_UNICODE) or (($0067) shl 16);
const PR_ORIGINAL_SENDER_EMAIL_ADDRESS_A           = 
   (PT_STRING8) or (($0067) shl 16);

const PR_ORIGINAL_SENT_REPRESENTING_ADDRTYPE       = 
   (PT_TSTRING) or (($0068) shl 16);
const PR_ORIGINAL_SENT_REPRESENTING_ADDRTYPE_W     = 
   (PT_UNICODE) or (($0068) shl 16);
const PR_ORIGINAL_SENT_REPRESENTING_ADDRTYPE_A     = 
   (PT_STRING8) or (($0068) shl 16);
const PR_ORIGINAL_SENT_REPRESENTING_EMAIL_ADDRESS  = 
   (PT_TSTRING) or (($0069) shl 16);
const PR_ORIGINAL_SENT_REPRESENTING_EMAIL_ADDRESS_W    =
   (PT_UNICODE) or (($0069) shl 16);
const PR_ORIGINAL_SENT_REPRESENTING_EMAIL_ADDRESS_A    = 
   (PT_STRING8) or (($0069) shl 16);

const PR_CONVERSATION_TOPIC                        = 
   (PT_TSTRING) or (($0070) shl 16);
const PR_CONVERSATION_TOPIC_W                      = 
   (PT_UNICODE) or (($0070) shl 16);
const PR_CONVERSATION_TOPIC_A                      =
   (PT_STRING8) or (($0070) shl 16);
const PR_CONVERSATION_INDEX                        = 
   (PT_BINARY) or (($0071) shl 16);

const PR_ORIGINAL_DISPLAY_BCC                      = 
   (PT_TSTRING) or (($0072) shl 16);
const PR_ORIGINAL_DISPLAY_BCC_W                    = 
   (PT_UNICODE) or (($0072) shl 16);
const PR_ORIGINAL_DISPLAY_BCC_A                    = 
   (PT_STRING8) or (($0072) shl 16);
const PR_ORIGINAL_DISPLAY_CC                       = 
   (PT_TSTRING) or (($0073) shl 16);
const PR_ORIGINAL_DISPLAY_CC_W                     = 
   (PT_UNICODE) or (($0073) shl 16);
const PR_ORIGINAL_DISPLAY_CC_A                     =
   (PT_STRING8) or (($0073) shl 16);
const PR_ORIGINAL_DISPLAY_TO                       = 
   (PT_TSTRING) or (($0074) shl 16);
const PR_ORIGINAL_DISPLAY_TO_W                     =
   (PT_UNICODE) or (($0074) shl 16);
const PR_ORIGINAL_DISPLAY_TO_A                     = 
   (PT_STRING8) or (($0074) shl 16);

const PR_RECEIVED_BY_ADDRTYPE                      = 
   (PT_TSTRING) or (($0075) shl 16);
const PR_RECEIVED_BY_ADDRTYPE_W                    = 
   (PT_UNICODE) or (($0075) shl 16);
const PR_RECEIVED_BY_ADDRTYPE_A                    = 
   (PT_STRING8) or (($0075) shl 16);
const PR_RECEIVED_BY_EMAIL_ADDRESS                 = 
   (PT_TSTRING) or (($0076) shl 16);
const PR_RECEIVED_BY_EMAIL_ADDRESS_W               = 
   (PT_UNICODE) or (($0076) shl 16);
const PR_RECEIVED_BY_EMAIL_ADDRESS_A               = 
   (PT_STRING8) or (($0076) shl 16);

const PR_RCVD_REPRESENTING_ADDRTYPE                = 
   (PT_TSTRING) or (($0077) shl 16);
const PR_RCVD_REPRESENTING_ADDRTYPE_W              =
   (PT_UNICODE) or (($0077) shl 16);
const PR_RCVD_REPRESENTING_ADDRTYPE_A              = 
   (PT_STRING8) or (($0077) shl 16);
const PR_RCVD_REPRESENTING_EMAIL_ADDRESS           =
   (PT_TSTRING) or (($0078) shl 16);
const PR_RCVD_REPRESENTING_EMAIL_ADDRESS_W         = 
   (PT_UNICODE) or (($0078) shl 16);
const PR_RCVD_REPRESENTING_EMAIL_ADDRESS_A         = 
   (PT_STRING8) or (($0078) shl 16);

const PR_ORIGINAL_AUTHOR_ADDRTYPE                  = 
   (PT_TSTRING) or (($0079) shl 16);
const PR_ORIGINAL_AUTHOR_ADDRTYPE_W                = 
   (PT_UNICODE) or (($0079) shl 16);
const PR_ORIGINAL_AUTHOR_ADDRTYPE_A                = 
   (PT_STRING8) or (($0079) shl 16);
const PR_ORIGINAL_AUTHOR_EMAIL_ADDRESS             = 
   (PT_TSTRING) or (($007A) shl 16);
const PR_ORIGINAL_AUTHOR_EMAIL_ADDRESS_W           = 
   (PT_UNICODE) or (($007A) shl 16);
const PR_ORIGINAL_AUTHOR_EMAIL_ADDRESS_A           = 
   (PT_STRING8) or (($007A) shl 16);

const PR_ORIGINALLY_INTENDED_RECIP_ADDRTYPE        =
   (PT_TSTRING) or (($007B) shl 16);
const PR_ORIGINALLY_INTENDED_RECIP_ADDRTYPE_W      =
   (PT_UNICODE) or (($007B) shl 16);
const PR_ORIGINALLY_INTENDED_RECIP_ADDRTYPE_A      =
   (PT_STRING8) or (($007B) shl 16);
const PR_ORIGINALLY_INTENDED_RECIP_EMAIL_ADDRESS   = 
   (PT_TSTRING) or (($007C) shl 16);
const PR_ORIGINALLY_INTENDED_RECIP_EMAIL_ADDRESS_W     = 
   (PT_UNICODE) or (($007C) shl 16);
const PR_ORIGINALLY_INTENDED_RECIP_EMAIL_ADDRESS_A     = 
   (PT_STRING8) or (($007C) shl 16);

const PR_TRANSPORT_MESSAGE_HEADERS                 = 
  (PT_TSTRING) or (($007D) shl 16);
const PR_TRANSPORT_MESSAGE_HEADERS_W               = 
  (PT_UNICODE) or (($007D) shl 16);
const PR_TRANSPORT_MESSAGE_HEADERS_A               = 
  (PT_STRING8) or (($007D) shl 16);

const PR_DELEGATION                                = 
  (PT_BINARY) or (($007E) shl 16);

const PR_TNEF_CORRELATION_KEY                      = 
  (PT_BINARY) or (($007F) shl 16);



(*
 *  Message content properties
 *)

const PR_BODY                                      = 
   (PT_TSTRING) or (($1000) shl 16);
const PR_BODY_W                                    = 
   (PT_UNICODE) or (($1000) shl 16);
const PR_BODY_A                                    = 
   (PT_STRING8) or (($1000) shl 16);
const PR_REPORT_TEXT                               = 
   (PT_TSTRING) or (($1001) shl 16);
const PR_REPORT_TEXT_W                             = 
   (PT_UNICODE) or (($1001) shl 16);
const PR_REPORT_TEXT_A                             = 
   (PT_STRING8) or (($1001) shl 16);
const PR_ORIGINATOR_AND_DL_EXPANSION_HISTORY       = 
   (PT_BINARY) or (($1002) shl 16);
const PR_REPORTING_DL_NAME                         = 
   (PT_BINARY) or (($1003) shl 16);
const PR_REPORTING_MTA_CERTIFICATE                 =
   (PT_BINARY) or (($1004) shl 16);

{  Removed PR_REPORT_ORIGIN_AUTHENTICATION_CHECK with DCR 3865, use PR_ORIGIN_CHECK }

const PR_RTF_SYNC_BODY_CRC                         = 
   (PT_LONG) or (($1006) shl 16);
const PR_RTF_SYNC_BODY_COUNT                       = 
   (PT_LONG) or (($1007) shl 16);
const PR_RTF_SYNC_BODY_TAG                         = 
   (PT_TSTRING) or (($1008) shl 16);
const PR_RTF_SYNC_BODY_TAG_W                       = 
   (PT_UNICODE) or (($1008) shl 16);
const PR_RTF_SYNC_BODY_TAG_A                       = 
   (PT_STRING8) or (($1008) shl 16);
const PR_RTF_COMPRESSED                            = 
   (PT_BINARY) or (($1009) shl 16);
const PR_RTF_SYNC_PREFIX_COUNT                     = 
   (PT_LONG) or (($1010) shl 16);
const PR_RTF_SYNC_TRAILING_COUNT                   = 
   (PT_LONG) or (($1011) shl 16);
const PR_ORIGINALLY_INTENDED_RECIP_ENTRYID         = 
   (PT_BINARY) or (($1012) shl 16);

(*
 *  Reserved 0x1100-0x1200
 *)


(*
 *  Message recipient properties
 *)

const PR_CONTENT_INTEGRITY_CHECK                   = 
   (PT_BINARY) or (($0C00) shl 16);
const PR_EXPLICIT_CONVERSION                       = 
   (PT_LONG) or (($0C01) shl 16);
const PR_IPM_RETURN_REQUESTED                      = 
   (PT_BOOLEAN) or (($0C02) shl 16);
const PR_MESSAGE_TOKEN                             = 
   (PT_BINARY) or (($0C03) shl 16);
const PR_NDR_REASON_CODE                           = 
   (PT_LONG) or (($0C04) shl 16);
const PR_NDR_DIAG_CODE                             = 
   (PT_LONG) or (($0C05) shl 16);
const PR_NON_RECEIPT_NOTIFICATION_REQUESTED        = 
   (PT_BOOLEAN) or (($0C06) shl 16);
const PR_DELIVERY_POINT                            = 
   (PT_LONG) or (($0C07) shl 16);

const PR_ORIGINATOR_NON_DELIVERY_REPORT_REQUESTED  = 
   (PT_BOOLEAN) or (($0C08) shl 16);
const PR_ORIGINATOR_REQUESTED_ALTERNATE_RECIPIENT  =
   (PT_BINARY) or (($0C09) shl 16);
const PR_PHYSICAL_DELIVERY_BUREAU_FAX_DELIVERY     = 
   (PT_BOOLEAN) or (($0C0A) shl 16);
const PR_PHYSICAL_DELIVERY_MODE                    = 
   (PT_LONG) or (($0C0B) shl 16);
const PR_PHYSICAL_DELIVERY_REPORT_REQUEST          = 
   (PT_LONG) or (($0C0C) shl 16);
const PR_PHYSICAL_FORWARDING_ADDRESS               = 
   (PT_BINARY) or (($0C0D) shl 16);
const PR_PHYSICAL_FORWARDING_ADDRESS_REQUESTED     = 
   (PT_BOOLEAN) or (($0C0E) shl 16);
const PR_PHYSICAL_FORWARDING_PROHIBITED            = 
   (PT_BOOLEAN) or (($0C0F) shl 16);
const PR_PHYSICAL_RENDITION_ATTRIBUTES             = 
   (PT_BINARY) or (($0C10) shl 16);
const PR_PROOF_OF_DELIVERY                         = 
   (PT_BINARY) or (($0C11) shl 16);
const PR_PROOF_OF_DELIVERY_REQUESTED               = 
   (PT_BOOLEAN) or (($0C12) shl 16);
const PR_RECIPIENT_CERTIFICATE                     =
   (PT_BINARY) or (($0C13) shl 16);
const PR_RECIPIENT_NUMBER_FOR_ADVICE               = 
   (PT_TSTRING) or (($0C14) shl 16);
const PR_RECIPIENT_NUMBER_FOR_ADVICE_W             =
   (PT_UNICODE) or (($0C14) shl 16);
const PR_RECIPIENT_NUMBER_FOR_ADVICE_A             = 
   (PT_STRING8) or (($0C14) shl 16);
const PR_RECIPIENT_TYPE                            = 
   (PT_LONG) or (($0C15) shl 16);
const PR_REGISTERED_MAIL_TYPE                      = 
   (PT_LONG) or (($0C16) shl 16);
const PR_REPLY_REQUESTED                           = 
   (PT_BOOLEAN) or (($0C17) shl 16);
const PR_REQUESTED_DELIVERY_METHOD                 = 
   (PT_LONG) or (($0C18) shl 16);
const PR_SENDER_ENTRYID                            = 
   (PT_BINARY) or (($0C19) shl 16);
const PR_SENDER_NAME                               =
   (PT_TSTRING) or (($0C1A) shl 16);
const PR_SENDER_NAME_W                             = 
   (PT_UNICODE) or (($0C1A) shl 16);
const PR_SENDER_NAME_A                             = 
   (PT_STRING8) or (($0C1A) shl 16);
const PR_SUPPLEMENTARY_INFO                        =
   (PT_TSTRING) or (($0C1B) shl 16);
const PR_SUPPLEMENTARY_INFO_W                      =
   (PT_UNICODE) or (($0C1B) shl 16);
const PR_SUPPLEMENTARY_INFO_A                      =
   (PT_STRING8) or (($0C1B) shl 16);
const PR_TYPE_OF_MTS_USER                          = 
   (PT_LONG) or (($0C1C) shl 16);
const PR_SENDER_SEARCH_KEY                         = 
   (PT_BINARY) or (($0C1D) shl 16);
const PR_SENDER_ADDRTYPE                           = 
   (PT_TSTRING) or (($0C1E) shl 16);
const PR_SENDER_ADDRTYPE_W                         = 
   (PT_UNICODE) or (($0C1E) shl 16);
const PR_SENDER_ADDRTYPE_A                         = 
   (PT_STRING8) or (($0C1E) shl 16);
const PR_SENDER_EMAIL_ADDRESS                      = 
   (PT_TSTRING) or (($0C1F) shl 16);
const PR_SENDER_EMAIL_ADDRESS_W                    = 
   (PT_UNICODE) or (($0C1F) shl 16);
const PR_SENDER_EMAIL_ADDRESS_A                    = 
   (PT_STRING8) or (($0C1F) shl 16);

(*
 *  Message non-transmittable properties
 *)

(*
 * The two tags, PR_MESSAGE_RECIPIENTS and PR_MESSAGE_ATTACHMENTS,
 * are to be used in the exclude list passed to
 * IMessage::CopyTo when the caller wants either the recipients or attachments
 * of the message to not get copied.  It is also used in the ProblemArray
 * return from IMessage::CopyTo when an error is encountered copying them
 *)

const PR_CURRENT_VERSION                           = 
   (PT_I8) or (($0E00) shl 16);
const PR_DELETE_AFTER_SUBMIT                       = 
   (PT_BOOLEAN) or (($0E01) shl 16);
const PR_DISPLAY_BCC                               = 
   (PT_TSTRING) or (($0E02) shl 16);
const PR_DISPLAY_BCC_W                             = 
   (PT_UNICODE) or (($0E02) shl 16);
const PR_DISPLAY_BCC_A                             = 
   (PT_STRING8) or (($0E02) shl 16);
const PR_DISPLAY_CC                                = 
   (PT_TSTRING) or (($0E03) shl 16);
const PR_DISPLAY_CC_W                              = 
   (PT_UNICODE) or (($0E03) shl 16);
const PR_DISPLAY_CC_A                              = 
   (PT_STRING8) or (($0E03) shl 16);
const PR_DISPLAY_TO                                = 
   (PT_TSTRING) or (($0E04) shl 16);
const PR_DISPLAY_TO_W                              = 
   (PT_UNICODE) or (($0E04) shl 16);
const PR_DISPLAY_TO_A                              = 
   (PT_STRING8) or (($0E04) shl 16);
const PR_PARENT_DISPLAY                            = 
   (PT_TSTRING) or (($0E05) shl 16);
const PR_PARENT_DISPLAY_W                          = 
   (PT_UNICODE) or (($0E05) shl 16);
const PR_PARENT_DISPLAY_A                          = 
   (PT_STRING8) or (($0E05) shl 16);
const PR_MESSAGE_DELIVERY_TIME                     = 
   (PT_SYSTIME) or (($0E06) shl 16);
const PR_MESSAGE_FLAGS                             = 
   (PT_LONG) or (($0E07) shl 16);
const PR_MESSAGE_SIZE                              = 
   (PT_LONG) or (($0E08) shl 16);
const PR_PARENT_ENTRYID                            = 
   (PT_BINARY) or (($0E09) shl 16);
const PR_SENTMAIL_ENTRYID                          =
   (PT_BINARY) or (($0E0A) shl 16);
const PR_CORRELATE                                 = 
   (PT_BOOLEAN) or (($0E0C) shl 16);
const PR_CORRELATE_MTSID                           = 
   (PT_BINARY) or (($0E0D) shl 16);
const PR_DISCRETE_VALUES                           = 
   (PT_BOOLEAN) or (($0E0E) shl 16);
const PR_RESPONSIBILITY                            = 
   (PT_BOOLEAN) or (($0E0F) shl 16);
const PR_SPOOLER_STATUS                            = 
   (PT_LONG) or (($0E10) shl 16);
const PR_TRANSPORT_STATUS                          = 
   (PT_LONG) or (($0E11) shl 16);
const PR_MESSAGE_RECIPIENTS                        = 
   (PT_OBJECT) or (($0E12) shl 16);
const PR_MESSAGE_ATTACHMENTS                       = 
   (PT_OBJECT) or (($0E13) shl 16);
const PR_SUBMIT_FLAGS                              = 
   (PT_LONG) or (($0E14) shl 16);
const PR_RECIPIENT_STATUS                          = 
   (PT_LONG) or (($0E15) shl 16);
const PR_TRANSPORT_KEY                             = 
   (PT_LONG) or (($0E16) shl 16);
const PR_MSG_STATUS                                = 
   (PT_LONG) or (($0E17) shl 16);
const PR_MESSAGE_DOWNLOAD_TIME                     = 
   (PT_LONG) or (($0E18) shl 16);
const PR_CREATION_VERSION                          = 
   (PT_I8) or (($0E19) shl 16);
const PR_MODIFY_VERSION                            = 
   (PT_I8) or (($0E1A) shl 16);
const PR_HASATTACH                                 =
   (PT_BOOLEAN) or (($0E1B) shl 16);
const PR_BODY_CRC                                  = 
   (PT_LONG) or (($0E1C) shl 16);
const PR_NORMALIZED_SUBJECT                        = 
   (PT_TSTRING) or (($0E1D) shl 16);
const PR_NORMALIZED_SUBJECT_W                      = 
   (PT_UNICODE) or (($0E1D) shl 16);
const PR_NORMALIZED_SUBJECT_A                      = 
   (PT_STRING8) or (($0E1D) shl 16);
const PR_RTF_IN_SYNC                               = 
   (PT_BOOLEAN) or (($0E1F) shl 16);
const PR_ATTACH_SIZE                               = 
   (PT_LONG) or (($0E20) shl 16);
const PR_ATTACH_NUM                                = 
   (PT_LONG) or (($0E21) shl 16);
const PR_PREPROCESS                                = 
   (PT_BOOLEAN) or (($0E22) shl 16);

{ PR_ORIGINAL_DISPLAY_TO, _CC, and _BCC moved to transmittible range 03/09/95 }

const PR_ORIGINATING_MTA_CERTIFICATE               =
   (PT_BINARY) or (($0E25) shl 16);
const PR_PROOF_OF_SUBMISSION                       = 
   (PT_BINARY) or (($0E26) shl 16);


(*
 * The range of non-message and non-recipient property IDs (0x3000 - 0x3FFF) is
 * further broken down into ranges to make assigning new property IDs easier.
 *
 *  From    To      Kind of property
 *  --------------------------------
 *  3000    32FF    MAPI_defined common property
 *  3200    33FF    MAPI_defined form property
 *  3400    35FF    MAPI_defined message store property
 *  3600    36FF    MAPI_defined Folder or AB Container property
 *  3700    38FF    MAPI_defined attachment property
 *  3900    39FF    MAPI_defined address book property
 *  3A00    3BFF    MAPI_defined mailuser property
 *  3C00    3CFF    MAPI_defined DistList property
 *  3D00    3DFF    MAPI_defined Profile Section property
 *  3E00    3EFF    MAPI_defined Status property
 *  3F00    3FFF    MAPI_defined display table property
 *)

(*
 *  Properties common to numerous MAPI objects.
 *
 *  Those properties that can appear on messages are in the
 *  non-transmittable range for messages. They start at the high
 *  end of that range and work down.
 *
 *  Properties that never appear on messages are defined in the common
 *  property range (see above).
 *)

(*
 * properties that are common to multiple objects (including message objects)
 * -- these ids are in the non-transmittable range
 *)

const PR_ENTRYID                                   = 
   (PT_BINARY) or (($0FFF) shl 16);
const PR_OBJECT_TYPE                               = 
   (PT_LONG) or (($0FFE) shl 16);
const PR_ICON                                      = 
   (PT_BINARY) or (($0FFD) shl 16);
const PR_MINI_ICON                                 = 
   (PT_BINARY) or (($0FFC) shl 16);
const PR_STORE_ENTRYID                             = 
   (PT_BINARY) or (($0FFB) shl 16);
const PR_STORE_RECORD_KEY                          = 
   (PT_BINARY) or (($0FFA) shl 16);
const PR_RECORD_KEY                                = 
   (PT_BINARY) or (($0FF9) shl 16);
const PR_MAPPING_SIGNATURE                         = 
   (PT_BINARY) or (($0FF8) shl 16);
const PR_ACCESS_LEVEL                              = 
   (PT_LONG) or (($0FF7) shl 16);
const PR_INSTANCE_KEY                              = 
   (PT_BINARY) or (($0FF6) shl 16);
const PR_ROW_TYPE                                  = 
   (PT_LONG) or (($0FF5) shl 16);
const PR_ACCESS                                    = 
   (PT_LONG) or (($0FF4) shl 16);

(*
 * properties that are common to multiple objects (usually not including message objects)
 * -- these ids are in the transmittable range
 *)

const PR_ROWID                                     = 
   (PT_LONG) or (($3000) shl 16);
const PR_DISPLAY_NAME                              = 
   (PT_TSTRING) or (($3001) shl 16);
const PR_DISPLAY_NAME_W                            = 
   (PT_UNICODE) or (($3001) shl 16);
const PR_DISPLAY_NAME_A                            = 
   (PT_STRING8) or (($3001) shl 16);
const PR_ADDRTYPE                                  =
   (PT_TSTRING) or (($3002) shl 16);
const PR_ADDRTYPE_W                                = 
   (PT_UNICODE) or (($3002) shl 16);
const PR_ADDRTYPE_A                                = 
   (PT_STRING8) or (($3002) shl 16);
const PR_EMAIL_ADDRESS                             =
   (PT_TSTRING) or (($3003) shl 16);
const PR_EMAIL_ADDRESS_W                           = 
   (PT_UNICODE) or (($3003) shl 16);
const PR_EMAIL_ADDRESS_A                           = 
   (PT_STRING8) or (($3003) shl 16);
const PR_COMMENT                                   = 
   (PT_TSTRING) or (($3004) shl 16);
const PR_COMMENT_W                                 = 
   (PT_UNICODE) or (($3004) shl 16);
const PR_COMMENT_A                                 = 
   (PT_STRING8) or (($3004) shl 16);
const PR_DEPTH                                     = 
   (PT_LONG) or (($3005) shl 16);
const PR_PROVIDER_DISPLAY                          = 
   (PT_TSTRING) or (($3006) shl 16);
const PR_PROVIDER_DISPLAY_W                        = 
   (PT_UNICODE) or (($3006) shl 16);
const PR_PROVIDER_DISPLAY_A                        = 
   (PT_STRING8) or (($3006) shl 16);
const PR_CREATION_TIME                             = 
   (PT_SYSTIME) or (($3007) shl 16);
const PR_LAST_MODIFICATION_TIME                    =
   (PT_SYSTIME) or (($3008) shl 16);
const PR_RESOURCE_FLAGS                            = 
   (PT_LONG) or (($3009) shl 16);
const PR_PROVIDER_DLL_NAME                         = 
   (PT_TSTRING) or (($300A) shl 16);
const PR_PROVIDER_DLL_NAME_W                       =
   (PT_UNICODE) or (($300A) shl 16);
const PR_PROVIDER_DLL_NAME_A                       =
   (PT_STRING8) or (($300A) shl 16);
const PR_SEARCH_KEY                                =
   (PT_BINARY) or (($300B) shl 16);
const PR_PROVIDER_UID                              =
   (PT_BINARY) or (($300C) shl 16);
const PR_PROVIDER_ORDINAL                          = 
   (PT_LONG) or (($300D) shl 16);

(*
 *  MAPI Form properties
 *)
const PR_FORM_VERSION                              = 
  (PT_TSTRING) or (($3301) shl 16);
const PR_FORM_VERSION_W                            = 
  (PT_UNICODE) or (($3301) shl 16);
const PR_FORM_VERSION_A                            = 
  (PT_STRING8) or (($3301) shl 16);
const PR_FORM_CLSID                                = 
  (PT_CLSID) or (($3302) shl 16);
const PR_FORM_CONTACT_NAME                         = 
  (PT_TSTRING) or (($3303) shl 16);
const PR_FORM_CONTACT_NAME_W                       = 
  (PT_UNICODE) or (($3303) shl 16);
const PR_FORM_CONTACT_NAME_A                       = 
  (PT_STRING8) or (($3303) shl 16);
const PR_FORM_CATEGORY                             = 
  (PT_TSTRING) or (($3304) shl 16);
const PR_FORM_CATEGORY_W                           = 
  (PT_UNICODE) or (($3304) shl 16);
const PR_FORM_CATEGORY_A                           = 
  (PT_STRING8) or (($3304) shl 16);
const PR_FORM_CATEGORY_SUB                         = 
  (PT_TSTRING) or (($3305) shl 16);
const PR_FORM_CATEGORY_SUB_W                       = 
  (PT_UNICODE) or (($3305) shl 16);
const PR_FORM_CATEGORY_SUB_A                       = 
  (PT_STRING8) or (($3305) shl 16);
const PR_FORM_HOST_MAP                             =
  (PT_MV_LONG) or (($3306) shl 16);
const PR_FORM_HIDDEN                               = 
  (PT_BOOLEAN) or (($3307) shl 16);
const PR_FORM_DESIGNER_NAME                        = 
  (PT_TSTRING) or (($3308) shl 16);
const PR_FORM_DESIGNER_NAME_W                      = 
  (PT_UNICODE) or (($3308) shl 16);
const PR_FORM_DESIGNER_NAME_A                      = 
  (PT_STRING8) or (($3308) shl 16);
const PR_FORM_DESIGNER_GUID                        = 
  (PT_CLSID) or (($3309) shl 16);
const PR_FORM_MESSAGE_BEHAVIOR                     = 
  (PT_LONG) or (($330A) shl 16);

(*
 *  Message store properties
 *)

const PR_DEFAULT_STORE                             = 
   (PT_BOOLEAN) or (($3400) shl 16);
const PR_STORE_SUPPORT_MASK                        = 
   (PT_LONG) or (($340D) shl 16);
const PR_STORE_STATE                               = 
   (PT_LONG) or (($340E) shl 16);

const PR_IPM_SUBTREE_SEARCH_KEY                    = 
   (PT_BINARY) or (($3410) shl 16);
const PR_IPM_OUTBOX_SEARCH_KEY                     = 
   (PT_BINARY) or (($3411) shl 16);
const PR_IPM_WASTEBASKET_SEARCH_KEY                = 
   (PT_BINARY) or (($3412) shl 16);
const PR_IPM_SENTMAIL_SEARCH_KEY                   = 
   (PT_BINARY) or (($3413) shl 16);
const PR_MDB_PROVIDER                              = 
   (PT_BINARY) or (($3414) shl 16);
const PR_RECEIVE_FOLDER_SETTINGS                   = 
   (PT_OBJECT) or (($3415) shl 16);

const PR_VALID_FOLDER_MASK                         =
   (PT_LONG) or (($35DF) shl 16);
const PR_IPM_SUBTREE_ENTRYID                       = 
   (PT_BINARY) or (($35E0) shl 16);

const PR_IPM_OUTBOX_ENTRYID                        = 
   (PT_BINARY) or (($35E2) shl 16);
const PR_IPM_WASTEBASKET_ENTRYID                   = 
   (PT_BINARY) or (($35E3) shl 16);
const PR_IPM_SENTMAIL_ENTRYID                      = 
   (PT_BINARY) or (($35E4) shl 16);
const PR_VIEWS_ENTRYID                             = 
   (PT_BINARY) or (($35E5) shl 16);
const PR_COMMON_VIEWS_ENTRYID                      = 
   (PT_BINARY) or (($35E6) shl 16);
const PR_FINDER_ENTRYID                            = 
   (PT_BINARY) or (($35E7) shl 16);

{ Proptags 0x35E8-0x35FF reserved for folders "guaranteed" by PR_VALID_FOLDER_MASK }


(*
 *  Folder and AB Container properties
 *)

const PR_CONTAINER_FLAGS                           = 
   (PT_LONG) or (($3600) shl 16);
const PR_FOLDER_TYPE                               =
   (PT_LONG) or (($3601) shl 16);
const PR_CONTENT_COUNT                             = 
   (PT_LONG) or (($3602) shl 16);
const PR_CONTENT_UNREAD                            = 
   (PT_LONG) or (($3603) shl 16);
const PR_CREATE_TEMPLATES                          = 
   (PT_OBJECT) or (($3604) shl 16);
const PR_DETAILS_TABLE                             = 
   (PT_OBJECT) or (($3605) shl 16);
const PR_SEARCH                                    = 
   (PT_OBJECT) or (($3607) shl 16);
const PR_SELECTABLE                                = 
   (PT_BOOLEAN) or (($3609) shl 16);
const PR_SUBFOLDERS                                = 
   (PT_BOOLEAN) or (($360A) shl 16);
const PR_STATUS                                    =
   (PT_LONG) or (($360B) shl 16);
const PR_ANR                                       =
   (PT_TSTRING) or (($360C) shl 16);
const PR_ANR_W                                     = 
   (PT_UNICODE) or (($360C) shl 16);
const PR_ANR_A                                     = 
   (PT_STRING8) or (($360C) shl 16);
const PR_CONTENTS_SORT_ORDER                       = 
   (PT_MV_LONG) or (($360D) shl 16);
const PR_CONTAINER_HIERARCHY                       = 
   (PT_OBJECT) or (($360E) shl 16);
const PR_CONTAINER_CONTENTS                        = 
   (PT_OBJECT) or (($360F) shl 16);
const PR_FOLDER_ASSOCIATED_CONTENTS                = 
   (PT_OBJECT) or (($3610) shl 16);
const PR_DEF_CREATE_DL                             = 
   (PT_BINARY) or (($3611) shl 16);
const PR_DEF_CREATE_MAILUSER                       = 
   (PT_BINARY) or (($3612) shl 16);
const PR_CONTAINER_CLASS                           = 
   (PT_TSTRING) or (($3613) shl 16);
const PR_CONTAINER_CLASS_W                         = 
   (PT_UNICODE) or (($3613) shl 16);
const PR_CONTAINER_CLASS_A                         = 
   (PT_STRING8) or (($3613) shl 16);
const PR_CONTAINER_MODIFY_VERSION                  = 
   (PT_I8) or (($3614) shl 16);
const PR_AB_PROVIDER_ID                            = 
   (PT_BINARY) or (($3615) shl 16);
const PR_DEFAULT_VIEW_ENTRYID                      = 
   (PT_BINARY) or (($3616) shl 16);
const PR_ASSOC_CONTENT_COUNT                       = 
   (PT_LONG) or (($3617) shl 16);

{ Reserved 0x36C0-0x36FF }

(*
 *  Attachment properties
 *)

const PR_ATTACHMENT_X400_PARAMETERS                = 
   (PT_BINARY) or (($3700) shl 16);
const PR_ATTACH_DATA_OBJ                           = 
   (PT_OBJECT) or (($3701) shl 16);
const PR_ATTACH_DATA_BIN                           = 
   (PT_BINARY) or (($3701) shl 16);
const PR_ATTACH_ENCODING                           = 
   (PT_BINARY) or (($3702) shl 16);
const PR_ATTACH_EXTENSION                          = 
   (PT_TSTRING) or (($3703) shl 16);
const PR_ATTACH_EXTENSION_W                        = 
   (PT_UNICODE) or (($3703) shl 16);
const PR_ATTACH_EXTENSION_A                        =
   (PT_STRING8) or (($3703) shl 16);
const PR_ATTACH_FILENAME                           = 
   (PT_TSTRING) or (($3704) shl 16);
const PR_ATTACH_FILENAME_W                         = 
   (PT_UNICODE) or (($3704) shl 16);
const PR_ATTACH_FILENAME_A                         = 
   (PT_STRING8) or (($3704) shl 16);
const PR_ATTACH_METHOD                             = 
   (PT_LONG) or (($3705) shl 16);
const PR_ATTACH_LONG_FILENAME                      = 
   (PT_TSTRING) or (($3707) shl 16);
const PR_ATTACH_LONG_FILENAME_W                    = 
   (PT_UNICODE) or (($3707) shl 16);
const PR_ATTACH_LONG_FILENAME_A                    =
   (PT_STRING8) or (($3707) shl 16);
const PR_ATTACH_PATHNAME                           = 
   (PT_TSTRING) or (($3708) shl 16);
const PR_ATTACH_PATHNAME_W                         = 
   (PT_UNICODE) or (($3708) shl 16);
const PR_ATTACH_PATHNAME_A                         = 
   (PT_STRING8) or (($3708) shl 16);
const PR_ATTACH_RENDERING                          = 
   (PT_BINARY) or (($3709) shl 16);
const PR_ATTACH_TAG                                =
   (PT_BINARY) or (($370A) shl 16);
const PR_RENDERING_POSITION                        = 
   (PT_LONG) or (($370B) shl 16);
const PR_ATTACH_TRANSPORT_NAME                     = 
   (PT_TSTRING) or (($370C) shl 16);
const PR_ATTACH_TRANSPORT_NAME_W                   = 
   (PT_UNICODE) or (($370C) shl 16);
const PR_ATTACH_TRANSPORT_NAME_A                   = 
   (PT_STRING8) or (($370C) shl 16);
const PR_ATTACH_LONG_PATHNAME                      = 
   (PT_TSTRING) or (($370D) shl 16);
const PR_ATTACH_LONG_PATHNAME_W                    = 
   (PT_UNICODE) or (($370D) shl 16);
const PR_ATTACH_LONG_PATHNAME_A                    = 
   (PT_STRING8) or (($370D) shl 16);
const PR_ATTACH_MIME_TAG                           = 
   (PT_TSTRING) or (($370E) shl 16);
const PR_ATTACH_MIME_TAG_W                         = 
   (PT_UNICODE) or (($370E) shl 16);
const PR_ATTACH_MIME_TAG_A                         = 
   (PT_STRING8) or (($370E) shl 16);
const PR_ATTACH_ADDITIONAL_INFO                    = 
   (PT_BINARY) or (($370F) shl 16);

(*
 *  AB Object properties
 *)

const PR_DISPLAY_TYPE                              = 
   (PT_LONG) or (($3900) shl 16);
const PR_TEMPLATEID                                = 
   (PT_BINARY) or (($3902) shl 16);
const PR_PRIMARY_CAPABILITY                        = 
   (PT_BINARY) or (($3904) shl 16);


(*
 *  Mail user properties
 *)
const PR_7BIT_DISPLAY_NAME_A                         =
   (PT_STRING8) or (($39FF) shl 16);
const PR_7BIT_DISPLAY_NAME_W                         =
   (PT_UNICODE) or (($39FF) shl 16);
const PR_7BIT_DISPLAY_NAME = PR_7BIT_DISPLAY_NAME_A;
const PR_ACCOUNT                                   = 
   (PT_TSTRING) or (($3A00) shl 16);
const PR_ACCOUNT_W                                 = 
   (PT_UNICODE) or (($3A00) shl 16);
const PR_ACCOUNT_A                                 = 
   (PT_STRING8) or (($3A00) shl 16);
const PR_ALTERNATE_RECIPIENT                       =
   (PT_BINARY) or (($3A01) shl 16);
const PR_CALLBACK_TELEPHONE_NUMBER                 = 
   (PT_TSTRING) or (($3A02) shl 16);
const PR_CALLBACK_TELEPHONE_NUMBER_W               = 
   (PT_UNICODE) or (($3A02) shl 16);
const PR_CALLBACK_TELEPHONE_NUMBER_A               = 
   (PT_STRING8) or (($3A02) shl 16);
const PR_CONVERSION_PROHIBITED                     =
   (PT_BOOLEAN) or (($3A03) shl 16);
const PR_DISCLOSE_RECIPIENTS                       = 
   (PT_BOOLEAN) or (($3A04) shl 16);
const PR_GENERATION                                = 
   (PT_TSTRING) or (($3A05) shl 16);
const PR_GENERATION_W                              = 
   (PT_UNICODE) or (($3A05) shl 16);
const PR_GENERATION_A                              = 
   (PT_STRING8) or (($3A05) shl 16);
const PR_GIVEN_NAME                                = 
   (PT_TSTRING) or (($3A06) shl 16);
const PR_GIVEN_NAME_W                              = 
   (PT_UNICODE) or (($3A06) shl 16);
const PR_GIVEN_NAME_A                              = 
   (PT_STRING8) or (($3A06) shl 16);
const PR_GOVERNMENT_ID_NUMBER                      =
   (PT_TSTRING) or (($3A07) shl 16);
const PR_GOVERNMENT_ID_NUMBER_W                    = 
   (PT_UNICODE) or (($3A07) shl 16);
const PR_GOVERNMENT_ID_NUMBER_A                    = 
   (PT_STRING8) or (($3A07) shl 16);
const PR_BUSINESS_TELEPHONE_NUMBER                 = 
   (PT_TSTRING) or (($3A08) shl 16);
const PR_BUSINESS_TELEPHONE_NUMBER_W               = 
   (PT_UNICODE) or (($3A08) shl 16);
const PR_BUSINESS_TELEPHONE_NUMBER_A               = 
   (PT_STRING8) or (($3A08) shl 16);
const PR_OFFICE_TELEPHONE_NUMBER                   = PR_BUSINESS_TELEPHONE_NUMBER;
const PR_OFFICE_TELEPHONE_NUMBER_W                 = PR_BUSINESS_TELEPHONE_NUMBER_W;
const PR_OFFICE_TELEPHONE_NUMBER_A                 = PR_BUSINESS_TELEPHONE_NUMBER_A;
const PR_HOME_TELEPHONE_NUMBER                     = 
   (PT_TSTRING) or (($3A09) shl 16);
const PR_HOME_TELEPHONE_NUMBER_W                   =
   (PT_UNICODE) or (($3A09) shl 16);
const PR_HOME_TELEPHONE_NUMBER_A                   = 
   (PT_STRING8) or (($3A09) shl 16);
const PR_INITIALS                                  = 
   (PT_TSTRING) or (($3A0A) shl 16);
const PR_INITIALS_W                                = 
   (PT_UNICODE) or (($3A0A) shl 16);
const PR_INITIALS_A                                = 
   (PT_STRING8) or (($3A0A) shl 16);
const PR_KEYWORD                                   = 
   (PT_TSTRING) or (($3A0B) shl 16);
const PR_KEYWORD_W                                 =
   (PT_UNICODE) or (($3A0B) shl 16);
const PR_KEYWORD_A                                 =
   (PT_STRING8) or (($3A0B) shl 16);
const PR_LANGUAGE                                  = 
   (PT_TSTRING) or (($3A0C) shl 16);
const PR_LANGUAGE_W                                = 
   (PT_UNICODE) or (($3A0C) shl 16);
const PR_LANGUAGE_A                                = 
   (PT_STRING8) or (($3A0C) shl 16);
const PR_LOCATION                                  = 
   (PT_TSTRING) or (($3A0D) shl 16);
const PR_LOCATION_W                                = 
   (PT_UNICODE) or (($3A0D) shl 16);
const PR_LOCATION_A                                = 
   (PT_STRING8) or (($3A0D) shl 16);
const PR_MAIL_PERMISSION                           = 
   (PT_BOOLEAN) or (($3A0E) shl 16);
const PR_MHS_COMMON_NAME                           = 
   (PT_TSTRING) or (($3A0F) shl 16);
const PR_MHS_COMMON_NAME_W                         = 
   (PT_UNICODE) or (($3A0F) shl 16);
const PR_MHS_COMMON_NAME_A                         = 
   (PT_STRING8) or (($3A0F) shl 16);
const PR_ORGANIZATIONAL_ID_NUMBER                  = 
   (PT_TSTRING) or (($3A10) shl 16);
const PR_ORGANIZATIONAL_ID_NUMBER_W                = 
   (PT_UNICODE) or (($3A10) shl 16);
const PR_ORGANIZATIONAL_ID_NUMBER_A                = 
   (PT_STRING8) or (($3A10) shl 16);
const PR_SURNAME                                   = 
   (PT_TSTRING) or (($3A11) shl 16);
const PR_SURNAME_W                                 = 
   (PT_UNICODE) or (($3A11) shl 16);
const PR_SURNAME_A                                 = 
   (PT_STRING8) or (($3A11) shl 16);
const PR_ORIGINAL_ENTRYID                          =
   (PT_BINARY) or (($3A12) shl 16);
const PR_ORIGINAL_DISPLAY_NAME                     = 
   (PT_TSTRING) or (($3A13) shl 16);
const PR_ORIGINAL_DISPLAY_NAME_W                   = 
   (PT_UNICODE) or (($3A13) shl 16);
const PR_ORIGINAL_DISPLAY_NAME_A                   = 
   (PT_STRING8) or (($3A13) shl 16);
const PR_ORIGINAL_SEARCH_KEY                       = 
   (PT_BINARY) or (($3A14) shl 16);
const PR_POSTAL_ADDRESS                            = 
   (PT_TSTRING) or (($3A15) shl 16);
const PR_POSTAL_ADDRESS_W                          = 
   (PT_UNICODE) or (($3A15) shl 16);
const PR_POSTAL_ADDRESS_A                          = 
   (PT_STRING8) or (($3A15) shl 16);
const PR_COMPANY_NAME                              = 
   (PT_TSTRING) or (($3A16) shl 16);
const PR_COMPANY_NAME_W                            =
   (PT_UNICODE) or (($3A16) shl 16);
const PR_COMPANY_NAME_A                            = 
   (PT_STRING8) or (($3A16) shl 16);
const PR_TITLE                                     = 
   (PT_TSTRING) or (($3A17) shl 16);
const PR_TITLE_W                                   = 
   (PT_UNICODE) or (($3A17) shl 16);
const PR_TITLE_A                                   = 
   (PT_STRING8) or (($3A17) shl 16);
const PR_DEPARTMENT_NAME                           = 
   (PT_TSTRING) or (($3A18) shl 16);
const PR_DEPARTMENT_NAME_W                         = 
   (PT_UNICODE) or (($3A18) shl 16);
const PR_DEPARTMENT_NAME_A                         = 
   (PT_STRING8) or (($3A18) shl 16);
const PR_OFFICE_LOCATION                           = 
   (PT_TSTRING) or (($3A19) shl 16);
const PR_OFFICE_LOCATION_W                         = 
   (PT_UNICODE) or (($3A19) shl 16);
const PR_OFFICE_LOCATION_A                         = 
   (PT_STRING8) or (($3A19) shl 16);
const PR_PRIMARY_TELEPHONE_NUMBER                  = 
   (PT_TSTRING) or (($3A1A) shl 16);
const PR_PRIMARY_TELEPHONE_NUMBER_W                = 
   (PT_UNICODE) or (($3A1A) shl 16);
const PR_PRIMARY_TELEPHONE_NUMBER_A                = 
   (PT_STRING8) or (($3A1A) shl 16);
const PR_BUSINESS2_TELEPHONE_NUMBER                = 
   (PT_TSTRING) or (($3A1B) shl 16);
const PR_BUSINESS2_TELEPHONE_NUMBER_W              =
   (PT_UNICODE) or (($3A1B) shl 16);
const PR_BUSINESS2_TELEPHONE_NUMBER_A              =
   (PT_STRING8) or (($3A1B) shl 16);
const PR_OFFICE2_TELEPHONE_NUMBER                  = PR_BUSINESS2_TELEPHONE_NUMBER;
const PR_OFFICE2_TELEPHONE_NUMBER_W                = PR_BUSINESS2_TELEPHONE_NUMBER_W;
const PR_OFFICE2_TELEPHONE_NUMBER_A                = PR_BUSINESS2_TELEPHONE_NUMBER_A;
const PR_MOBILE_TELEPHONE_NUMBER                   =
   (PT_TSTRING) or (($3A1C) shl 16);
const PR_MOBILE_TELEPHONE_NUMBER_W                 = 
   (PT_UNICODE) or (($3A1C) shl 16);
const PR_MOBILE_TELEPHONE_NUMBER_A                 = 
   (PT_STRING8) or (($3A1C) shl 16);
const PR_CELLULAR_TELEPHONE_NUMBER                 = PR_MOBILE_TELEPHONE_NUMBER;
const PR_CELLULAR_TELEPHONE_NUMBER_W               = PR_MOBILE_TELEPHONE_NUMBER_W;
const PR_CELLULAR_TELEPHONE_NUMBER_A               = PR_MOBILE_TELEPHONE_NUMBER_A;
const PR_RADIO_TELEPHONE_NUMBER                    = 
   (PT_TSTRING) or (($3A1D) shl 16);
const PR_RADIO_TELEPHONE_NUMBER_W                  =
   (PT_UNICODE) or (($3A1D) shl 16);
const PR_RADIO_TELEPHONE_NUMBER_A                  = 
   (PT_STRING8) or (($3A1D) shl 16);
const PR_CAR_TELEPHONE_NUMBER                      = 
   (PT_TSTRING) or (($3A1E) shl 16);
const PR_CAR_TELEPHONE_NUMBER_W                    = 
   (PT_UNICODE) or (($3A1E) shl 16);
const PR_CAR_TELEPHONE_NUMBER_A                    = 
   (PT_STRING8) or (($3A1E) shl 16);
const PR_OTHER_TELEPHONE_NUMBER                    = 
   (PT_TSTRING) or (($3A1F) shl 16);
const PR_OTHER_TELEPHONE_NUMBER_W                  = 
   (PT_UNICODE) or (($3A1F) shl 16);
const PR_OTHER_TELEPHONE_NUMBER_A                  = 
   (PT_STRING8) or (($3A1F) shl 16);
const PR_TRANSMITABLE_DISPLAY_NAME                 = 
   (PT_TSTRING) or (($3A20) shl 16);
const PR_TRANSMITABLE_DISPLAY_NAME_W               = 
   (PT_UNICODE) or (($3A20) shl 16);
const PR_TRANSMITABLE_DISPLAY_NAME_A               = 
   (PT_STRING8) or (($3A20) shl 16);
const PR_PAGER_TELEPHONE_NUMBER                    = 
   (PT_TSTRING) or (($3A21) shl 16);
const PR_PAGER_TELEPHONE_NUMBER_W                  = 
   (PT_UNICODE) or (($3A21) shl 16);
const PR_PAGER_TELEPHONE_NUMBER_A                  = 
   (PT_STRING8) or (($3A21) shl 16);
const PR_BEEPER_TELEPHONE_NUMBER                   = PR_PAGER_TELEPHONE_NUMBER;
const PR_BEEPER_TELEPHONE_NUMBER_W                 = PR_PAGER_TELEPHONE_NUMBER_W;
const PR_BEEPER_TELEPHONE_NUMBER_A                 = PR_PAGER_TELEPHONE_NUMBER_A;
const PR_USER_CERTIFICATE                          = 
   (PT_BINARY) or (($3A22) shl 16);
const PR_PRIMARY_FAX_NUMBER                        =
   (PT_TSTRING) or (($3A23) shl 16);
const PR_PRIMARY_FAX_NUMBER_W                      = 
   (PT_UNICODE) or (($3A23) shl 16);
const PR_PRIMARY_FAX_NUMBER_A                      =
   (PT_STRING8) or (($3A23) shl 16);
const PR_BUSINESS_FAX_NUMBER                       = 
   (PT_TSTRING) or (($3A24) shl 16);
const PR_BUSINESS_FAX_NUMBER_W                     = 
   (PT_UNICODE) or (($3A24) shl 16);
const PR_BUSINESS_FAX_NUMBER_A                     = 
   (PT_STRING8) or (($3A24) shl 16);
const PR_HOME_FAX_NUMBER                           = 
   (PT_TSTRING) or (($3A25) shl 16);
const PR_HOME_FAX_NUMBER_W                         = 
   (PT_UNICODE) or (($3A25) shl 16);
const PR_HOME_FAX_NUMBER_A                         = 
   (PT_STRING8) or (($3A25) shl 16);
const PR_COUNTRY                                   = 
   (PT_TSTRING) or (($3A26) shl 16);
const PR_COUNTRY_W                                 = 
   (PT_UNICODE) or (($3A26) shl 16);
const PR_COUNTRY_A                                 = 
   (PT_STRING8) or (($3A26) shl 16);
const PR_BUSINESS_ADDRESS_COUNTRY                  = PR_COUNTRY;
const PR_BUSINESS_ADDRESS_COUNTRY_W                = PR_COUNTRY_W;
const PR_BUSINESS_ADDRESS_COUNTRY_A                = PR_COUNTRY_A;

const PR_LOCALITY                                  =
   (PT_TSTRING) or (($3A27) shl 16);
const PR_LOCALITY_W                                = 
   (PT_UNICODE) or (($3A27) shl 16);
const PR_LOCALITY_A                                = 
   (PT_STRING8) or (($3A27) shl 16);
const PR_BUSINESS_ADDRESS_CITY                     = PR_LOCALITY;
const PR_BUSINESS_ADDRESS_CITY_W                   = PR_LOCALITY_W;
const PR_BUSINESS_ADDRESS_CITY_A                   = PR_LOCALITY_A;

const PR_STATE_OR_PROVINCE                         = 
   (PT_TSTRING) or (($3A28) shl 16);
const PR_STATE_OR_PROVINCE_W                       = 
   (PT_UNICODE) or (($3A28) shl 16);
const PR_STATE_OR_PROVINCE_A                       = 
   (PT_STRING8) or (($3A28) shl 16);
const PR_BUSINESS_ADDRESS_STATE_OR_PROVINCE        = PR_STATE_OR_PROVINCE;
const PR_BUSINESS_ADDRESS_STATE_OR_PROVINCE_W      = PR_STATE_OR_PROVINCE_W;
const PR_BUSINESS_ADDRESS_STATE_OR_PROVINCE_A      = PR_STATE_OR_PROVINCE_A;

const PR_STREET_ADDRESS                            = 
   (PT_TSTRING) or (($3A29) shl 16);
const PR_STREET_ADDRESS_W                          =
   (PT_UNICODE) or (($3A29) shl 16);
const PR_STREET_ADDRESS_A                          =
   (PT_STRING8) or (($3A29) shl 16);
const PR_BUSINESS_ADDRESS_STREET                   = PR_STREET_ADDRESS;
const PR_BUSINESS_ADDRESS_STREET_W                 = PR_STREET_ADDRESS_W;
const PR_BUSINESS_ADDRESS_STREET_A                 = PR_STREET_ADDRESS_A;

const PR_POSTAL_CODE                               = 
   (PT_TSTRING) or (($3A2A) shl 16);
const PR_POSTAL_CODE_W                             = 
   (PT_UNICODE) or (($3A2A) shl 16);
const PR_POSTAL_CODE_A                             = 
   (PT_STRING8) or (($3A2A) shl 16);
const PR_BUSINESS_ADDRESS_POSTAL_CODE              = PR_POSTAL_CODE;
const PR_BUSINESS_ADDRESS_POSTAL_CODE_W            = PR_POSTAL_CODE_W;
const PR_BUSINESS_ADDRESS_POSTAL_CODE_A            = PR_POSTAL_CODE_A;


const PR_POST_OFFICE_BOX                           =
   (PT_TSTRING) or (($3A2B) shl 16);
const PR_POST_OFFICE_BOX_W                         =
   (PT_UNICODE) or (($3A2B) shl 16);
const PR_POST_OFFICE_BOX_A                         =
   (PT_STRING8) or (($3A2B) shl 16);
const PR_BUSINESS_ADDRESS_POST_OFFICE_BOX          = PR_POST_OFFICE_BOX;
const PR_BUSINESS_ADDRESS_POST_OFFICE_BOX_W        = PR_POST_OFFICE_BOX_W;
const PR_BUSINESS_ADDRESS_POST_OFFICE_BOX_A        = PR_POST_OFFICE_BOX_A;


const PR_TELEX_NUMBER                              = 
   (PT_TSTRING) or (($3A2C) shl 16);
const PR_TELEX_NUMBER_W                            = 
   (PT_UNICODE) or (($3A2C) shl 16);
const PR_TELEX_NUMBER_A                            = 
   (PT_STRING8) or (($3A2C) shl 16);
const PR_ISDN_NUMBER                               = 
   (PT_TSTRING) or (($3A2D) shl 16);
const PR_ISDN_NUMBER_W                             = 
   (PT_UNICODE) or (($3A2D) shl 16);
const PR_ISDN_NUMBER_A                             = 
   (PT_STRING8) or (($3A2D) shl 16);
const PR_ASSISTANT_TELEPHONE_NUMBER                = 
   (PT_TSTRING) or (($3A2E) shl 16);
const PR_ASSISTANT_TELEPHONE_NUMBER_W              = 
   (PT_UNICODE) or (($3A2E) shl 16);
const PR_ASSISTANT_TELEPHONE_NUMBER_A              = 
   (PT_STRING8) or (($3A2E) shl 16);
const PR_HOME2_TELEPHONE_NUMBER                    = 
   (PT_TSTRING) or (($3A2F) shl 16);
const PR_HOME2_TELEPHONE_NUMBER_W                  =
   (PT_UNICODE) or (($3A2F) shl 16);
const PR_HOME2_TELEPHONE_NUMBER_A                  =
   (PT_STRING8) or (($3A2F) shl 16);
const PR_ASSISTANT                                 = 
   (PT_TSTRING) or (($3A30) shl 16);
const PR_ASSISTANT_W                               = 
   (PT_UNICODE) or (($3A30) shl 16);
const PR_ASSISTANT_A                               = 
   (PT_STRING8) or (($3A30) shl 16);
const PR_SEND_RICH_INFO                            = 
   (PT_BOOLEAN) or (($3A40) shl 16);

const PR_WEDDING_ANNIVERSARY                       = 
   (PT_SYSTIME) or (($3A41) shl 16);
const PR_BIRTHDAY                                  = 
   (PT_SYSTIME) or (($3A42) shl 16);


const PR_HOBBIES                                   = 
   (PT_TSTRING) or (($3A43) shl 16);
const PR_HOBBIES_W                                 = 
   (PT_UNICODE) or (($3A43) shl 16);
const PR_HOBBIES_A                                 = 
   (PT_STRING8) or (($3A43) shl 16);

const PR_MIDDLE_NAME                               = 
   (PT_TSTRING) or (($3A44) shl 16);
const PR_MIDDLE_NAME_W                             = 
   (PT_UNICODE) or (($3A44) shl 16);
const PR_MIDDLE_NAME_A                             = 
   (PT_STRING8) or (($3A44) shl 16);

const PR_DISPLAY_NAME_PREFIX                       = 
   (PT_TSTRING) or (($3A45) shl 16);
const PR_DISPLAY_NAME_PREFIX_W                     =
   (PT_UNICODE) or (($3A45) shl 16);
const PR_DISPLAY_NAME_PREFIX_A                     = 
   (PT_STRING8) or (($3A45) shl 16);

const PR_PROFESSION                                = 
   (PT_TSTRING) or (($3A46) shl 16);
const PR_PROFESSION_W                              = 
   (PT_UNICODE) or (($3A46) shl 16);
const PR_PROFESSION_A                              = 
   (PT_STRING8) or (($3A46) shl 16);

const PR_PREFERRED_BY_NAME                         = 
   (PT_TSTRING) or (($3A47) shl 16);
const PR_PREFERRED_BY_NAME_W                       =
   (PT_UNICODE) or (($3A47) shl 16);
const PR_PREFERRED_BY_NAME_A                       = 
   (PT_STRING8) or (($3A47) shl 16);

const PR_SPOUSE_NAME                               = 
   (PT_TSTRING) or (($3A48) shl 16);
const PR_SPOUSE_NAME_W                             = 
   (PT_UNICODE) or (($3A48) shl 16);
const PR_SPOUSE_NAME_A                             = 
   (PT_STRING8) or (($3A48) shl 16);

const PR_COMPUTER_NETWORK_NAME                     = 
   (PT_TSTRING) or (($3A49) shl 16);
const PR_COMPUTER_NETWORK_NAME_W                   = 
   (PT_UNICODE) or (($3A49) shl 16);
const PR_COMPUTER_NETWORK_NAME_A                   = 
   (PT_STRING8) or (($3A49) shl 16);

const PR_CUSTOMER_ID                               = 
   (PT_TSTRING) or (($3A4A) shl 16);
const PR_CUSTOMER_ID_W                             = 
   (PT_UNICODE) or (($3A4A) shl 16);
const PR_CUSTOMER_ID_A                             =
   (PT_STRING8) or (($3A4A) shl 16);

const PR_TTYTDD_PHONE_NUMBER                       =
   (PT_TSTRING) or (($3A4B) shl 16);
const PR_TTYTDD_PHONE_NUMBER_W                     =
   (PT_UNICODE) or (($3A4B) shl 16);
const PR_TTYTDD_PHONE_NUMBER_A                     =
   (PT_STRING8) or (($3A4B) shl 16);

const PR_FTP_SITE                                  =
   (PT_TSTRING) or (($3A4C) shl 16);
const PR_FTP_SITE_W                                =
   (PT_UNICODE) or (($3A4C) shl 16);
const PR_FTP_SITE_A                                = 
   (PT_STRING8) or (($3A4C) shl 16);

const PR_GENDER                                    = 
   (PT_SHORT) or (($3A4D) shl 16);

const PR_MANAGER_NAME                              = 
   (PT_TSTRING) or (($3A4E) shl 16);
const PR_MANAGER_NAME_W                            = 
   (PT_UNICODE) or (($3A4E) shl 16);
const PR_MANAGER_NAME_A                            =
   (PT_STRING8) or (($3A4E) shl 16);

const PR_NICKNAME                                  = 
   (PT_TSTRING) or (($3A4F) shl 16);
const PR_NICKNAME_W                                =
   (PT_UNICODE) or (($3A4F) shl 16);
const PR_NICKNAME_A                                = 
   (PT_STRING8) or (($3A4F) shl 16);

const PR_PERSONAL_HOME_PAGE                        = 
   (PT_TSTRING) or (($3A50) shl 16);
const PR_PERSONAL_HOME_PAGE_W                      = 
   (PT_UNICODE) or (($3A50) shl 16);
const PR_PERSONAL_HOME_PAGE_A                      = 
   (PT_STRING8) or (($3A50) shl 16);


const PR_BUSINESS_HOME_PAGE                        = 
   (PT_TSTRING) or (($3A51) shl 16);
const PR_BUSINESS_HOME_PAGE_W                      =
   (PT_UNICODE) or (($3A51) shl 16);
const PR_BUSINESS_HOME_PAGE_A                      = 
   (PT_STRING8) or (($3A51) shl 16);

const PR_CONTACT_VERSION                           = 
   (PT_CLSID) or (($3A52) shl 16);
const PR_CONTACT_ENTRYIDS                          = 
   (PT_MV_BINARY) or (($3A53) shl 16);

const PR_CONTACT_ADDRTYPES                         = 
   (PT_MV_TSTRING) or (($3A54) shl 16);
const PR_CONTACT_ADDRTYPES_W                       = 
   (PT_MV_UNICODE) or (($3A54) shl 16);
const PR_CONTACT_ADDRTYPES_A                       = 
   (PT_MV_STRING8) or (($3A54) shl 16);

const PR_CONTACT_DEFAULT_ADDRESS_INDEX             = 
   (PT_LONG) or (($3A55) shl 16);

const PR_CONTACT_EMAIL_ADDRESSES                   = 
   (PT_MV_TSTRING) or (($3A56) shl 16);
const PR_CONTACT_EMAIL_ADDRESSES_W                 = 
   (PT_MV_UNICODE) or (($3A56) shl 16);
const PR_CONTACT_EMAIL_ADDRESSES_A                 =
   (PT_MV_STRING8) or (($3A56) shl 16);


const PR_COMPANY_MAIN_PHONE_NUMBER                 =
   (PT_TSTRING) or (($3A57) shl 16);
const PR_COMPANY_MAIN_PHONE_NUMBER_W               =
   (PT_UNICODE) or (($3A57) shl 16);
const PR_COMPANY_MAIN_PHONE_NUMBER_A               = 
   (PT_STRING8) or (($3A57) shl 16);

const PR_CHILDRENS_NAMES                           =
   (PT_MV_TSTRING) or (($3A58) shl 16);
const PR_CHILDRENS_NAMES_W                         = 
   (PT_MV_UNICODE) or (($3A58) shl 16);
const PR_CHILDRENS_NAMES_A                         = 
   (PT_MV_STRING8) or (($3A58) shl 16);



const PR_HOME_ADDRESS_CITY                         = 
   (PT_TSTRING) or (($3A59) shl 16);
const PR_HOME_ADDRESS_CITY_W                       = 
   (PT_UNICODE) or (($3A59) shl 16);
const PR_HOME_ADDRESS_CITY_A                       = 
   (PT_STRING8) or (($3A59) shl 16);

const PR_HOME_ADDRESS_COUNTRY                      = 
   (PT_TSTRING) or (($3A5A) shl 16);
const PR_HOME_ADDRESS_COUNTRY_W                    = 
   (PT_UNICODE) or (($3A5A) shl 16);
const PR_HOME_ADDRESS_COUNTRY_A                    = 
   (PT_STRING8) or (($3A5A) shl 16);

const PR_HOME_ADDRESS_POSTAL_CODE                  =
   (PT_TSTRING) or (($3A5B) shl 16);
const PR_HOME_ADDRESS_POSTAL_CODE_W                =
   (PT_UNICODE) or (($3A5B) shl 16);
const PR_HOME_ADDRESS_POSTAL_CODE_A                =
   (PT_STRING8) or (($3A5B) shl 16);

const PR_HOME_ADDRESS_STATE_OR_PROVINCE            = 
   (PT_TSTRING) or (($3A5C) shl 16);
const PR_HOME_ADDRESS_STATE_OR_PROVINCE_W          = 
   (PT_UNICODE) or (($3A5C) shl 16);
const PR_HOME_ADDRESS_STATE_OR_PROVINCE_A          = 
   (PT_STRING8) or (($3A5C) shl 16);

const PR_HOME_ADDRESS_STREET                       = 
   (PT_TSTRING) or (($3A5D) shl 16);
const PR_HOME_ADDRESS_STREET_W                     = 
   (PT_UNICODE) or (($3A5D) shl 16);
const PR_HOME_ADDRESS_STREET_A                     =
   (PT_STRING8) or (($3A5D) shl 16);

const PR_HOME_ADDRESS_POST_OFFICE_BOX              = 
   (PT_TSTRING) or (($3A5E) shl 16);
const PR_HOME_ADDRESS_POST_OFFICE_BOX_W            =
   (PT_UNICODE) or (($3A5E) shl 16);
const PR_HOME_ADDRESS_POST_OFFICE_BOX_A            = 
   (PT_STRING8) or (($3A5E) shl 16);

const PR_OTHER_ADDRESS_CITY                        = 
   (PT_TSTRING) or (($3A5F) shl 16);
const PR_OTHER_ADDRESS_CITY_W                      = 
   (PT_UNICODE) or (($3A5F) shl 16);
const PR_OTHER_ADDRESS_CITY_A                      = 
   (PT_STRING8) or (($3A5F) shl 16);

const PR_OTHER_ADDRESS_COUNTRY                     = 
   (PT_TSTRING) or (($3A60) shl 16);
const PR_OTHER_ADDRESS_COUNTRY_W                   = 
   (PT_UNICODE) or (($3A60) shl 16);
const PR_OTHER_ADDRESS_COUNTRY_A                   = 
   (PT_STRING8) or (($3A60) shl 16);

const PR_OTHER_ADDRESS_POSTAL_CODE                 =
   (PT_TSTRING) or (($3A61) shl 16);
const PR_OTHER_ADDRESS_POSTAL_CODE_W               = 
   (PT_UNICODE) or (($3A61) shl 16);
const PR_OTHER_ADDRESS_POSTAL_CODE_A               = 
   (PT_STRING8) or (($3A61) shl 16);

const PR_OTHER_ADDRESS_STATE_OR_PROVINCE           = 
   (PT_TSTRING) or (($3A62) shl 16);
const PR_OTHER_ADDRESS_STATE_OR_PROVINCE_W         = 
   (PT_UNICODE) or (($3A62) shl 16);
const PR_OTHER_ADDRESS_STATE_OR_PROVINCE_A         =
   (PT_STRING8) or (($3A62) shl 16);

const PR_OTHER_ADDRESS_STREET                      = 
   (PT_TSTRING) or (($3A63) shl 16);
const PR_OTHER_ADDRESS_STREET_W                    = 
   (PT_UNICODE) or (($3A63) shl 16);
const PR_OTHER_ADDRESS_STREET_A                    = 
   (PT_STRING8) or (($3A63) shl 16);

const PR_OTHER_ADDRESS_POST_OFFICE_BOX             = 
   (PT_TSTRING) or (($3A64) shl 16);
const PR_OTHER_ADDRESS_POST_OFFICE_BOX_W           = 
   (PT_UNICODE) or (($3A64) shl 16);
const PR_OTHER_ADDRESS_POST_OFFICE_BOX_A           = 
   (PT_STRING8) or (($3A64) shl 16);


(*
 *  Profile section properties
 *)

const PR_STORE_PROVIDERS                           = 
   (PT_BINARY) or (($3D00) shl 16);
const PR_AB_PROVIDERS                              = 
   (PT_BINARY) or (($3D01) shl 16);
const PR_TRANSPORT_PROVIDERS                       = 
   (PT_BINARY) or (($3D02) shl 16);

const PR_DEFAULT_PROFILE                           =
   (PT_BOOLEAN) or (($3D04) shl 16);
const PR_AB_SEARCH_PATH                            = 
   (PT_MV_BINARY) or (($3D05) shl 16);
const PR_AB_DEFAULT_DIR                            = 
   (PT_BINARY) or (($3D06) shl 16);
const PR_AB_DEFAULT_PAB                            =
   (PT_BINARY) or (($3D07) shl 16);

const PR_FILTERING_HOOKS                           = 
   (PT_BINARY) or (($3D08) shl 16);
const PR_SERVICE_NAME                              = 
   (PT_TSTRING) or (($3D09) shl 16);
const PR_SERVICE_NAME_W                            =
   (PT_UNICODE) or (($3D09) shl 16);
const PR_SERVICE_NAME_A                            = 
   (PT_STRING8) or (($3D09) shl 16);
const PR_SERVICE_DLL_NAME                          = 
   (PT_TSTRING) or (($3D0A) shl 16);
const PR_SERVICE_DLL_NAME_W                        = 
   (PT_UNICODE) or (($3D0A) shl 16);
const PR_SERVICE_DLL_NAME_A                        = 
   (PT_STRING8) or (($3D0A) shl 16);
const PR_SERVICE_ENTRY_NAME                        = 
   (PT_STRING8) or (($3D0B) shl 16);
const PR_SERVICE_UID                               = 
   (PT_BINARY) or (($3D0C) shl 16);
const PR_SERVICE_EXTRA_UIDS                        = 
   (PT_BINARY) or (($3D0D) shl 16);
const PR_SERVICES                                  = 
   (PT_BINARY) or (($3D0E) shl 16);
const PR_SERVICE_SUPPORT_FILES                     = 
   (PT_MV_TSTRING) or (($3D0F) shl 16);
const PR_SERVICE_SUPPORT_FILES_W                   = 
   (PT_MV_UNICODE) or (($3D0F) shl 16);
const PR_SERVICE_SUPPORT_FILES_A                   =
   (PT_MV_STRING8) or (($3D0F) shl 16);
const PR_SERVICE_DELETE_FILES                      =
   (PT_MV_TSTRING) or (($3D10) shl 16);
const PR_SERVICE_DELETE_FILES_W                    = 
   (PT_MV_UNICODE) or (($3D10) shl 16);
const PR_SERVICE_DELETE_FILES_A                    =
   (PT_MV_STRING8) or (($3D10) shl 16);
const PR_AB_SEARCH_PATH_UPDATE                     = 
   (PT_BINARY) or (($3D11) shl 16);
const PR_PROFILE_NAME                              = 
   (PT_TSTRING) or (($3D12) shl 16);
const PR_PROFILE_NAME_A                            = 
   (PT_STRING8) or (($3D12) shl 16);
const PR_PROFILE_NAME_W                            = 
   (PT_UNICODE) or (($3D12) shl 16);

(*
 *  Status object properties
 *)

const PR_IDENTITY_DISPLAY                          =
   (PT_TSTRING) or (($3E00) shl 16);
const PR_IDENTITY_DISPLAY_W                        = 
   (PT_UNICODE) or (($3E00) shl 16);
const PR_IDENTITY_DISPLAY_A                        = 
   (PT_STRING8) or (($3E00) shl 16);
const PR_IDENTITY_ENTRYID                          = 
   (PT_BINARY) or (($3E01) shl 16);
const PR_RESOURCE_METHODS                          = 
   (PT_LONG) or (($3E02) shl 16);
const PR_RESOURCE_TYPE                             = 
   (PT_LONG) or (($3E03) shl 16);
const PR_STATUS_CODE                               = 
   (PT_LONG) or (($3E04) shl 16);
const PR_IDENTITY_SEARCH_KEY                       =
   (PT_BINARY) or (($3E05) shl 16);
const PR_OWN_STORE_ENTRYID                         = 
   (PT_BINARY) or (($3E06) shl 16);
const PR_RESOURCE_PATH                             = 
   (PT_TSTRING) or (($3E07) shl 16);
const PR_RESOURCE_PATH_W                           =
   (PT_UNICODE) or (($3E07) shl 16);
const PR_RESOURCE_PATH_A                           =
   (PT_STRING8) or (($3E07) shl 16);
const PR_STATUS_STRING                             =
   (PT_TSTRING) or (($3E08) shl 16);
const PR_STATUS_STRING_W                           = 
   (PT_UNICODE) or (($3E08) shl 16);
const PR_STATUS_STRING_A                           = 
   (PT_STRING8) or (($3E08) shl 16);
const PR_X400_DEFERRED_DELIVERY_CANCEL             = 
   (PT_BOOLEAN) or (($3E09) shl 16);
const PR_HEADER_FOLDER_ENTRYID                     = 
   (PT_BINARY) or (($3E0A) shl 16);
const PR_REMOTE_PROGRESS                           = 
   (PT_LONG) or (($3E0B) shl 16);
const PR_REMOTE_PROGRESS_TEXT                      = 
   (PT_TSTRING) or (($3E0C) shl 16);
const PR_REMOTE_PROGRESS_TEXT_W                    =
   (PT_UNICODE) or (($3E0C) shl 16);
const PR_REMOTE_PROGRESS_TEXT_A                    = 
   (PT_STRING8) or (($3E0C) shl 16);
const PR_REMOTE_VALIDATE_OK                        = 
   (PT_BOOLEAN) or (($3E0D) shl 16);

(*
 * Display table properties
 *)

const PR_CONTROL_FLAGS                             =
   (PT_LONG) or (($3F00) shl 16);
const PR_CONTROL_STRUCTURE                         = 
   (PT_BINARY) or (($3F01) shl 16);
const PR_CONTROL_TYPE                              =
   (PT_LONG) or (($3F02) shl 16);
const PR_DELTAX                                    =
   (PT_LONG) or (($3F03) shl 16);
const PR_DELTAY                                    =
   (PT_LONG) or (($3F04) shl 16);
const PR_XPOS                                      =
   (PT_LONG) or (($3F05) shl 16);
const PR_YPOS                                      =
   (PT_LONG) or (($3F06) shl 16);
const PR_CONTROL_ID                                =
   (PT_BINARY) or (($3F07) shl 16);
const PR_INITIAL_DETAILS_PANE                      =
   (PT_LONG) or (($3F08) shl 16);

(*
 * Secure property id range
 *)

const PROP_ID_SECURE_MIN                           = $67F0;
const PROP_ID_SECURE_MAX                           = $67FF;

//additional

const PR_SEND_INTERNET_ENCODING =
   (PT_LONG) or (($3A71 ) shl 16);

const PR_INTERNET_MESSAGE_ID =
   (PT_STRING8) or (($1035 ) shl 16);

//Generally undocumented properties
PR_ABSTRACT = (($3FDA) shl 16) or (PT_STRING8);
PR_ACL_DATA = (($3FE0) shl 16) or PT_BINARY;
PR_ACL_TABLE = (($3FE0) shl 16) or PT_OBJECT;
PR_ACTIVE_USER_ENTRYID = (($6652) shl 16) or PT_BINARY;
PR_ADDRBOOK_FOR_LOCAL_SITE_ENTRYID = (($6626) shl 16) or PT_BINARY;
PR_ADDRESS_BOOK_DISPLAY_NAME = (($3FE8) shl 16) or PT_STRING8;
PR_ADDRESS_BOOK_ENTRYID = (($663B) shl 16) or PT_BINARY;
PR_ARRIVAL_TIME = (($665F) shl 16) or PT_SYSTIME;
PR_ASSOC_MESSAGE_SIZE = (($66B4) shl 16) or PT_LONG;
PR_ASSOC_MESSAGE_SIZE_EXTENDED = (($66B4) shl 16) or PT_I8;
PR_ASSOC_MSG_W_ATTACH_COUNT = (($66AE) shl 16) or PT_LONG;
PR_ATTACH_ON_ASSOC_MSG_COUNT = (($66B2) shl 16) or PT_LONG;
PR_ATTACH_ON_NORMAL_MSG_COUNT = (($66B1) shl 16) or PT_LONG;
PR_AUTO_ADD_NEW_SUBS = (($65E5) shl 16) or PT_BOOLEAN;
PR_AUTO_RESPONSE_SUPPRESS = (($3FDF) shl 16) or PT_LONG;
PR_BILATERAL_INFO = (($3FDC) shl 16) or PT_BINARY;
PR_CACHED_COLUMN_COUNT = (($66AC) shl 16) or PT_LONG;
PR_CATEG_COUNT = (($66AB) shl 16) or PT_LONG;
PR_CHANGE_ADVISOR = (($6634) shl 16) or PT_OBJECT;
PR_CHANGE_KEY = (($65E2) shl 16) or PT_BINARY;
PR_CHANGE_NOTIFICATION_GUID = (($6637) shl 16) or PT_CLSID;
PR_CLIENT_ACTIONS = (($6645) shl 16) or PT_BINARY;
PR_CODE_PAGE_ID = (($66C3) shl 16) or PT_LONG;
PR_COLLECTOR = (($662E) shl 16) or PT_OBJECT;
PR_CONFLICT_ENTRYID = (($3FF0) shl 16) or PT_BINARY;
PR_CONTACT_COUNT = (($66B7) shl 16) or PT_LONG;
PR_CONTENT_SEARCH_KEY = (($6666) shl 16) or PT_BINARY;
PR_CONTENTS_SYNCHRONIZER = (($662D) shl 16) or PT_OBJECT; 
PR_CREATOR_ENTRYID = (($3FF9) shl 16) or PT_BINARY;
PR_CREATOR_NAME = (($3FF8) shl 16) or PT_STRING8; 
PR_DAM_BACK_PATCHED = (($6647) shl 16) or PT_BOOLEAN;
PR_DAM_ORIGINAL_ENTRYID = (($6646) shl 16) or PT_BINARY; 
PR_DEFERRED_SEND_NUMBER = (($3FEB) shl 16) or PT_LONG; 
PR_DEFERRED_SEND_TIME = (($3FEF) shl 16) or PT_SYSTIME; 
PR_DEFERRED_SEND_UNITS = (($3FEC) shl 16) or PT_LONG; 
PR_DELEGATED_BY_RULE = (($3FE3) shl 16) or PT_BOOLEAN;
PR_DELETED_ASSOC_MESSAGE_SIZE_EXTENDED = (($669D) shl 16) or PT_I8; 
PR_DELETED_ASSOC_MSG_COUNT = (($6643) shl 16) or PT_LONG; 
PR_DELETED_FOLDER_COUNT = (($6641) shl 16) or PT_LONG; 
PR_DELETED_MESSAGE_SIZE_EXTENDED = (($669B) shl 16) or PT_I8; 
PR_DELETED_MSG_COUNT = (($6640) shl 16) or PT_LONG;
PR_DELETED_NORMAL_MESSAGE_SIZE_EXTENDED = (($669C) shl 16) or PT_I8;
PR_DELETED_ON = (($668F) shl 16) or PT_SYSTIME;
PR_DESIGN_IN_PROGRESS = (($3FE4) shl 16) or PT_BOOLEAN;
PR_DISABLE_FULL_FIDELITY = (($10F2) shl 16) or PT_BOOLEAN;
PR_DISABLE_WINSOCK = (($6618) shl 16) or PT_LONG; 
PR_DL_REPORT_FLAGS = (($3FDB) shl 16) or PT_LONG; 
PR_EFORMS_FOR_LOCALE_ENTRYID = (($6624) shl 16) or PT_BINARY; 
PR_EFORMS_LOCALE_ID = (($3FE9) shl 16) or PT_LONG; 
PR_EFORMS_REGISTRY_ENTRYID = (($6621) shl 16) or PT_BINARY;
PR_EMS_AB_ACCESS_CATEGORY = (ULONG($8044) shl 16) or PT_LONG;
PR_EMS_AB_ACTIVATION_SCHEDULE = (ULONG($8045) shl 16) or PT_BINARY;
PR_EMS_AB_ACTIVATION_STYLE = (ULONG($8046) shl 16) or PT_LONG;
PR_EMS_AB_ADDRESS_ENTRY_DISPLAY_TABLE = (ULONG($8017) shl 16) or PT_BINARY; 
PR_EMS_AB_ADDRESS_ENTRY_DISPLAY_TABLE_MSDOS = (ULONG($8047) shl 16) or PT_BINARY;
PR_EMS_AB_ADDRESS_SYNTAX = (ULONG($8018) shl 16) or PT_BINARY; 
PR_EMS_AB_ADDRESS_TYPE = (ULONG($8048) shl 16) or PT_STRING8;
PR_EMS_AB_ADMD = (ULONG($8049) shl 16) or PT_STRING8; 
PR_EMS_AB_ADMIN_DESCRIPTION = (ULONG($804A) shl 16) or PT_STRING8;
PR_EMS_AB_ADMIN_DISPLAY_NAME = (ULONG($804B) shl 16) or PT_STRING8;
PR_EMS_AB_ADMIN_EXTENSION_DLL = (ULONG($804C) shl 16) or PT_STRING8; 
PR_EMS_AB_ALIASED_OBJECT_NAME = (ULONG($804D) shl 16) or PT_STRING8; 
PR_EMS_AB_ALIASED_OBJECT_NAME_O = (ULONG($804D) shl 16) or PT_OBJECT;
PR_EMS_AB_ALT_RECIPIENT = (ULONG($804E) shl 16) or PT_STRING8; 
PR_EMS_AB_ALT_RECIPIENT_BL = (ULONG($804F) shl 16) or PT_MV_STRING8;
PR_EMS_AB_ALT_RECIPIENT_BL_O = (ULONG($804F) shl 16) or PT_OBJECT;
PR_EMS_AB_ALT_RECIPIENT_O = (ULONG($804E) shl 16) or PT_OBJECT;
PR_EMS_AB_ANCESTOR_ID = (ULONG($8050) shl 16) or PT_BINARY; 
PR_EMS_AB_ANONYMOUS_ACCESS = (ULONG($8187) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_ANONYMOUS_ACCOUNT = (ULONG($8C26) shl 16) or PT_STRING8; 
PR_EMS_AB_ASSOC_NT_ACCOUNT = (ULONG($8027) shl 16) or PT_BINARY;
PR_EMS_AB_ASSOC_PROTOCOL_CFG_NNTP = (ULONG($81A5) shl 16) or PT_STRING8; 
PR_EMS_AB_ASSOC_PROTOCOL_CFG_NNTP_O = (ULONG($81A5) shl 16) or PT_OBJECT;
PR_EMS_AB_ASSOC_REMOTE_DXA = (ULONG($8051) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_ASSOC_REMOTE_DXA_O = (ULONG($8051) shl 16) or PT_OBJECT; 
PR_EMS_AB_ASSOCIATION_LIFETIME = (ULONG($8052) shl 16) or PT_LONG;
PR_EMS_AB_ATTRIBUTE_CERTIFICATE = (ULONG($8C45) shl 16) or PT_MV_BINARY;
PR_EMS_AB_AUTH_ORIG_BL = (ULONG($8053) shl 16) or PT_MV_STRING8;
PR_EMS_AB_AUTH_ORIG_BL_O = (ULONG($8053) shl 16) or PT_OBJECT; 
PR_EMS_AB_AUTHENTICATION_TO_USE = (ULONG($819A) shl 16) or PT_STRING8; 
PR_EMS_AB_AUTHORITY_REVOCATION_LIST = (ULONG($8026) shl 16) or PT_MV_BINARY; 
PR_EMS_AB_AUTHORIZED_DOMAIN = (ULONG($8054) shl 16) or PT_STRING8; 
PR_EMS_AB_AUTHORIZED_PASSWORD = (ULONG($8055) shl 16) or PT_BINARY; 
PR_EMS_AB_AUTHORIZED_PASSWORD_CONFIRM = (ULONG($8192) shl 16) or PT_BINARY; 
PR_EMS_AB_AUTHORIZED_USER = (ULONG($8056) shl 16) or PT_STRING8; 
PR_EMS_AB_AUTOREPLY = (ULONG($800B) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_AUTOREPLY_MESSAGE = (ULONG($800A) shl 16) or PT_STRING8;
PR_EMS_AB_AUTOREPLY_SUBJECT = (ULONG($803E) shl 16) or PT_STRING8;
PR_EMS_AB_AVAILABLE_AUTHORIZATION_PACKAGES = (ULONG($8181) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_AVAILABLE_DISTRIBUTIONS = (ULONG($818B) shl 16) or PT_STRING8; 
PR_EMS_AB_BRIDGEHEAD_SERVERS = (ULONG($8174) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_BRIDGEHEAD_SERVERS_O = (ULONG($8174) shl 16) or PT_OBJECT; 
PR_EMS_AB_BUSINESS_CATEGORY = (ULONG($8057) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_BUSINESS_ROLES = (ULONG($8023) shl 16) or PT_BINARY; 
PR_EMS_AB_CA_CERTIFICATE = (ULONG($8003) shl 16) or PT_MV_BINARY;
PR_EMS_AB_CAN_CREATE_PF = (ULONG($8058) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_CAN_CREATE_PF_BL = (ULONG($8059) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_CAN_CREATE_PF_BL_O = (ULONG($8059) shl 16) or PT_OBJECT; 
PR_EMS_AB_CAN_CREATE_PF_DL = (ULONG($805A) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_CAN_CREATE_PF_DL_BL = (ULONG($805B) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_CAN_CREATE_PF_DL_BL_O = (ULONG($805B) shl 16) or PT_OBJECT;
PR_EMS_AB_CAN_CREATE_PF_DL_O = (ULONG($805A) shl 16) or PT_OBJECT; 
PR_EMS_AB_CAN_CREATE_PF_O = (ULONG($8058) shl 16) or PT_OBJECT; 
PR_EMS_AB_CAN_NOT_CREATE_PF = (ULONG($805C) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_CAN_NOT_CREATE_PF_BL = (ULONG($805D) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_CAN_NOT_CREATE_PF_BL_O = (ULONG($805D) shl 16) or PT_OBJECT;
PR_EMS_AB_CAN_NOT_CREATE_PF_DL = (ULONG($805E) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_CAN_NOT_CREATE_PF_DL_BL = (ULONG($805F) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_CAN_NOT_CREATE_PF_DL_BL_O = (ULONG($805F) shl 16) or PT_OBJECT; 
PR_EMS_AB_CAN_NOT_CREATE_PF_DL_O = (ULONG($805E) shl 16) or PT_OBJECT; 
PR_EMS_AB_CAN_NOT_CREATE_PF_O = (ULONG($805C) shl 16) or PT_OBJECT;
PR_EMS_AB_CAN_PRESERVE_DNS = (ULONG($8060) shl 16) or PT_BOOLEAN;
PR_EMS_AB_CERTIFICATE_CHAIN_V3 = (ULONG($8C27) shl 16) or PT_BINARY;
PR_EMS_AB_CERTIFICATE_REVOCATION_LIST = (ULONG($8016) shl 16) or PT_BINARY; 
PR_EMS_AB_CERTIFICATE_REVOCATION_LIST_V1 = (ULONG($8C29) shl 16) or PT_BINARY;
PR_EMS_AB_CERTIFICATE_REVOCATION_LIST_V3 = (ULONG($8C28) shl 16) or PT_BINARY;
PR_EMS_AB_CHARACTER_SET = (ULONG($8185) shl 16) or PT_STRING8; 
PR_EMS_AB_CHARACTER_SET_LIST = (ULONG($8182) shl 16) or PT_MV_STRING8;
//PR_EMS_AB_CHILD_RDNS = (($FFF8) shl 16) or PT_MV_STRING8;
PR_EMS_AB_CLIENT_ACCESS_ENABLED = (ULONG($8C24) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_CLOCK_ALERT_OFFSET = (ULONG($8061) shl 16) or PT_LONG; 
PR_EMS_AB_CLOCK_ALERT_REPAIR = (ULONG($8062) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_CLOCK_WARNING_OFFSET = (ULONG($8063) shl 16) or PT_LONG; 
PR_EMS_AB_CLOCK_WARNING_REPAIR = (ULONG($8064) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_COMPROMISED_KEY_LIST = (ULONG($81C4) shl 16) or PT_BINARY; 
PR_EMS_AB_COMPUTER_NAME = (ULONG($8065) shl 16) or PT_STRING8; 
PR_EMS_AB_CONNECTED_DOMAINS = (ULONG($8066) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_CONNECTION_LIST_FILTER = (ULONG($8180) shl 16) or PT_BINARY; 
PR_EMS_AB_CONNECTION_LIST_FILTER_TYPE = (ULONG($81B4) shl 16) or PT_LONG;
PR_EMS_AB_CONNECTION_TYPE = (ULONG($81B3) shl 16) or PT_BOOLEAN;
PR_EMS_AB_CONTAINER_INFO = (ULONG($8067) shl 16) or PT_LONG; 
PR_EMS_AB_CONTAINERID = (ULONG($FFFD) shl 16) or PT_LONG;
PR_EMS_AB_CONTENT_TYPE = (ULONG($8186) shl 16) or PT_LONG; 
PR_EMS_AB_CONTROL_MSG_FOLDER_ID = (ULONG($8188) shl 16) or PT_BINARY; 
PR_EMS_AB_CONTROL_MSG_RULES = (ULONG($818A) shl 16) or PT_BINARY; 
PR_EMS_AB_COST = (ULONG($8068) shl 16) or PT_LONG; 
PR_EMS_AB_COUNTRY_NAME = (ULONG($8069) shl 16) or PT_STRING8; 
PR_EMS_AB_CROSS_CERTIFICATE_CRL = (ULONG($8C30) shl 16) or PT_MV_BINARY; 
PR_EMS_AB_CROSS_CERTIFICATE_PAIR = (ULONG($8025) shl 16) or PT_MV_BINARY; 
PR_EMS_AB_DEFAULT_MESSAGE_FORMAT = (ULONG($8C37) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_DELEGATE_USER = (ULONG($8C49) shl 16) or PT_BOOLEAN;
PR_EMS_AB_DELIV_CONT_LENGTH = (ULONG($806A) shl 16) or PT_LONG; 
PR_EMS_AB_DELIV_EITS = (ULONG($806B) shl 16) or PT_MV_BINARY;
PR_EMS_AB_DELIV_EXT_CONT_TYPES = (ULONG($806C) shl 16) or PT_MV_BINARY; 
PR_EMS_AB_DELIVER_AND_REDIRECT = (ULONG($806D) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_DELIVERY_MECHANISM = (ULONG($806E) shl 16) or PT_LONG;
PR_EMS_AB_DELTA_REVOCATION_LIST = (ULONG($8C46) shl 16) or PT_MV_BINARY;
PR_EMS_AB_DESCRIPTION = (ULONG($806F) shl 16) or PT_MV_STRING8;
PR_EMS_AB_DESTINATION_INDICATOR = (ULONG($8070) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_DIAGNOSTIC_REG_KEY = (ULONG($8071) shl 16) or PT_STRING8; 
PR_EMS_AB_DISABLE_DEFERRED_COMMIT = (ULONG($8C23) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_DISABLED_GATEWAY_PROXY = (ULONG($81C3) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_DISPLAY_NAME_OVERRIDE = (ULONG($8001) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_DISPLAY_NAME_PRINTABLE = (($39FF) shl 16) or PT_STRING8; 
PR_EMS_AB_DISPLAY_NAME_SUFFIX = (ULONG($8C44) shl 16) or PT_STRING8; 
PR_EMS_AB_DL_MEM_REJECT_PERMS_BL = (ULONG($8072) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_DL_MEM_REJECT_PERMS_BL_O = (ULONG($8072) shl 16) or PT_OBJECT;
PR_EMS_AB_DL_MEM_SUBMIT_PERMS_BL = (ULONG($8073) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_DL_MEM_SUBMIT_PERMS_BL_O = (ULONG($8073) shl 16) or PT_OBJECT;
PR_EMS_AB_DL_MEMBER_RULE = (ULONG($8074) shl 16) or PT_MV_BINARY; 
PR_EMS_AB_DMD_NAME = (ULONG($8C56) shl 16) or PT_STRING8; 
PR_EMS_AB_DO_OAB_VERSION = (ULONG($8C3A) shl 16) or PT_LONG; 
PR_EMS_AB_DOMAIN_DEF_ALT_RECIP = (ULONG($8075) shl 16) or PT_STRING8; 
PR_EMS_AB_DOMAIN_DEF_ALT_RECIP_O = (ULONG($8075) shl 16) or PT_OBJECT; 
PR_EMS_AB_DOMAIN_NAME = (ULONG($8076) shl 16) or PT_STRING8;
PR_EMS_AB_DOS_ENTRYID = (ULONG($FFFD) shl 16) or PT_LONG; 
PR_EMS_AB_DSA_SIGNATURE = (ULONG($8077) shl 16) or PT_BINARY; 
PR_EMS_AB_DXA_ADMIN_COPY = (ULONG($8078) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_DXA_ADMIN_FORWARD = (ULONG($8079) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_DXA_ADMIN_UPDATE = (ULONG($807A) shl 16) or PT_LONG; 
PR_EMS_AB_DXA_APPEND_REQCN = (ULONG($807B) shl 16) or PT_BOOLEAN;
PR_EMS_AB_DXA_CONF_CONTAINER_LIST = (ULONG($807C) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_DXA_CONF_CONTAINER_LIST_O = (ULONG($807C) shl 16) or PT_OBJECT; 
PR_EMS_AB_DXA_CONF_REQ_TIME = (ULONG($807D) shl 16) or PT_SYSTIME; 
PR_EMS_AB_DXA_CONF_SEQ = (ULONG($807E) shl 16) or PT_STRING8; 
PR_EMS_AB_DXA_CONF_SEQ_USN = (ULONG($807F) shl 16) or PT_LONG;
PR_EMS_AB_DXA_EXCHANGE_OPTIONS = (ULONG($8080) shl 16) or PT_LONG; 
PR_EMS_AB_DXA_EXPORT_NOW = (ULONG($8081) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_DXA_FLAGS = (ULONG($8082) shl 16) or PT_LONG; 
PR_EMS_AB_DXA_IMP_SEQ = (ULONG($8083) shl 16) or PT_STRING8; 
PR_EMS_AB_DXA_IMP_SEQ_TIME = (ULONG($8084) shl 16) or PT_SYSTIME;
PR_EMS_AB_DXA_IMP_SEQ_USN = (ULONG($8085) shl 16) or PT_LONG;
PR_EMS_AB_DXA_IMPORT_NOW = (ULONG($8086) shl 16) or PT_BOOLEAN;
PR_EMS_AB_DXA_IN_TEMPLATE_MAP = (ULONG($8087) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_DXA_LOCAL_ADMIN = (ULONG($8088) shl 16) or PT_STRING8;
PR_EMS_AB_DXA_LOCAL_ADMIN_O = (ULONG($8088) shl 16) or PT_OBJECT; 
PR_EMS_AB_DXA_LOGGING_LEVEL = (ULONG($8089) shl 16) or PT_LONG; 
PR_EMS_AB_DXA_NATIVE_ADDRESS_TYPE = (ULONG($808A) shl 16) or PT_STRING8; 
PR_EMS_AB_DXA_OUT_TEMPLATE_MAP = (ULONG($808B) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_DXA_PASSWORD = (ULONG($808C) shl 16) or PT_STRING8; 
PR_EMS_AB_DXA_PREV_EXCHANGE_OPTIONS = (ULONG($808D) shl 16) or PT_LONG; 
PR_EMS_AB_DXA_PREV_EXPORT_NATIVE_ONLY = (ULONG($808E) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_DXA_PREV_IN_EXCHANGE_SENSITIVITY = (ULONG($808F) shl 16) or PT_LONG; 
PR_EMS_AB_DXA_PREV_REMOTE_ENTRIES = (ULONG($8090) shl 16) or PT_STRING8; 
PR_EMS_AB_DXA_PREV_REMOTE_ENTRIES_O = (ULONG($8090) shl 16) or PT_OBJECT; 
PR_EMS_AB_DXA_PREV_REPLICATION_SENSITIVITY = (ULONG($8091) shl 16) or PT_LONG; 
PR_EMS_AB_DXA_PREV_TEMPLATE_OPTIONS = (ULONG($8092) shl 16) or PT_LONG; 
PR_EMS_AB_DXA_PREV_TYPES = (ULONG($8093) shl 16) or PT_LONG; 
PR_EMS_AB_DXA_RECIPIENT_CP = (ULONG($8094) shl 16) or PT_STRING8;
PR_EMS_AB_DXA_REMOTE_CLIENT = (ULONG($8095) shl 16) or PT_STRING8;
PR_EMS_AB_DXA_REMOTE_CLIENT_O = (ULONG($8095) shl 16) or PT_OBJECT; 
PR_EMS_AB_DXA_REQ_SEQ = (ULONG($8096) shl 16) or PT_STRING8; 
PR_EMS_AB_DXA_REQ_SEQ_TIME = (ULONG($8097) shl 16) or PT_SYSTIME;
PR_EMS_AB_DXA_REQ_SEQ_USN = (ULONG($8098) shl 16) or PT_LONG; 
PR_EMS_AB_DXA_REQNAME = (ULONG($8099) shl 16) or PT_STRING8; 
PR_EMS_AB_DXA_SVR_SEQ = (ULONG($809A) shl 16) or PT_STRING8; 
PR_EMS_AB_DXA_SVR_SEQ_TIME = (ULONG($809B) shl 16) or PT_SYSTIME; 
PR_EMS_AB_DXA_SVR_SEQ_USN = (ULONG($809C) shl 16) or PT_LONG; 
PR_EMS_AB_DXA_TASK = (ULONG($809D) shl 16) or PT_LONG; 
PR_EMS_AB_DXA_TEMPLATE_OPTIONS = (ULONG($809E) shl 16) or PT_LONG; 
PR_EMS_AB_DXA_TEMPLATE_TIMESTAMP = (ULONG($809F) shl 16) or PT_SYSTIME;
PR_EMS_AB_DXA_TYPES = (ULONG($80A0) shl 16) or PT_LONG; 
PR_EMS_AB_DXA_UNCONF_CONTAINER_LIST = (ULONG($80A1) shl 16) or PT_MV_STRING8;
PR_EMS_AB_DXA_UNCONF_CONTAINER_LIST_O = (ULONG($80A1) shl 16) or PT_OBJECT; 
PR_EMS_AB_EMPLOYEE_NUMBER = (ULONG($8C67) shl 16) or PT_STRING8; 
PR_EMS_AB_EMPLOYEE_TYPE = (ULONG($8C69) shl 16) or PT_STRING8;
PR_EMS_AB_ENABLE_COMPATIBILITY = (ULONG($8C32) shl 16) or PT_BOOLEAN;
PR_EMS_AB_ENABLED = (ULONG($8C21) shl 16) or PT_BOOLEAN;
PR_EMS_AB_ENABLED_AUTHORIZATION_PACKAGES = (ULONG($8184) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_ENABLED_PROTOCOL_CFG = (ULONG($81A8) shl 16) or PT_BOOLEAN;
PR_EMS_AB_ENABLED_PROTOCOLS = (ULONG($817F) shl 16) or PT_LONG; 
PR_EMS_AB_ENCAPSULATION_METHOD = (ULONG($80A2) shl 16) or PT_LONG; 
PR_EMS_AB_ENCRYPT = (ULONG($80A3) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_ENCRYPT_ALG_LIST_NA = (ULONG($8040) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_ENCRYPT_ALG_LIST_OTHER = (ULONG($8041) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_ENCRYPT_ALG_SELECTED_NA = (ULONG($8043) shl 16) or PT_STRING8; 
PR_EMS_AB_ENCRYPT_ALG_SELECTED_OTHER = (ULONG($803D) shl 16) or PT_STRING8;
PR_EMS_AB_EXPAND_DLS_LOCALLY = (ULONG($80A4) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_EXPIRATION_TIME = (ULONG($8028) shl 16) or PT_SYSTIME; 
PR_EMS_AB_EXPORT_CONTAINERS = (ULONG($80A5) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_EXPORT_CONTAINERS_O = (ULONG($80A5) shl 16) or PT_OBJECT; 
PR_EMS_AB_EXPORT_CUSTOM_RECIPIENTS = (ULONG($80A6) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_EXTENDED_CHARS_ALLOWED = (ULONG($80A7) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_EXTENSION_ATTRIBUTE_1 = (ULONG($802D) shl 16) or PT_STRING8; 
PR_EMS_AB_EXTENSION_ATTRIBUTE_10 = (ULONG($8036) shl 16) or PT_STRING8;
PR_EMS_AB_EXTENSION_ATTRIBUTE_11 = (ULONG($8C57) shl 16) or PT_STRING8; 
PR_EMS_AB_EXTENSION_ATTRIBUTE_12 = (ULONG($8C58) shl 16) or PT_STRING8; 
PR_EMS_AB_EXTENSION_ATTRIBUTE_13 = (ULONG($8C59) shl 16) or PT_STRING8; 
PR_EMS_AB_EXTENSION_ATTRIBUTE_14 = (ULONG($8C60) shl 16) or PT_STRING8; 
PR_EMS_AB_EXTENSION_ATTRIBUTE_15 = (ULONG($8C61) shl 16) or PT_STRING8; 
PR_EMS_AB_EXTENSION_ATTRIBUTE_2 = (ULONG($802E) shl 16) or PT_STRING8;
PR_EMS_AB_EXTENSION_ATTRIBUTE_3 = (ULONG($802F) shl 16) or PT_STRING8; 
PR_EMS_AB_EXTENSION_ATTRIBUTE_4 = (ULONG($8030) shl 16) or PT_STRING8; 
PR_EMS_AB_EXTENSION_ATTRIBUTE_5 = (ULONG($8031) shl 16) or PT_STRING8; 
PR_EMS_AB_EXTENSION_ATTRIBUTE_6 = (ULONG($8032) shl 16) or PT_STRING8; 
PR_EMS_AB_EXTENSION_ATTRIBUTE_7 = (ULONG($8033) shl 16) or PT_STRING8;
PR_EMS_AB_EXTENSION_ATTRIBUTE_8 = (ULONG($8034) shl 16) or PT_STRING8;
PR_EMS_AB_EXTENSION_ATTRIBUTE_9 = (ULONG($8035) shl 16) or PT_STRING8; 
PR_EMS_AB_EXTENSION_DATA = (ULONG($80A8) shl 16) or PT_MV_BINARY; 
PR_EMS_AB_EXTENSION_NAME = (ULONG($80A9) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_EXTENSION_NAME_INHERITED = (ULONG($80AA) shl 16) or PT_MV_STRING8;
PR_EMS_AB_FACSIMILE_TELEPHONE_NUMBER = (ULONG($80AB) shl 16) or PT_MV_BINARY;
PR_EMS_AB_FILE_VERSION = (ULONG($80AC) shl 16) or PT_BINARY;
PR_EMS_AB_FILTER_LOCAL_ADDRESSES = (ULONG($80AD) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_FOLDER_PATHNAME = (ULONG($8004) shl 16) or PT_STRING8;
PR_EMS_AB_FOLDERS_CONTAINER = (ULONG($80AE) shl 16) or PT_STRING8; 
PR_EMS_AB_FOLDERS_CONTAINER_O = (ULONG($80AE) shl 16) or PT_OBJECT; 
PR_EMS_AB_FORM_DATA = (ULONG($8C65) shl 16) or PT_BINARY; 
PR_EMS_AB_FORWARDING_ADDRESS = (ULONG($8C64) shl 16) or PT_STRING8; 
PR_EMS_AB_GARBAGE_COLL_PERIOD = (ULONG($80AF) shl 16) or PT_LONG; 
PR_EMS_AB_GATEWAY_LOCAL_CRED = (ULONG($80B0) shl 16) or PT_STRING8; 
PR_EMS_AB_GATEWAY_LOCAL_DESIG = (ULONG($80B1) shl 16) or PT_STRING8; 
PR_EMS_AB_GATEWAY_PROXY = (ULONG($80B2) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_GATEWAY_ROUTING_TREE = (ULONG($80B3) shl 16) or PT_BINARY;
PR_EMS_AB_GENERATION_QUALIFIER = (ULONG($8C53) shl 16) or PT_STRING8; 
PR_EMS_AB_GROUP_BY_ATTR_1 = (ULONG($81B7) shl 16) or PT_STRING8; 
PR_EMS_AB_GROUP_BY_ATTR_2 = (ULONG($81B8) shl 16) or PT_STRING8; 
PR_EMS_AB_GROUP_BY_ATTR_3 = (ULONG($81B9) shl 16) or PT_STRING8; 
PR_EMS_AB_GROUP_BY_ATTR_4 = (ULONG($81BA) shl 16) or PT_STRING8;
PR_EMS_AB_GROUP_BY_ATTR_VALUE_DN = (ULONG($8C1A) shl 16) or PT_STRING8;
PR_EMS_AB_GROUP_BY_ATTR_VALUE_DN_O = (ULONG($8C1A) shl 16) or PT_OBJECT; 
PR_EMS_AB_GROUP_BY_ATTR_VALUE_STR = (ULONG($8C19) shl 16) or PT_STRING8; 
PR_EMS_AB_GWART_LAST_MODIFIED = (ULONG($80B4) shl 16) or PT_SYSTIME; 
PR_EMS_AB_HAS_FULL_REPLICA_NCS = (ULONG($80B5) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_HAS_FULL_REPLICA_NCS_O = (ULONG($80B5) shl 16) or PT_OBJECT; 
PR_EMS_AB_HAS_MASTER_NCS = (ULONG($80B6) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_HAS_MASTER_NCS_O = (ULONG($80B6) shl 16) or PT_OBJECT; 
PR_EMS_AB_HELP_DATA16 = (ULONG($803A) shl 16) or PT_BINARY; 
PR_EMS_AB_HELP_DATA32 = (ULONG($8010) shl 16) or PT_BINARY; 
PR_EMS_AB_HELP_FILE_NAME = (ULONG($803B) shl 16) or PT_STRING8; 
PR_EMS_AB_HEURISTICS = (ULONG($80B7) shl 16) or PT_LONG;
PR_EMS_AB_HIDE_DL_MEMBERSHIP = (ULONG($80B8) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_HIDE_FROM_ADDRESS_BOOK = (ULONG($80B9) shl 16) or PT_BOOLEAN;
PR_EMS_AB_HIERARCHY_PATH = (ULONG($FFF9) shl 16) or PT_STRING8; 
PR_EMS_AB_HOME_MDB = (ULONG($8006) shl 16) or PT_STRING8; 
PR_EMS_AB_HOME_MDB_BL = (ULONG($8014) shl 16) or PT_MV_STRING8;
PR_EMS_AB_HOME_MDB_BL_O = (ULONG($8014) shl 16) or PT_OBJECT;
PR_EMS_AB_HOME_MDB_O = (ULONG($8006) shl 16) or PT_OBJECT;
PR_EMS_AB_HOME_MTA = (ULONG($8007) shl 16) or PT_STRING8; 
PR_EMS_AB_HOME_MTA_O = (ULONG($8007) shl 16) or PT_OBJECT; 
PR_EMS_AB_HOME_PUBLIC_SERVER = (ULONG($803F) shl 16) or PT_STRING8;
PR_EMS_AB_HOME_PUBLIC_SERVER_O = (ULONG($803F) shl 16) or PT_OBJECT; 
PR_EMS_AB_HOUSE_IDENTIFIER = (ULONG($8C54) shl 16) or PT_STRING8; 
PR_EMS_AB_HTTP_PUB_AB_ATTRIBUTES = (ULONG($81A9) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_HTTP_PUB_GAL = (ULONG($819B) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_HTTP_PUB_GAL_LIMIT = (ULONG($819C) shl 16) or PT_LONG; 
PR_EMS_AB_HTTP_PUB_PF = (ULONG($819E) shl 16) or PT_MV_BINARY;
PR_EMS_AB_HTTP_SERVERS = (ULONG($81AB) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_IMPORT_CONTAINER = (ULONG($80BA) shl 16) or PT_STRING8; 
PR_EMS_AB_IMPORT_CONTAINER_O = (ULONG($80BA) shl 16) or PT_OBJECT; 
PR_EMS_AB_IMPORT_SENSITIVITY = (ULONG($80BB) shl 16) or PT_LONG; 
PR_EMS_AB_IMPORTED_FROM = (ULONG($8042) shl 16) or PT_STRING8; 
PR_EMS_AB_INBOUND_ACCEPT_ALL = (ULONG($8C20) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_INBOUND_DN = (ULONG($8C1E) shl 16) or PT_STRING8; 
PR_EMS_AB_INBOUND_DN_O = (ULONG($8C1E) shl 16) or PT_OBJECT;
PR_EMS_AB_INBOUND_HOST = (ULONG($818E) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_INBOUND_NEWSFEED = (ULONG($8193) shl 16) or PT_STRING8; 
PR_EMS_AB_INBOUND_NEWSFEED_TYPE = (ULONG($8C1F) shl 16) or PT_BOOLEAN;
PR_EMS_AB_INBOUND_SITES = (ULONG($80BC) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_INBOUND_SITES_O = (ULONG($80BC) shl 16) or PT_OBJECT; 
PR_EMS_AB_INCOMING_MSG_SIZE_LIMIT = (ULONG($8190) shl 16) or PT_LONG;
PR_EMS_AB_INCOMING_PASSWORD = (ULONG($81AF) shl 16) or PT_BINARY; 
PR_EMS_AB_INSADMIN = (ULONG($81C5) shl 16) or PT_STRING8; 
PR_EMS_AB_INSADMIN_O = (ULONG($81C5) shl 16) or PT_OBJECT; 
PR_EMS_AB_INSTANCE_TYPE = (ULONG($80BD) shl 16) or PT_LONG; 
PR_EMS_AB_INTERNATIONAL_ISDN_NUMBER = (ULONG($80BE) shl 16) or PT_MV_STRING8;
PR_EMS_AB_INVOCATION_ID = (ULONG($80BF) shl 16) or PT_BINARY; 
PR_EMS_AB_IS_DELETED = (ULONG($80C0) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_IS_MASTER = (ULONG($FFFB) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_IS_MEMBER_OF_DL = (ULONG($8008) shl 16) or PT_OBJECT; 
PR_EMS_AB_IS_MEMBER_OF_DL_T = (ULONG($8008) shl 16) or PT_STRING8;
PR_EMS_AB_IS_SINGLE_VALUED = (ULONG($80C1) shl 16) or PT_BOOLEAN;
PR_EMS_AB_KCC_STATUS = (ULONG($80C2) shl 16) or PT_MV_BINARY;
PR_EMS_AB_KM_SERVER = (ULONG($800D) shl 16) or PT_STRING8; 
PR_EMS_AB_KM_SERVER_O = (ULONG($800D) shl 16) or PT_OBJECT;
PR_EMS_AB_KNOWLEDGE_INFORMATION = (ULONG($80C3) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_LABELEDURI = (ULONG($8C51) shl 16) or PT_STRING8; 
PR_EMS_AB_LANGUAGE = (ULONG($8178) shl 16) or PT_LONG; 
PR_EMS_AB_LANGUAGE_ISO639 = (ULONG($8C6C) shl 16) or PT_STRING8; 
PR_EMS_AB_LDAP_DISPLAY_NAME = (ULONG($8171) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_LDAP_SEARCH_CFG = (ULONG($8C1D) shl 16) or PT_LONG; 
PR_EMS_AB_LINE_WRAP = (ULONG($80C4) shl 16) or PT_LONG; 
PR_EMS_AB_LINK_ID = (ULONG($80C5) shl 16) or PT_LONG; 
PR_EMS_AB_LIST_PUBLIC_FOLDERS = (ULONG($8C50) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_LOCAL_BRIDGE_HEAD = (ULONG($80C6) shl 16) or PT_STRING8;
PR_EMS_AB_LOCAL_BRIDGE_HEAD_ADDRESS = (ULONG($80C7) shl 16) or PT_STRING8; 
PR_EMS_AB_LOCAL_INITIAL_TURN = (ULONG($80C8) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_LOCAL_SCOPE = (ULONG($80C9) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_LOCAL_SCOPE_O = (ULONG($80C9) shl 16) or PT_OBJECT;
PR_EMS_AB_LOG_FILENAME = (ULONG($80CA) shl 16) or PT_STRING8;
PR_EMS_AB_LOG_ROLLOVER_INTERVAL = (ULONG($80CB) shl 16) or PT_LONG; 
PR_EMS_AB_MAIL_DROP = (ULONG($8C63) shl 16) or PT_STRING8; 
PR_EMS_AB_MAINTAIN_AUTOREPLY_HISTORY = (ULONG($80CC) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_MANAGER = (ULONG($8005) shl 16) or PT_OBJECT; 
PR_EMS_AB_MANAGER_T = (ULONG($8005) shl 16) or PT_STRING8; 
PR_EMS_AB_MAPI_DISPLAY_TYPE = (ULONG($80CD) shl 16) or PT_LONG; 
PR_EMS_AB_MAPI_ID = (ULONG($80CE) shl 16) or PT_LONG; 
PR_EMS_AB_MAXIMUM_OBJECT_ID = (ULONG($8169) shl 16) or PT_BINARY; 
PR_EMS_AB_MDB_BACKOFF_INTERVAL = (ULONG($80CF) shl 16) or PT_LONG;
PR_EMS_AB_MDB_MSG_TIME_OUT_PERIOD = (ULONG($80D0) shl 16) or PT_LONG; 
PR_EMS_AB_MDB_OVER_QUOTA_LIMIT = (ULONG($80D1) shl 16) or PT_LONG;
PR_EMS_AB_MDB_STORAGE_QUOTA = (ULONG($80D2) shl 16) or PT_LONG;
PR_EMS_AB_MDB_UNREAD_LIMIT = (ULONG($80D3) shl 16) or PT_LONG; 
PR_EMS_AB_MDB_USE_DEFAULTS = (ULONG($80D4) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_MEMBER = (ULONG($8009) shl 16) or PT_OBJECT; 
PR_EMS_AB_MEMBER_T = (ULONG($8009) shl 16) or PT_STRING8;
PR_EMS_AB_MESSAGE_TRACKING_ENABLED = (ULONG($80D5) shl 16) or PT_BOOLEAN;
PR_EMS_AB_MIME_TYPES = (ULONG($8C1C) shl 16) or PT_BINARY;
PR_EMS_AB_MODERATED = (ULONG($81AC) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_MODERATOR = (ULONG($8199) shl 16) or PT_STRING8; 
PR_EMS_AB_MONITOR_CLOCK = (ULONG($80D6) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_MONITOR_SERVERS = (ULONG($80D7) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_MONITOR_SERVICES = (ULONG($80D8) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_MONITORED_CONFIGURATIONS = (ULONG($80D9) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_MONITORED_CONFIGURATIONS_O = (ULONG($80D9) shl 16) or PT_OBJECT; 
PR_EMS_AB_MONITORED_SERVERS = (ULONG($80DA) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_MONITORED_SERVERS_O = (ULONG($80DA) shl 16) or PT_OBJECT;
PR_EMS_AB_MONITORED_SERVICES = (ULONG($80DB) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_MONITORING_ALERT_DELAY = (ULONG($80DC) shl 16) or PT_LONG; 
PR_EMS_AB_MONITORING_ALERT_UNITS = (ULONG($80DD) shl 16) or PT_LONG; 
PR_EMS_AB_MONITORING_AVAILABILITY_STYLE = (ULONG($80DE) shl 16) or PT_LONG; 
PR_EMS_AB_MONITORING_AVAILABILITY_WINDOW = (ULONG($80DF) shl 16) or PT_BINARY; 
PR_EMS_AB_MONITORING_CACHED_VIA_MAIL = (ULONG($80E0) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_MONITORING_CACHED_VIA_MAIL_O = (ULONG($80E0) shl 16) or PT_OBJECT; 
PR_EMS_AB_MONITORING_CACHED_VIA_RPC = (ULONG($80E1) shl 16) or PT_MV_STRING8;
PR_EMS_AB_MONITORING_CACHED_VIA_RPC_O = (ULONG($80E1) shl 16) or PT_OBJECT; 
PR_EMS_AB_MONITORING_ESCALATION_PROCEDURE = (ULONG($80E2) shl 16) or PT_MV_BINARY; 
PR_EMS_AB_MONITORING_HOTSITE_POLL_INTERVAL = (ULONG($80E3) shl 16) or PT_LONG; 
PR_EMS_AB_MONITORING_HOTSITE_POLL_UNITS = (ULONG($80E4) shl 16) or PT_LONG;
PR_EMS_AB_MONITORING_MAIL_UPDATE_INTERVAL = (ULONG($80E5) shl 16) or PT_LONG; 
PR_EMS_AB_MONITORING_MAIL_UPDATE_UNITS = (ULONG($80E6) shl 16) or PT_LONG; 
PR_EMS_AB_MONITORING_NORMAL_POLL_INTERVAL = (ULONG($80E7) shl 16) or PT_LONG;
PR_EMS_AB_MONITORING_NORMAL_POLL_UNITS = (ULONG($80E8) shl 16) or PT_LONG; 
PR_EMS_AB_MONITORING_RECIPIENTS = (ULONG($80E9) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_MONITORING_RECIPIENTS_NDR = (ULONG($80EA) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_MONITORING_RECIPIENTS_NDR_O = (ULONG($80EA) shl 16) or PT_OBJECT;
PR_EMS_AB_MONITORING_RECIPIENTS_O = (ULONG($80E9) shl 16) or PT_OBJECT;
PR_EMS_AB_MONITORING_RPC_UPDATE_INTERVAL = (ULONG($80EB) shl 16) or PT_LONG;
PR_EMS_AB_MONITORING_RPC_UPDATE_UNITS = (ULONG($80EC) shl 16) or PT_LONG;
PR_EMS_AB_MONITORING_WARNING_DELAY = (ULONG($80ED) shl 16) or PT_LONG;
PR_EMS_AB_MONITORING_WARNING_UNITS = (ULONG($80EE) shl 16) or PT_LONG;
PR_EMS_AB_MTA_LOCAL_CRED = (ULONG($80EF) shl 16) or PT_STRING8;
PR_EMS_AB_MTA_LOCAL_DESIG = (ULONG($80F0) shl 16) or PT_STRING8;
PR_EMS_AB_N_ADDRESS = (ULONG($80F1) shl 16) or PT_BINARY;
PR_EMS_AB_N_ADDRESS_TYPE = (ULONG($80F2) shl 16) or PT_LONG;
PR_EMS_AB_NETWORK_ADDRESS = (ULONG($8170) shl 16) or PT_MV_STRING8;
PR_EMS_AB_NEWSFEED_TYPE = (ULONG($8194) shl 16) or PT_LONG; 
PR_EMS_AB_NEWSGROUP = (ULONG($8198) shl 16) or PT_STRING8; 
PR_EMS_AB_NEWSGROUP_LIST = (ULONG($8196) shl 16) or PT_BINARY;
PR_EMS_AB_NNTP_CHARACTER_SET = (ULONG($817D) shl 16) or PT_STRING8; 
PR_EMS_AB_NNTP_CONTENT_FORMAT = (ULONG($8176) shl 16) or PT_STRING8; 
PR_EMS_AB_NNTP_DISTRIBUTIONS = (ULONG($8197) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_NNTP_DISTRIBUTIONS_FLAG = (ULONG($81A4) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_NNTP_NEWSFEEDS = (ULONG($81A6) shl 16) or PT_MV_STRING8;
PR_EMS_AB_NNTP_NEWSFEEDS_O = (ULONG($81A6) shl 16) or PT_OBJECT; 
PR_EMS_AB_NT_MACHINE_NAME = (ULONG($80F3) shl 16) or PT_STRING8; 
PR_EMS_AB_NT_SECURITY_DESCRIPTOR = (ULONG($8013) shl 16) or PT_BINARY; 
PR_EMS_AB_NUM_OF_OPEN_RETRIES = (ULONG($80F4) shl 16) or PT_LONG; 
PR_EMS_AB_NUM_OF_TRANSFER_RETRIES = (ULONG($80F5) shl 16) or PT_LONG;
PR_EMS_AB_OBJ_DIST_NAME = (ULONG($803C) shl 16) or PT_STRING8;
PR_EMS_AB_OBJ_DIST_NAME_O = (ULONG($803C) shl 16) or PT_OBJECT; 
PR_EMS_AB_OBJ_VIEW_CONTAINERS = (ULONG($81C7) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_OBJ_VIEW_CONTAINERS_O = (ULONG($81C7) shl 16) or PT_OBJECT; 
PR_EMS_AB_OBJECT_CLASS_CATEGORY = (ULONG($80F6) shl 16) or PT_LONG;
PR_EMS_AB_OBJECT_OID = (ULONG($FFFA) shl 16) or PT_BINARY; 
PR_EMS_AB_OBJECT_VERSION = (ULONG($80F7) shl 16) or PT_LONG; 
PR_EMS_AB_OFF_LINE_AB_CONTAINERS = (ULONG($80F8) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_OFF_LINE_AB_CONTAINERS_O = (ULONG($80F8) shl 16) or PT_OBJECT; 
PR_EMS_AB_OFF_LINE_AB_SCHEDULE = (ULONG($80F9) shl 16) or PT_BINARY; 
PR_EMS_AB_OFF_LINE_AB_SERVER = (ULONG($80FA) shl 16) or PT_STRING8;
PR_EMS_AB_OFF_LINE_AB_SERVER_O = (ULONG($80FA) shl 16) or PT_OBJECT;
PR_EMS_AB_OFF_LINE_AB_STYLE = (ULONG($80FB) shl 16) or PT_LONG; 
PR_EMS_AB_OID_TYPE = (ULONG($80FC) shl 16) or PT_LONG;
PR_EMS_AB_OM_OBJECT_CLASS = (ULONG($80FD) shl 16) or PT_BINARY; 
PR_EMS_AB_OM_SYNTAX = (ULONG($80FE) shl 16) or PT_LONG; 
PR_EMS_AB_OOF_REPLY_TO_ORIGINATOR = (ULONG($80FF) shl 16) or PT_BOOLEAN;
PR_EMS_AB_OPEN_RETRY_INTERVAL = (ULONG($8100) shl 16) or PT_LONG;
PR_EMS_AB_ORGANIZATION_NAME = (ULONG($8101) shl 16) or PT_MV_STRING8;
PR_EMS_AB_ORGANIZATIONAL_UNIT_NAME = (ULONG($8102) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_ORIGINAL_DISPLAY_TABLE = (ULONG($8103) shl 16) or PT_BINARY; 
PR_EMS_AB_ORIGINAL_DISPLAY_TABLE_MSDOS = (ULONG($8104) shl 16) or PT_BINARY; 
PR_EMS_AB_OTHER_RECIPS = (ULONG($F000) shl 16) or PT_OBJECT;
PR_EMS_AB_OUTBOUND_HOST = (ULONG($818D) shl 16) or PT_BINARY; 
PR_EMS_AB_OUTBOUND_HOST_TYPE = (ULONG($81B0) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_OUTBOUND_NEWSFEED = (ULONG($8195) shl 16) or PT_STRING8; 
PR_EMS_AB_OUTBOUND_SITES = (ULONG($8105) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_OUTBOUND_SITES_O = (ULONG($8105) shl 16) or PT_OBJECT; 
PR_EMS_AB_OUTGOING_MSG_SIZE_LIMIT = (ULONG($818F) shl 16) or PT_LONG;
PR_EMS_AB_OVERRIDE_NNTP_CONTENT_FORMAT = (ULONG($81C6) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_OWA_SERVER = (ULONG($8C66) shl 16) or PT_STRING8;
PR_EMS_AB_OWNER = (ULONG($800C) shl 16) or PT_STRING8; 
PR_EMS_AB_OWNER_BL = (ULONG($8024) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_OWNER_BL_O = (ULONG($8024) shl 16) or PT_OBJECT; 
PR_EMS_AB_OWNER_O = (ULONG($800C) shl 16) or PT_OBJECT;
PR_EMS_AB_P_SELECTOR = (ULONG($8106) shl 16) or PT_BINARY;
PR_EMS_AB_P_SELECTOR_INBOUND = (ULONG($8107) shl 16) or PT_BINARY; 
PR_EMS_AB_PARENT_ENTRYID = (ULONG($FFFC) shl 16) or PT_BINARY; 
PR_EMS_AB_PER_MSG_DIALOG_DISPLAY_TABLE = (ULONG($8108) shl 16) or PT_BINARY; 
PR_EMS_AB_PER_RECIP_DIALOG_DISPLAY_TABLE = (ULONG($8109) shl 16) or PT_BINARY;
PR_EMS_AB_PERIOD_REP_SYNC_TIMES = (ULONG($810A) shl 16) or PT_BINARY;
PR_EMS_AB_PERIOD_REPL_STAGGER = (ULONG($810B) shl 16) or PT_LONG; 
PR_EMS_AB_PERSONAL_TITLE = (ULONG($8C6B) shl 16) or PT_STRING8; 
PR_EMS_AB_PF_CONTACTS = (ULONG($8038) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_PF_CONTACTS_O = (ULONG($8038) shl 16) or PT_OBJECT; 
PR_EMS_AB_POP_CHARACTER_SET = (ULONG($8179) shl 16) or PT_STRING8; 
PR_EMS_AB_POP_CONTENT_FORMAT = (ULONG($8177) shl 16) or PT_STRING8;
PR_EMS_AB_PORT_NUMBER = (ULONG($81B5) shl 16) or PT_LONG; 
PR_EMS_AB_POSTAL_ADDRESS = (ULONG($810C) shl 16) or PT_MV_BINARY; 
PR_EMS_AB_PREFERRED_DELIVERY_METHOD = (ULONG($810D) shl 16) or PT_MV_LONG; 
PR_EMS_AB_PRESERVE_INTERNET_CONTENT = (ULONG($8C22) shl 16) or PT_BOOLEAN;
PR_EMS_AB_PRMD = (ULONG($810E) shl 16) or PT_STRING8;
PR_EMS_AB_PROMO_EXPIRATION = (ULONG($81C2) shl 16) or PT_SYSTIME;
PR_EMS_AB_PROTOCOL_SETTINGS = (ULONG($81B6) shl 16) or PT_MV_STRING8;
PR_EMS_AB_PROXY_ADDRESSES = (ULONG($800F) shl 16) or PT_MV_STRING8;
PR_EMS_AB_PROXY_ADDRESSES_A = (ULONG($800F) shl 16) or PT_MV_STRING8;
PR_EMS_AB_PROXY_ADDRESSES_W = (ULONG($800F) shl 16) or PT_MV_UNICODE;
PR_EMS_AB_PROXY_GENERATION_ENABLED = (ULONG($81B1) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_PROXY_GENERATOR_DLL = (ULONG($810F) shl 16) or PT_STRING8; 
PR_EMS_AB_PUBLIC_DELEGATES = (ULONG($8015) shl 16) or PT_OBJECT;
PR_EMS_AB_PUBLIC_DELEGATES_BL = (ULONG($8110) shl 16) or PT_MV_STRING8;
PR_EMS_AB_PUBLIC_DELEGATES_BL_O = (ULONG($8110) shl 16) or PT_OBJECT; 
PR_EMS_AB_PUBLIC_DELEGATES_T = (ULONG($8015) shl 16) or PT_STRING8; 
PR_EMS_AB_QUOTA_NOTIFICATION_SCHEDULE = (ULONG($8111) shl 16) or PT_BINARY; 
PR_EMS_AB_QUOTA_NOTIFICATION_STYLE = (ULONG($8112) shl 16) or PT_LONG; 
PR_EMS_AB_RANGE_LOWER = (ULONG($8113) shl 16) or PT_LONG; 
PR_EMS_AB_RANGE_UPPER = (ULONG($8114) shl 16) or PT_LONG;
PR_EMS_AB_RAS_ACCOUNT = (ULONG($81AD) shl 16) or PT_STRING8; 
PR_EMS_AB_RAS_CALLBACK_NUMBER = (ULONG($8115) shl 16) or PT_STRING8; 
PR_EMS_AB_RAS_PASSWORD = (ULONG($81AE) shl 16) or PT_BINARY; 
PR_EMS_AB_RAS_PHONE_NUMBER = (ULONG($8116) shl 16) or PT_STRING8; 
PR_EMS_AB_RAS_PHONEBOOK_ENTRY_NAME = (ULONG($8117) shl 16) or PT_STRING8; 
PR_EMS_AB_RAS_REMOTE_SRVR_NAME = (ULONG($8118) shl 16) or PT_STRING8;
PR_EMS_AB_REFERRAL_LIST = (ULONG($81A3) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_REGISTERED_ADDRESS = (ULONG($8119) shl 16) or PT_MV_BINARY; 
PR_EMS_AB_REMOTE_BRIDGE_HEAD = (ULONG($811A) shl 16) or PT_STRING8; 
PR_EMS_AB_REMOTE_BRIDGE_HEAD_ADDRESS = (ULONG($811B) shl 16) or PT_STRING8;
PR_EMS_AB_REMOTE_OUT_BH_SERVER = (ULONG($811C) shl 16) or PT_STRING8; 
PR_EMS_AB_REMOTE_OUT_BH_SERVER_O = (ULONG($811C) shl 16) or PT_OBJECT;
PR_EMS_AB_REMOTE_SITE = (ULONG($811D) shl 16) or PT_STRING8; 
PR_EMS_AB_REMOTE_SITE_O = (ULONG($811D) shl 16) or PT_OBJECT; 
PR_EMS_AB_REPLICATED_OBJECT_VERSION = (ULONG($8C62) shl 16) or PT_LONG; 
PR_EMS_AB_REPLICATION_MAIL_MSG_SIZE = (ULONG($8168) shl 16) or PT_LONG; 
PR_EMS_AB_REPLICATION_SENSITIVITY = (ULONG($811E) shl 16) or PT_LONG;
PR_EMS_AB_REPLICATION_STAGGER = (ULONG($811F) shl 16) or PT_LONG;
PR_EMS_AB_REPORT_TO_ORIGINATOR = (ULONG($8120) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_REPORT_TO_OWNER = (ULONG($8121) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_REPORTS = (ULONG($800E) shl 16) or PT_OBJECT; 
PR_EMS_AB_REPORTS_T = (ULONG($800E) shl 16) or PT_OBJECT;
PR_EMS_AB_REQ_SEQ = (ULONG($8122) shl 16) or PT_LONG;
PR_EMS_AB_REQUIRE_SSL = (ULONG($8C25) shl 16) or PT_BOOLEAN;
PR_EMS_AB_RESPONSIBLE_LOCAL_DXA = (ULONG($8123) shl 16) or PT_STRING8; 
PR_EMS_AB_RESPONSIBLE_LOCAL_DXA_O = (ULONG($8123) shl 16) or PT_OBJECT; 
PR_EMS_AB_RETURN_EXACT_MSG_SIZE = (ULONG($8C52) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_RID_SERVER = (ULONG($8124) shl 16) or PT_STRING8; 
PR_EMS_AB_RID_SERVER_O = (ULONG($8124) shl 16) or PT_OBJECT; 
PR_EMS_AB_ROLE_OCCUPANT = (ULONG($8125) shl 16) or PT_MV_STRING8;
PR_EMS_AB_ROLE_OCCUPANT_O = (ULONG($8125) shl 16) or PT_OBJECT; 
PR_EMS_AB_ROOT_NEWSGROUPS_FOLDER_ID = (ULONG($81B2) shl 16) or PT_BINARY; 
PR_EMS_AB_ROUTING_LIST = (ULONG($8126) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_RTS_CHECKPOINT_SIZE = (ULONG($8127) shl 16) or PT_LONG; 
PR_EMS_AB_RTS_RECOVERY_TIMEOUT = (ULONG($8128) shl 16) or PT_LONG; 
PR_EMS_AB_RTS_WINDOW_SIZE = (ULONG($8129) shl 16) or PT_LONG;
PR_EMS_AB_RUNS_ON = (ULONG($812A) shl 16) or PT_MV_STRING8;
PR_EMS_AB_RUNS_ON_O = (ULONG($812A) shl 16) or PT_OBJECT; 
PR_EMS_AB_S_SELECTOR = (ULONG($812B) shl 16) or PT_BINARY; 
PR_EMS_AB_S_SELECTOR_INBOUND = (ULONG($812C) shl 16) or PT_BINARY; 
PR_EMS_AB_SCHEMA_FLAGS = (ULONG($8173) shl 16) or PT_LONG;
PR_EMS_AB_SCHEMA_VERSION = (ULONG($817C) shl 16) or PT_MV_LONG;
PR_EMS_AB_SEARCH_FLAGS = (ULONG($812D) shl 16) or PT_LONG; 
PR_EMS_AB_SEARCH_GUIDE = (ULONG($812E) shl 16) or PT_MV_BINARY; 
PR_EMS_AB_SECURITY_POLICY = (ULONG($8C47) shl 16) or PT_MV_BINARY; 
PR_EMS_AB_SECURITY_PROTOCOL = (ULONG($8037) shl 16) or PT_MV_BINARY; 
PR_EMS_AB_SEE_ALSO = (ULONG($812F) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_SEE_ALSO_O = (ULONG($812F) shl 16) or PT_OBJECT;
PR_EMS_AB_SEND_EMAIL_MESSAGE = (ULONG($8C31) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_SEND_TNEF = (ULONG($8191) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_SERIAL_NUMBER = (ULONG($8130) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_SERVER = (ULONG($FFFE) shl 16) or PT_STRING8;
PR_EMS_AB_SERVICE_ACTION_FIRST = (ULONG($8131) shl 16) or PT_LONG; 
PR_EMS_AB_SERVICE_ACTION_OTHER = (ULONG($8132) shl 16) or PT_LONG;
PR_EMS_AB_SERVICE_ACTION_SECOND = (ULONG($8133) shl 16) or PT_LONG; 
PR_EMS_AB_SERVICE_RESTART_DELAY = (ULONG($8134) shl 16) or PT_LONG; 
PR_EMS_AB_SERVICE_RESTART_MESSAGE = (ULONG($8135) shl 16) or PT_STRING8;
PR_EMS_AB_SESSION_DISCONNECT_TIMER = (ULONG($8136) shl 16) or PT_LONG;
PR_EMS_AB_SITE_AFFINITY = (ULONG($8137) shl 16) or PT_MV_STRING8;
PR_EMS_AB_SITE_FOLDER_GUID = (ULONG($8166) shl 16) or PT_BINARY;
PR_EMS_AB_SITE_FOLDER_SERVER = (ULONG($8167) shl 16) or PT_STRING8; 
PR_EMS_AB_SITE_FOLDER_SERVER_O = (ULONG($8167) shl 16) or PT_OBJECT; 
PR_EMS_AB_SITE_PROXY_SPACE = (ULONG($8138) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_SMIME_ALG_LIST_NA = (ULONG($8C33) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_SMIME_ALG_LIST_OTHER = (ULONG($8C34) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_SMIME_ALG_SELECTED_NA = (ULONG($8C35) shl 16) or PT_STRING8;
PR_EMS_AB_SMIME_ALG_SELECTED_OTHER = (ULONG($8C36) shl 16) or PT_STRING8; 
PR_EMS_AB_SPACE_LAST_COMPUTED = (ULONG($8139) shl 16) or PT_SYSTIME; 
PR_EMS_AB_STREET_ADDRESS = (ULONG($813A) shl 16) or PT_STRING8; 
PR_EMS_AB_SUB_REFS = (ULONG($813B) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_SUB_REFS_O = (ULONG($813B) shl 16) or PT_OBJECT; 
PR_EMS_AB_SUB_SITE = (ULONG($817B) shl 16) or PT_STRING8;
PR_EMS_AB_SUBMISSION_CONT_LENGTH = (ULONG($813C) shl 16) or PT_LONG; 
PR_EMS_AB_SUPPORT_SMIME_SIGNATURES = (ULONG($8C48) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_SUPPORTED_ALGORITHMS = (ULONG($8C55) shl 16) or PT_BINARY; 
PR_EMS_AB_SUPPORTED_APPLICATION_CONTEXT = (ULONG($813D) shl 16) or PT_MV_BINARY;
PR_EMS_AB_SUPPORTING_STACK = (ULONG($813E) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_SUPPORTING_STACK_BL = (ULONG($813F) shl 16) or PT_MV_STRING8;
PR_EMS_AB_SUPPORTING_STACK_BL_O = (ULONG($813F) shl 16) or PT_OBJECT; 
PR_EMS_AB_SUPPORTING_STACK_O = (ULONG($813E) shl 16) or PT_OBJECT; 
PR_EMS_AB_T_SELECTOR = (ULONG($8140) shl 16) or PT_BINARY;
PR_EMS_AB_T_SELECTOR_INBOUND = (ULONG($8141) shl 16) or PT_BINARY; 
PR_EMS_AB_TAGGED_X509_CERT = (ULONG($8C6A) shl 16) or PT_MV_BINARY; 
PR_EMS_AB_TARGET_ADDRESS = (ULONG($8011) shl 16) or PT_STRING8;
PR_EMS_AB_TARGET_MTAS = (ULONG($8142) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_TELEPHONE_NUMBER = (ULONG($8012) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_TELEPHONE_PERSONAL_PAGER = (ULONG($8C68) shl 16) or PT_STRING8;
PR_EMS_AB_TELETEX_TERMINAL_IDENTIFIER = (ULONG($8143) shl 16) or PT_MV_BINARY; 
PR_EMS_AB_TEMP_ASSOC_THRESHOLD = (ULONG($8144) shl 16) or PT_LONG; 
PR_EMS_AB_TOMBSTONE_LIFETIME = (ULONG($8145) shl 16) or PT_LONG;
PR_EMS_AB_TRACKING_LOG_PATH_NAME = (ULONG($8146) shl 16) or PT_STRING8; 
PR_EMS_AB_TRANS_RETRY_MINS = (ULONG($8147) shl 16) or PT_LONG;
PR_EMS_AB_TRANS_TIMEOUT_MINS = (ULONG($8148) shl 16) or PT_LONG;
PR_EMS_AB_TRANSFER_RETRY_INTERVAL = (ULONG($8149) shl 16) or PT_LONG;
PR_EMS_AB_TRANSFER_TIMEOUT_NON_URGENT = (ULONG($814A) shl 16) or PT_LONG; 
PR_EMS_AB_TRANSFER_TIMEOUT_NORMAL = (ULONG($814B) shl 16) or PT_LONG;
PR_EMS_AB_TRANSFER_TIMEOUT_URGENT = (ULONG($814C) shl 16) or PT_LONG; 
PR_EMS_AB_TRANSLATION_TABLE_USED = (ULONG($814D) shl 16) or PT_LONG;
PR_EMS_AB_TRANSPORT_EXPEDITED_DATA = (ULONG($814E) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_TRUST_LEVEL = (ULONG($814F) shl 16) or PT_LONG; 
PR_EMS_AB_TURN_REQUEST_THRESHOLD = (ULONG($8150) shl 16) or PT_LONG; 
PR_EMS_AB_TWO_WAY_ALTERNATE_FACILITY = (ULONG($8151) shl 16) or PT_BOOLEAN;
PR_EMS_AB_TYPE = (ULONG($8C38) shl 16) or PT_STRING8; 
PR_EMS_AB_UNAUTH_ORIG_BL = (ULONG($8152) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_UNAUTH_ORIG_BL_O = (ULONG($8152) shl 16) or PT_OBJECT; 
PR_EMS_AB_USE_SERVER_VALUES = (ULONG($817E) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_USE_SITE_VALUES = (ULONG($8183) shl 16) or PT_BOOLEAN; 
PR_EMS_AB_USENET_SITE_NAME = (ULONG($8189) shl 16) or PT_STRING8;
PR_EMS_AB_USER_PASSWORD = (ULONG($8153) shl 16) or PT_MV_BINARY; 
PR_EMS_AB_USN_CHANGED = (ULONG($8029) shl 16) or PT_LONG; 
PR_EMS_AB_USN_CREATED = (ULONG($8154) shl 16) or PT_LONG;
PR_EMS_AB_USN_DSA_LAST_OBJ_REMOVED = (ULONG($8155) shl 16) or PT_LONG; 
PR_EMS_AB_USN_INTERSITE = (ULONG($817A) shl 16) or PT_LONG; 
PR_EMS_AB_USN_LAST_OBJ_REM = (ULONG($8156) shl 16) or PT_LONG;
PR_EMS_AB_USN_SOURCE = (ULONG($8157) shl 16) or PT_LONG; 
PR_EMS_AB_VIEW_CONTAINER_1 = (ULONG($81BF) shl 16) or PT_STRING8; 
PR_EMS_AB_VIEW_CONTAINER_2 = (ULONG($81C0) shl 16) or PT_STRING8; 
PR_EMS_AB_VIEW_CONTAINER_3 = (ULONG($81C1) shl 16) or PT_STRING8; 
PR_EMS_AB_VIEW_DEFINITION = (ULONG($8C1B) shl 16) or PT_MV_BINARY; 
PR_EMS_AB_VIEW_FLAGS = (ULONG($8C18) shl 16) or PT_LONG;
PR_EMS_AB_VIEW_SITE = (ULONG($81BE) shl 16) or PT_STRING8; 
PR_EMS_AB_VOICE_MAIL_FLAGS = (ULONG($8C40) shl 16) or PT_MV_BINARY;
PR_EMS_AB_VOICE_MAIL_GREETINGS = (ULONG($8C3F) shl 16) or PT_MV_STRING8; 
PR_EMS_AB_VOICE_MAIL_PASSWORD = (ULONG($8C3D) shl 16) or PT_STRING8; 
PR_EMS_AB_VOICE_MAIL_RECORDED_NAME = (ULONG($8C3E) shl 16) or PT_BINARY;
PR_EMS_AB_VOICE_MAIL_RECORDING_LENGTH = (ULONG($8C43) shl 16) or PT_MV_LONG;
PR_EMS_AB_VOICE_MAIL_SPEED = (ULONG($8C42) shl 16) or PT_LONG;
PR_EMS_AB_VOICE_MAIL_SYSTEM_GUID = (ULONG($8C3B) shl 16) or PT_BINARY;
PR_EMS_AB_VOICE_MAIL_USER_ID = (ULONG($8C3C) shl 16) or PT_STRING8;
PR_EMS_AB_VOICE_MAIL_VOLUME = (ULONG($8C41) shl 16) or PT_LONG; 
PR_EMS_AB_WWW_HOME_PAGE = (ULONG($8175) shl 16) or PT_STRING8; 
PR_EMS_AB_X121_ADDRESS = (ULONG($8158) shl 16) or PT_MV_STRING8;
PR_EMS_AB_X25_CALL_USER_DATA_INCOMING = (ULONG($8159) shl 16) or PT_BINARY; 
PR_EMS_AB_X25_CALL_USER_DATA_OUTGOING = (ULONG($815A) shl 16) or PT_BINARY; 
PR_EMS_AB_X25_FACILITIES_DATA_INCOMING = (ULONG($815B) shl 16) or PT_BINARY; 
PR_EMS_AB_X25_FACILITIES_DATA_OUTGOING = (ULONG($815C) shl 16) or PT_BINARY; 
PR_EMS_AB_X25_LEASED_LINE_PORT = (ULONG($815D) shl 16) or PT_BINARY; 
PR_EMS_AB_X25_LEASED_OR_SWITCHED = (ULONG($815E) shl 16) or PT_BOOLEAN;
PR_EMS_AB_X25_REMOTE_MTA_PHONE = (ULONG($815F) shl 16) or PT_STRING8; 
PR_EMS_AB_X400_ATTACHMENT_TYPE = (ULONG($8160) shl 16) or PT_BINARY; 
PR_EMS_AB_X400_SELECTOR_SYNTAX = (ULONG($8161) shl 16) or PT_LONG; 
PR_EMS_AB_X500_ACCESS_CONTROL_LIST = (ULONG($8162) shl 16) or PT_BINARY;
PR_EMS_AB_X500_NC = (ULONG($81A2) shl 16) or PT_STRING8; 
PR_EMS_AB_X500_RDN = (ULONG($81A1) shl 16) or PT_STRING8;
PR_EMS_AB_XMIT_TIMEOUT_NON_URGENT = (ULONG($8163) shl 16) or PT_LONG; 
PR_EMS_AB_XMIT_TIMEOUT_NORMAL = (ULONG($8164) shl 16) or PT_LONG;
PR_EMS_AB_XMIT_TIMEOUT_URGENT = (ULONG($8165) shl 16) or PT_LONG;
PR_EVENTS_ROOT_FOLDER_ENTRYID = (($668A) shl 16) or PT_BINARY; 
PR_EXCESS_STORAGE_USED = (($3FF6) shl 16) or PT_LONG; 
PR_EXPIRY_NUMBER = (($3FED) shl 16) or PT_LONG;
PR_EXPIRY_UNITS = (($3FEE) shl 16) or PT_LONG; 
PR_EXTENDED_ACL_DATA = (($3FFE) shl 16) or PT_BINARY;
PR_FAST_TRANSFER = (($662F) shl 16) or PT_OBJECT; 
PR_FAVORITES_DEFAULT_NAME = (($6635) shl 16) or PT_STRING8; 
PR_FOLDER_CHILD_COUNT = (($6638) shl 16) or PT_LONG; 
PR_FOLDER_DESIGN_FLAGS = (($3FE2) shl 16) or PT_LONG;
PR_FOLDER_FLAGS = (($66A8) shl 16) or PT_LONG;
PR_FOLDER_PATHNAME = (($66B5) shl 16) or PT_STRING8; 
PR_FOREIGN_ID = (($6667) shl 16) or PT_BINARY; 
PR_FOREIGN_REPORT_ID = (($6668) shl 16) or PT_BINARY; 
PR_FOREIGN_SUBJECT_ID = (($6669) shl 16) or PT_BINARY; 
PR_FREE_BUSY_FOR_LOCAL_SITE_ENTRYID = (($6625) shl 16) or PT_BINARY;
PR_GW_ADMIN_OPERATIONS = (($6658) shl 16) or PT_LONG;
PR_GW_MTSIN_ENTRYID = (($6628) shl 16) or PT_BINARY;
PR_GW_MTSOUT_ENTRYID = (($6629) shl 16) or PT_BINARY; 
PR_HAS_DAMS = (($3FEA) shl 16) or PT_BOOLEAN; 
PR_HAS_MODERATOR_RULES = (($663F) shl 16) or PT_BOOLEAN; 
PR_HAS_NAMED_PROPERTIES = (($664A) shl 16) or PT_BOOLEAN;
PR_HAS_RULES = (($663A) shl 16) or PT_BOOLEAN;
PR_HIERARCHY_CHANGE_NUM = (($663E) shl 16) or PT_LONG; 
PR_HIERARCHY_SERVER = (($6623) shl 16) or PT_STRING8; 
PR_HIERARCHY_SYNCHRONIZER = (($662C) shl 16) or PT_OBJECT; 
PR_IMAP_INTERNAL_DATE = (($65F5) shl 16) or PT_SYSTIME; 
PR_IN_CONFLICT = (($666C) shl 16) or PT_BOOLEAN;
PR_IN_TRANSIT = (($6618) shl 16) or PT_BOOLEAN; 
PR_INBOUND_NEWSFEED_DN = (($668D) shl 16) or PT_STRING8; 
PR_INTERNAL_TRACE_INFO = (($666A) shl 16) or PT_BINARY; 
PR_INTERNET_CHARSET = (($669A) shl 16) or PT_STRING8; 
PR_INTERNET_CPID = (($3FDE) shl 16) or PT_LONG; 
PR_INTERNET_NEWSGROUP_NAME = (($66A7) shl 16) or PT_STRING8;
PR_IPM_DAF_ENTRYID = (($661F) shl 16) or PT_BINARY;
PR_IPM_FAVORITES_ENTRYID = (($6630) shl 16) or PT_BINARY; 
PR_IPM_PUBLIC_FOLDERS_ENTRYID = (($6631) shl 16) or PT_BINARY; 
PR_IS_NEWSGROUP = (($6697) shl 16) or PT_BOOLEAN; 
PR_IS_NEWSGROUP_ANCHOR = (($6696) shl 16) or PT_BOOLEAN; 
PR_LAST_ACCESS_TIME = (($66A9) shl 16) or PT_SYSTIME;
PR_LAST_FULL_BACKUP = (($6685) shl 16) or PT_SYSTIME;
PR_LAST_LOGOFF_TIME = (($66A3) shl 16) or PT_SYSTIME; 
PR_LAST_LOGON_TIME = (($66A2) shl 16) or PT_SYSTIME;
PR_LAST_MODIFIER_ENTRYID = (($3FFB) shl 16) or PT_BINARY;
PR_LAST_MODIFIER_NAME = (($3FFA) shl 16) or PT_STRING8; 
PR_LOCALE_ID = (($66A1) shl 16) or PT_LONG;
PR_LONGTERM_ENTRYID_FROM_TABLE = (($6670) shl 16) or PT_BINARY; 
PR_MAILBOX_OWNER_ENTRYID = (($661B) shl 16) or PT_BINARY; 
PR_MAILBOX_OWNER_NAME = (($661C) shl 16) or PT_STRING8;
PR_MEMBER_ENTRYID = (($0FFF) shl 16) or PT_BINARY; 
PR_MEMBER_ID = (($6671) shl 16) or PT_I8;
PR_MEMBER_NAME = (($6672) shl 16) or PT_STRING8;
PR_MEMBER_RIGHTS = (($6673) shl 16) or PT_LONG;
PR_MESSAGE_CODEPAGE = (($3FFD) shl 16) or PT_LONG; 
PR_MESSAGE_LOCALE_ID = (($3FF1) shl 16) or PT_LONG; 
PR_MESSAGE_PROCESSED = (($65E8) shl 16) or PT_BOOLEAN; 
PR_MESSAGE_SITE_NAME = (($65E7) shl 16) or PT_STRING8;
PR_MESSAGE_SIZE_EXTENDED = (($0E08) shl 16) or PT_I8; 
PR_MOVE_TO_FOLDER_ENTRYID = (($3FF4) shl 16) or PT_BINARY; 
PR_MOVE_TO_STORE_ENTRYID = (($3FF3) shl 16) or PT_BINARY; 
PR_MSG_BODY_ID = (($3FDD) shl 16) or PT_LONG; 
PR_MTS_ID = (($0047) shl 16) or PT_BINARY; 
PR_MTS_REPORT_ID = (($0047) shl 16) or PT_BINARY;
PR_MTS_SUBJECT_ID = (($6663) shl 16) or PT_BINARY; 
PR_NEW_SUBS_GET_AUTO_ADD = (($65E6) shl 16) or PT_BOOLEAN;
PR_NEWSFEED_INFO = (($66A6) shl 16) or PT_BINARY; 
PR_NEWSGROUP_COMPONENT = (($66A5) shl 16) or PT_STRING8;
PR_NEWSGROUP_ROOT_FOLDER_ENTRYID = (($668C) shl 16) or PT_BINARY; 
PR_NNTP_ARTICLE_FOLDER_ENTRYID = (($668A) shl 16) or PT_BINARY; 
PR_NNTP_CONTROL_FOLDER_ENTRYID = (($668B) shl 16) or PT_BINARY;
PR_NON_IPM_SUBTREE_ENTRYID = (($6620) shl 16) or PT_BINARY; 
PR_NORMAL_MESSAGE_SIZE = (($66B3) shl 16) or PT_LONG; 
PR_NORMAL_MESSAGE_SIZE_EXTENDED = (($66B3) shl 16) or PT_I8; 
PR_NORMAL_MSG_W_ATTACH_COUNT = (($66AD) shl 16) or PT_LONG;
PR_NT_USER_NAME = (($66A0) shl 16) or PT_STRING8; 
PR_OFFLINE_ADDRBOOK_ENTRYID = (($6623) shl 16) or PT_BINARY; 
PR_OFFLINE_FLAGS = (($663D) shl 16) or PT_LONG; 
PR_OFFLINE_MESSAGE_ENTRYID = (($6627) shl 16) or PT_BINARY; 
PR_OLDEST_DELETED_ON = (($6642) shl 16) or PT_SYSTIME;
PR_OOF_STATE = (($661D) shl 16) or PT_BOOLEAN; 
PR_ORIGINATOR_ADDR = (($665C) shl 16) or PT_STRING8;
PR_ORIGINATOR_ADDRTYPE = (($665D) shl 16) or PT_STRING8; 
PR_ORIGINATOR_ENTRYID = (($665E) shl 16) or PT_BINARY;
PR_ORIGINATOR_NAME = (($665B) shl 16) or PT_STRING8;
PR_OST_ENCRYPTION = (($6702) shl 16) or PT_LONG; 
PR_OUTBOUND_NEWSFEED_DN = (($668E) shl 16) or PT_STRING8;
PR_OVERALL_AGE_LIMIT = (($6699) shl 16) or PT_LONG;
PR_OVERALL_MSG_AGE_LIMIT = (($6693) shl 16) or PT_LONG;
PR_OWA_URL = (($10F1) shl 16) or PT_STRING8; 
PR_OWNER_COUNT = (($66B6) shl 16) or PT_LONG; 
PR_P1_CONTENT = (($1100) shl 16) or PT_BINARY; 
PR_P1_CONTENT_TYPE = (($1101) shl 16) or PT_BINARY; 
PR_PARENT_SOURCE_KEY = (($65E1) shl 16) or PT_BINARY;
PR_PREDECESSOR_CHANGE_LIST = (($65E3) shl 16) or PT_BINARY; 
PR_PREVENT_MSG_CREATE = (($65F4) shl 16) or PT_BOOLEAN; 
PR_PREVIEW = (($3FD9) shl 16) or PT_STRING8; 
PR_PREVIEW_UNREAD = (($3FD8) shl 16) or PT_STRING8; 
PR_PROFILE_AB_FILES_PATH = (($660E) shl 16) or PT_STRING8; 
PR_PROFILE_ADDR_INFO = (($6687) shl 16) or PT_BINARY; 
PR_PROFILE_ALLPUB_COMMENT = (($6617) shl 16) or PT_STRING8; 
PR_PROFILE_ALLPUB_DISPLAY_NAME = (($6616) shl 16) or PT_STRING8; 
PR_PROFILE_AUTH_PACKAGE = (($6619) shl 16) or PT_LONG; 
PR_PROFILE_BINDING_ORDER = (($6609) shl 16) or PT_STRING8;
PR_PROFILE_CONFIG_FLAGS = (($6601) shl 16) or PT_LONG; 
PR_PROFILE_CONNECT_FLAGS = (($6604) shl 16) or PT_LONG;
PR_PROFILE_FAVFLD_COMMENT = (($6615) shl 16) or PT_STRING8; 
PR_PROFILE_FAVFLD_DISPLAY_NAME = (($660F) shl 16) or PT_STRING8; 
PR_PROFILE_HOME_SERVER = (($6602) shl 16) or PT_STRING8; 
PR_PROFILE_HOME_SERVER_ADDRS = (($6613) shl 16) or PT_MV_STRING8;
PR_PROFILE_HOME_SERVER_DN = (($6612) shl 16) or PT_STRING8; 
PR_PROFILE_MAILBOX = (($660B) shl 16) or PT_STRING8;
PR_PROFILE_MAX_RESTRICT = (($660D) shl 16) or PT_LONG; 
PR_PROFILE_MOAB = (($667B) shl 16) or PT_STRING8;
PR_PROFILE_MOAB_GUID = (($667C) shl 16) or PT_STRING8; 
PR_PROFILE_MOAB_SEQ = (($667D) shl 16) or PT_LONG; 
PR_PROFILE_OFFLINE_INFO = (($6611) shl 16) or PT_BINARY;
PR_PROFILE_OFFLINE_STORE_PATH = (($6610) shl 16) or PT_STRING8; 
PR_PROFILE_OPEN_FLAGS = (($6609) shl 16) or PT_LONG; 
PR_PROFILE_OPTIONS_DATA = (($6689) shl 16) or PT_BINARY; 
PR_PROFILE_SECURE_MAILBOX = (($67F0) shl 16) or PT_BINARY; 
PR_PROFILE_SERVER = (($660C) shl 16) or PT_STRING8;
PR_PROFILE_SERVER_DN = (($6614) shl 16) or PT_STRING8;
PR_PROFILE_TRANSPORT_FLAGS = (($6605) shl 16) or PT_LONG;
PR_PROFILE_TYPE = (($660A) shl 16) or PT_LONG; 
PR_PROFILE_UI_STATE = (($6606) shl 16) or PT_LONG; 
PR_PROFILE_UNRESOLVED_NAME = (($6607) shl 16) or PT_STRING8; 
PR_PROFILE_UNRESOLVED_SERVER = (($6608) shl 16) or PT_STRING8; 
PR_PROFILE_USER = (($6603) shl 16) or PT_STRING8;
PR_PROFILE_VERSION = (($6600) shl 16) or PT_LONG; 
PR_PROMOTE_PROP_ID_LIST = (($666A) shl 16) or PT_BINARY; 
PR_PST_ENCRYPTION = (($6702) shl 16) or PT_LONG; 
PR_PST_PATH = (($6700) shl 16) or PT_STRING8;
PR_PST_PATH_A = (($6700) shl 16) or PT_STRING8;
PR_PST_PATH_W = (($6700) shl 16) or PT_UNICODE;  
PR_PST_PW_SZ_NEW = (($6704) shl 16) or PT_STRING8; 
PR_PST_PW_SZ_OLD = (($6703) shl 16) or PT_STRING8; 
PR_PST_REMEMBER_PW = (($6701) shl 16) or PT_BOOLEAN; 
PR_PUBLIC_FOLDER_ENTRYID = (($663C) shl 16) or PT_BINARY; 
PR_PUBLISH_IN_ADDRESS_BOOK = (($3FE6) shl 16) or PT_BOOLEAN; 
PR_RECIPIENT_NUMBER = (($6662) shl 16) or PT_LONG; 
PR_RECIPIENT_ON_ASSOC_MSG_COUNT = (($66B0) shl 16) or PT_LONG; 
PR_RECIPIENT_ON_NORMAL_MSG_COUNT = (($66AF) shl 16) or PT_LONG;
PR_REPLICA_LIST = (($6698) shl 16) or PT_BINARY; 
PR_REPLICA_SERVER = (($6644) shl 16) or PT_STRING8; 
PR_REPLICA_VERSION = (($664B) shl 16) or PT_I8; 
PR_REPLICATION_ALWAYS_INTERVAL = (($6694) shl 16) or PT_LONG; 
PR_REPLICATION_MESSAGE_PRIORITY = (($6692) shl 16) or PT_LONG; 
PR_REPLICATION_MSG_SIZE = (($6695) shl 16) or PT_LONG; 
PR_REPLICATION_SCHEDULE = (($6691) shl 16) or PT_BINARY; 
PR_REPLICATION_STYLE = (($6690) shl 16) or PT_LONG; 
PR_REPLY_RECIPIENT_SMTP_PROXIES = (($3FFC) shl 16) or PT_STRING8; 
PR_REPORT_DESTINATION_ENTRYID = (($6665) shl 16) or PT_BINARY;
PR_REPORT_DESTINATION_NAME = (($6664) shl 16) or PT_STRING8;
PR_RESOLVE_METHOD = (($3FE7) shl 16) or PT_LONG;
PR_RESTRICTION_COUNT = (($66AA) shl 16) or PT_LONG; 
PR_RETENTION_AGE_LIMIT = (($66C4) shl 16) or PT_LONG; 
PR_RIGHTS = (($6639) shl 16) or PT_LONG;
PR_RULE_ACTION_NUMBER = (($6650) shl 16) or PT_LONG;
PR_RULE_ACTION_TYPE = (($6649) shl 16) or PT_LONG;
//PR_RULE_ACTIONS = (($668000FE  - ????
//PR_RULE_CONDITION = (($667900FD  - ???
PR_RULE_ERROR = (($6648) shl 16) or PT_LONG;
PR_RULE_FOLDER_ENTRYID = (($6651) shl 16) or PT_BINARY; 
PR_RULE_ID = (($6674) shl 16) or PT_I8;
PR_RULE_IDS = (($6675) shl 16) or PT_BINARY; 
PR_RULE_LEVEL = (($6683) shl 16) or PT_LONG; 
PR_RULE_NAME = (($6682) shl 16) or PT_STRING8; 
PR_RULE_PROVIDER = (($6681) shl 16) or PT_STRING8; 
PR_RULE_PROVIDER_DATA = (($6684) shl 16) or PT_BINARY; 
PR_RULE_SEQUENCE = (($6676) shl 16) or PT_LONG; 
PR_RULE_STATE = (($6677) shl 16) or PT_LONG; 
PR_RULE_TRIGGER_HISTORY = (($3FF2) shl 16) or PT_BINARY; 
PR_RULE_USER_FLAGS = (($6678) shl 16) or PT_LONG; 
PR_RULES_DATA = (($3FE1) shl 16) or PT_BINARY;
PR_RULES_TABLE = (($3FE1) shl 16) or PT_OBJECT;
PR_SCHEDULE_FOLDER_ENTRYID = (($661E) shl 16) or PT_BINARY; 
PR_SECURE_IN_SITE = (($669E) shl 16) or PT_BOOLEAN;
PR_SECURE_ORIGINATION = (($3FE5) shl 16) or PT_BOOLEAN; 
PR_SORT_LOCALE_ID = (($6705) shl 16) or PT_LONG; 
PR_SOURCE_KEY = (($65E0) shl 16) or PT_BINARY; 
PR_SPLUS_FREE_BUSY_ENTRYID = (($6622) shl 16) or PT_BINARY; 
PR_STORAGE_LIMIT_INFORMATION = (($66A4) shl 16) or PT_LONG; 
PR_STORAGE_QUOTA_LIMIT = (($3FF5) shl 16) or PT_LONG; 
PR_STORE_OFFLINE = (($6632) shl 16) or PT_BOOLEAN; 
PR_STORE_SLOWLINK = (($7C0A) shl 16) or PT_BOOLEAN; 
PR_SUBJECT_TRACE_INFO = (($6661) shl 16) or PT_BINARY; 
PR_SVR_GENERATING_QUOTA_MSG = (($3FF7) shl 16) or PT_STRING8; 
PR_SYNCHRONIZE_FLAGS = (($65E4) shl 16) or PT_LONG;
PR_SYS_CONFIG_FOLDER_ENTRYID = (($6636) shl 16) or PT_BINARY; 
PR_TEST_LINE_SPEED = (($662B) shl 16) or PT_BINARY; 
PR_TRACE_INFO = (($6660) shl 16) or PT_BINARY; 
PR_TRANSFER_ENABLED = (($662A) shl 16) or PT_BOOLEAN;
PR_USER_ENTRYID = (($6619) shl 16) or PT_BINARY;
PR_USER_NAME = (($661A) shl 16) or PT_STRING8;
PR_X400_ENVELOPE_TYPE = (($6653) shl 16) or PT_LONG;

//my own hacks

PR_LIST_SUBSCRIBE = (($1044) shl 16) or PT_STRING8;
PR_LIST_UNSUBSCRIBE = (($1045) shl 16) or PT_STRING8;

//
PSTF_NO_ENCRYPTION              = $80000000;
PSTF_COMPRESSABLE_ENCRYPTION    = $40000000;
PSTF_BEST_ENCRYPTION            = $20000000;

//Outlook 2007
PR_PROVIDER_ITEMID         = $0EA30102;
PR_PROVIDER_PARENT_ITEMID  = $0EA40102;
PR_SEARCH_ATTACHMENTS_W    = $0EA5001F;
PR_SEARCH_ATTACHMENTS_A    = $0EA5001E;
PR_SEARCH_RECIP_EMAIL_TO_W = $0EA6001F;
PR_SEARCH_RECIP_EMAIL_TO_A = $0EA6001A;
PR_SEARCH_RECIP_EMAIL_CC_W = $0EA7001F;
PR_SEARCH_RECIP_EMAIL_CC_A = $0EA7001E;
PR_SEARCH_RECIP_EMAIL_BCC_W = $0EA8001F;
PR_SEARCH_RECIP_EMAIL_BCC_A = $0EA8001E;

//MFCMAPI headers

//Exchange 2007 Web Services
(*
Property folder:ManagedFolderInformation (unindexed property path)
Property Name and Parent Class FolderType.ManagedFolderInformation
MAPI Property FolderType.ManagedFolderInformationType.CanDelete 
0x672D0003 (flag 0x1)
FolderType.ManagedFolderInformationType.CanRenameOrMove
0x672D0003 (flag 0x2)
FolderType.ManagedFolderInformationType.
MustDisplayComment  0x672D0003 (flag 0x4)
FolderType.ManagedFolderInformationType.HasQuota 
0x672D0003 (flag 0x8)
FolderType.ManagedFolderInformationType.
IsManagedFoldersRoot  0x672D0003 (flag 0x10)
*)
PR_MANAGED_FOLDER_INFORMATION = $672D0003;

(*
FolderType.ManagedFolderInformationType.Comment 
0x6733001F
*)
PR_MANAGED_FOLDER_COMMENT =  $6733001F;

(*
FolderType.ManagedFolderInformationType.FolderSize 
0x67300003
*)
PR_MANAGED_FOLDER_SIZE = $67300003;

(*
FolderType.ManagedFolderInformationType.ManagedFolderId 
0x6732001F
*)
PR_MANAGED_FOLDER_ID = $6732001F;

(*
FolderType.ManagedFolderInformationType.StorageQuota 
0x67310003
*)
PR_MANAGED_FOLDER_STORAGE_QUOTA = $67310003;

//Dgoldman [MSFT] <D@d.com> - microsoft.public.platformsdk.mapi, "2 Profiles, use 2 services (MSEMS and MSUPST)"
ptagNoLocalDelivery = $67700003;
ptagXrefComplete = $67700003;
ptagSoftDeleted = $67700003;

PR_DISPLAY_TYPE_EX = $39050003;

//Exchange Protocols (April 2008)

PR_EMS_AB_HAB_CHILD_DEPARTMENTS = $8C9A000D;
PR_EMS_AB_HAB_DEPARTMENT_MEMBERS = $8C97000D;
PR_EMS_AB_HAB_PARENT_DEPARTMENT = $8C99000D;
PR_EMS_AB_HAB_ROOT_DEPARTMENT = $8C98000D;
PR_EMS_AB_HAB_SHOW_IN_DEPARTMENTS = $8C94000D;
PR_EMS_AB_MANAGE_DL = $6704000D;

PR_EMS_AB_PHONETIC_COMPANY_NAME   = $8C91001E;
PR_EMS_AB_PHONETIC_COMPANY_NAME_A = $8C91001E;
PR_EMS_AB_PHONETIC_COMPANY_NAME_W = $8C91001F;

PR_EMS_AB_PHONETIC_DEPARTMENT_NAME   = $8C90001E;
PR_EMS_AB_PHONETIC_DEPARTMENT_NAME_A = $8C90001E; 
PR_EMS_AB_PHONETIC_DEPARTMENT_NAME_W = $8C90001F;

PR_EMS_AB_PHONETIC_DISPLAY_NAME   = $8C92001E;
PR_EMS_AB_PHONETIC_DISPLAY_NAME_A = $8C92001E;
PR_EMS_AB_PHONETIC_DISPLAY_NAME_W = $8C92001F;

PR_EMS_AB_PHONETIC_GIVEN_NAME = $8C8E001E;
PR_EMS_AB_PHONETIC_GIVEN_NAME_A = $8C8E001E;
PR_EMS_AB_PHONETIC_GIVEN_NAME_W = $8C8E001F;

PR_EMS_AB_PHONETIC_SURNAME   = $8C8F001E;
PR_EMS_AB_PHONETIC_SURNAME_A = $8C8F001E;
PR_EMS_AB_PHONETIC_SURNAME_W = $8C8F001F;

PR_EMS_AB_ROOM_CAPACITY = $08070003;

PR_EMS_AB_ROOM_CONTAINERS   = $8C96101E;
PR_EMS_AB_ROOM_CONTAINERS_A = $8C96101E;
PR_EMS_AB_ROOM_CONTAINERS_W = $8C96101F;

PR_EMS_AB_ROOM_DESCRIPTION   = $0809001E;
PR_EMS_AB_ROOM_DESCRIPTION_A = $0809001E;
PR_EMS_AB_ROOM_DESCRIPTION_W = $0809001F;

PR_EMS_AB_SENIORITY_INDEX = $8CA00003;

//-----------

PR_ADDITIONAL_REN_ENTRYIDS_EX = $36D90102;

//indeces for PR_ADDITIONAL_REN_ENTRYIDS_EX
RSF_PID_RSS_SUBSCRIPTION = $8001;
RSF_PID_SEND_AND_TRACK = $8002;
RSF_PID_TODO_SEARCH = $8004;
RSF_PID_CONV_ACTIONS = $8006;
RSF_PID_COMBINED_ACTIONS     = $8007;
RSF_PID_SUGGESTED_CONTACTS  = $8008;

PERSIST_SENTINEL = 0;

RSF_ELID_HEADER = 2;
RSF_ELID_ENTRYID = 1;
ELEMENT_SENTINEL = 0;



PR_BLOCK_STATUS = $10960003;
ptagBlockStatus = $10960003;

//PR_DEFERRED_SEND_TIME = $3FEF0040;
ptagDeferredSendTime  = $3FEF0040;

PR_EXCEPTION_REPLACETIME = $7FF90040;

PR_EXTENDED_FOLDER_FLAGS = $36DA0102;
ptagExtendedFolderFlags  = $36DA0102;

PR_GATEWAY_NEEDS_TO_REFRESH = $6846000B;


PR_FREEBUSY_COUNT_MONTHS =  $68690003;
PR_FREEBUSY_PUBLISH_END = $68480003;
PR_FREEBUSY_PUBLISH_START = $68470003;
PR_FREEBUSY_RANGE_TIMESTAMP = $68680040;

//PR_HAS_RULES = $663A000B;
//ptagHasRules = $663A000B;


ptagIncrSyncMsgPartial = $407A0003;
ptagIncrSyncGroupId = $407C0003;


PR_JUNK_ADD_RECIPS_TO_SSL = $61030003;
PR_JUNK_INCLUDE_CONTACTS = $61000003;
PR_JUNK_PERMANENTLY_DELETE = $61020003;
PR_JUNK_PHISHING_ENABLE_LINKS = $6107000B;
PR_JUNK_POSTMARK_OUTGOING_MAIL = $6109000B;
PR_JUNK_THRESHOLD = $61010003;


PR_OAB_COMPRESSED_SIZE = $68090003;
PR_OAB_CONTAINER_GUID = $6802001E;
PR_OAB_CONTAINER_GUID_W = $6802001F;
PR_OAB_DN = $6804001E;
PR_OAB_DN_W = $6804001F;
PR_OAB_FILE_SIZE =  $680A0003;
PR_OAB_FILETYPE = $68080003;
PR_OAB_LANGID = $68070003;
PR_OAB_MESSAGE_CLASS = $68030003;
PR_OAB_NAME = $6800001E;
PR_OAB_NAME_W = $6800001F;
PR_OAB_SEQUENCE = $68010003;
PR_OAB_SHA_HASH = $68060102;
PR_OAB_TRUNCATED_PROPS = $68051003;

PR_ORIG_ENTRYID = $300F0102;

//PR_OOF_STATE = $661D000B;
//ptagOOFState = $661D000B;

PR_PROCESSED = $7D01000B;

ptagProhibitReceiveQuota  = $666A0003;

PR_RECIPIENT_PROPOSED = $5FE1000B;
ptagRecipientProposed = $5FE1000B;

PR_RECIPIENT_PROPOSEDENDTIME = $5FE40040;
ptagRecipientProposedEndTime = $5FE40040;

PR_RECIPIENT_PROPOSEDSTARTTIME = $5FE30040; 
ptagRecipientProposedStartTime = $5FE30040;

PR_ROAMING_DATATYPES = $7C060003;
PR_ROAMING_DICTIONARY = $7C070102;
PR_ROAMING_XMLSTREAM = $7C080102;

//PR_RULE_FOLDER_ENTRYID = $66510102;
//ptagRuleFolderEntryId   = $66510102;

PR_SCHDINFO_APPT_TOMBSTONE = $686A0102;
PR_SCHDINFO_AUTO_ACCEPT_APPTS = $686D000B;
PR_SCHDINFO_DELEGATE_ENTRYIDS = $68451102;
PR_SCHDINFO_DELEGATE_NAMES   = $6844101E;
PR_SCHDINFO_DELEGATE_NAMES_W = $6844101F;
PR_SCHDINFO_BOSS_WANTS_COPY = $6842000B;
PR_SCHDINFO_BOSS_WANTS_INFO = $684B000B;
PR_SCHDINFO_DISALLOW_OVERLAPPING_APPTS = $686F000B;
PR_SCHDINFO_DISALLOW_RECURRING_APPTS = $686E000B;
PR_SCHDINFO_DONT_MAIL_DELEGATES = $6843000B;
PR_SCHDINFO_FREEBUSY = $686C0102;
PR_SCHDINFO_FREEBUSY_OOF = $68561102;
PR_SCHDINFO_FREEBUSY_BUSY = $68541102;
PR_SCHDINFO_FREEBUSY_MERGED = $68501102;
PR_SCHDINFO_FREEBUSY_TENTATIVE = $68521102;
PR_SCHDINFO_MONTHS_OOF = $68551003;
PR_SCHDINFO_MONTHS_BUSY = $6851003;
PR_SCHDINFO_MONTHS_MERGED = $684F1003;
PR_SCHDINFO_MONTHS_TENTATIVE = $68511003;
PR_SCHDINFO_RESOURCE_TYPE = $68410003;

//PR_SPLUS_FREE_BUSY_ENTRYID = $66220102;

PR_WB_SF_DEFINITION = $68450102;
PR_WB_SF_EFP_FLAGS = $68480003;
PR_WB_SF_EXPIRATION = $683A0003;
PR_WB_SF_ID = $68420102;
PR_WB_SF_LAST_USED = $68340003;
PR_WB_SF_RECREATE_INFO = $68440102;
PR_WB_SF_STORAGE_TYPE = $68460003;
PR_WB_SF_TAG = $68470003;
PR_WB_SF_TEMPLATE_ID = $68410003;


InternalSchemaSenderTelephoneNumber = $6802001E;
InternalSchemaSenderTelephoneNumber_W = $6802001F;
InternalSchemaVoiceMessageAttachmentOrder = $6805001E;
InternalSchemaVoiceMessageAttachmentOrder_W = $6805001F;


ptagSentMailSvrEID = $674000FB;

PR_STORE_USER_ENTRYID = $7CF60102;


PR_SWAPPED_TODO_DATA = $0E2D0102;
ptagSwappedTodoData  = $0E2D0102;
PR_SWAPPED_TODO_STORE = $0E2C0102;
ptagSwappedTodoStore  = $0E2C0102;


PR_TARGET_ENTRYID = $30100102;
ptagTargetEntryId = $30100102;


PR_TODO_ITEM_FLAGS = $0E2B0003;
ptagToDoItemFlags  = $0E2B0003;

//PR_STORE_ENTRYID_EMSMDB_V1 PROP_TAG(PT_BINARY, 0x65f6)
PR_STORE_ENTRYID_EMSMDB_V1 = $65f60102;

PR_STORE_UNICODE_MASK = $340F0003;

//http://blogs.msdn.com/b/stephen_griffin/archive/2011/04/13/setsearchpath-not-really.aspx
PR_AB_SEARCH_PATH_CUSTOMIZATION = $3D1B0003;
SEARCHPATHREORDERTYPE_RAW = 0;
SEARCHPATHREORDERTYPE_ACCT_PREFERGAL = 1;
SEARCHPATHREORDERTYPE_ACCT_PREFERCONTACTS = 2;

//http://blogs.msdn.com/b/stephen_griffin/archive/2010/09/13/you-chose-wisely.aspx
PR_AB_CHOOSE_DIRECTORY_AUTOMATICALLY = $3D1C000B;

//http://blogs.msdn.com/b/stephen_griffin/archive/2011/12/06/enabling-kerberos-authentication.aspx
PR_PROFILE_HOME_SERVER_FQDN = $662A001F;
PR_PROFILE_HOME_SERVER_FQDN_A = $662A001E;

//http://msdn.microsoft.com/en-us/library/ff625291.aspx
PR_NICK_NAME_W = $6001001f;
PR_NEW_NICK_NAME = $6002000B;
PR_DROPDOWN_DISPLAY_NAME_W = $6003001f;
PR_NICK_NAME_WEIGHT = $60040003;

implementation

end.

