unit emsabTag;

interface

uses Windows, MAPITags, MAPIDefs;

{const
  PR_EMS_AB_HOME_MTA = (PT_TSTRING) or ULONG((($8007) shl 16));
  PR_EMS_AB_HOME_PUBLIC_SERVER = (PT_TSTRING) or (($803F) shl 16);}

  (*
** --emsabtag.h---------------------------------------------------------------
**
**  Property tag definitions for standard properties of Exchange Address
**  Book objects.
**
**  Note: These proptags are only valid when talking directly to the
**  Exchange Server Address Book. They are specifically NOT valid when
**  trying to read properties from an object copied into another address
**  book provider (the Personal Address Book, for example).
**
**  Copyright (c) Microsoft Corp. 1986-1996. All rights reserved.
** ---------------------------------------------------------------------------
*)

(*
* Flags for ulInterfaceOptions on OpenProperty
*)
const AB_SHOW_PHANTOMS                      = 2;
const AB_SHOW_OTHERS                        = 4;

(*
* Flags for ulFlag on ResolveNames
*)
const EMS_AB_ADDRESS_LOOKUP                  = 1;

(*
* Constructed, but externally visible.
*)

//const PR_CONTENT_RETURN_REQUESTED                  =
//   = (PT_BOOLEAN) or ((ULONG($000A)) shl 16 );

const PR_EMS_AB_SERVER                     = (PT_TSTRING or ( ULONG($FFFE) shl 16 ));
const PR_EMS_AB_SERVER_A                   = (PT_STRING8 or ( ULONG($FFFE) shl 16 ));
const PR_EMS_AB_SERVER_W                   = (PT_UNICODE or ( ULONG($FFFE) shl 16 ));
const PR_EMS_AB_CONTAINERID                = (PT_LONG or (    ULONG($FFFD) shl 16 ));
const PR_EMS_AB_DOS_ENTRYID                 = PR_EMS_AB_CONTAINERID;
const PR_EMS_AB_PARENT_ENTRYID             = (PT_BINARY or (  ULONG($FFFC) shl 16 ));
const PR_EMS_AB_IS_MASTER                  = (PT_BOOLEAN or (  ULONG($FFFB) shl 16 ));
const PR_EMS_AB_OBJECT_OID                 = (PT_BINARY or (   ULONG($FFFA) shl 16 ));
const PR_EMS_AB_HIERARCHY_PATH             = (PT_TSTRING or (  ULONG($FFF9) shl 16 ));
const PR_EMS_AB_HIERARCHY_PATH_A           = (PT_STRING8 or (  ULONG($FFF9) shl 16 ));
const PR_EMS_AB_HIERARCHY_PATH_W           = (PT_UNICODE or (  ULONG($FFF9) shl 16 ));
const PR_EMS_AB_CHILD_RDNS                  = (PT_MV_STRING8 or (   ULONG($FFF8) shl 16 ));

const MIN_EMS_AB_CONSTRUCTED_PROP_ID        = ULONG($FFF8);

const PR_EMS_AB_OTHER_RECIPS                = (PT_OBJECT or (       ULONG($F000) shl 16 ));

(*
 * Prop tags defined in the schema.
 *)
const PR_EMS_AB_DISPLAY_NAME_PRINTABLE      = (PT_TSTRING or (      ULONG($39FF) shl 16 ));
const PR_EMS_AB_DISPLAY_NAME_PRINTABLE_A    = (PT_STRING8 or (      ULONG($39FF) shl 16 ));
const PR_EMS_AB_DISPLAY_NAME_PRINTABLE_W    = (PT_UNICODE or (      ULONG($39FF) shl 16 ));

const PR_EMS_AB_ACCESS_CATEGORY            = (PT_LONG or (          ULONG($8044) shl 16 ));
const PR_EMS_AB_ACTIVATION_SCHEDULE        = (PT_BINARY or (        ULONG($8045) shl 16 ));
const PR_EMS_AB_ACTIVATION_STYLE           = (PT_LONG or (          ULONG($8046) shl 16 ));
const PR_EMS_AB_ADDRESS_ENTRY_DISPLAY_TABLE = (PT_BINARY or (        ULONG($8017) shl 16 ));
const PR_EMS_AB_ADDRESS_ENTRY_DISPLAY_TABLE_MSDOS = (PT_BINARY or (        ULONG($8047) shl 16 ));
const PR_EMS_AB_ADDRESS_SYNTAX             = (PT_BINARY or (        ULONG($8018) shl 16 ));
const PR_EMS_AB_ADDRESS_TYPE               = (PT_TSTRING or (       ULONG($8048) shl 16 ));
const PR_EMS_AB_ADDRESS_TYPE_A             = (PT_STRING8 or (       ULONG($8048) shl 16 ));
const PR_EMS_AB_ADDRESS_TYPE_W             = (PT_UNICODE or (       ULONG($8048) shl 16 ));
const PR_EMS_AB_ADMD                       = (PT_TSTRING or (       ULONG($8049) shl 16 ));
const PR_EMS_AB_ADMD_A                     = (PT_STRING8 or (       ULONG($8049) shl 16 ));
const PR_EMS_AB_ADMD_W                     = (PT_UNICODE or (       ULONG($8049) shl 16 ));
const PR_EMS_AB_ADMIN_DESCRIPTION          = (PT_TSTRING or (       ULONG($804A) shl 16 ));
const PR_EMS_AB_ADMIN_DESCRIPTION_A        = (PT_STRING8 or (       ULONG($804A) shl 16 ));
const PR_EMS_AB_ADMIN_DESCRIPTION_W        = (PT_UNICODE or (       ULONG($804A) shl 16 ));
const PR_EMS_AB_ADMIN_DISPLAY_NAME         = (PT_TSTRING or (       ULONG($804B) shl 16 ));
const PR_EMS_AB_ADMIN_DISPLAY_NAME_A       = (PT_STRING8 or (       ULONG($804B) shl 16 ));
const PR_EMS_AB_ADMIN_DISPLAY_NAME_W       = (PT_UNICODE or (       ULONG($804B) shl 16 ));
const PR_EMS_AB_ADMIN_EXTENSION_DLL        = (PT_TSTRING or (       ULONG($804C) shl 16 ));
const PR_EMS_AB_ADMIN_EXTENSION_DLL_A      = (PT_STRING8 or (       ULONG($804C) shl 16 ));
const PR_EMS_AB_ADMIN_EXTENSION_DLL_W      = (PT_UNICODE or (       ULONG($804C) shl 16 ));
const PR_EMS_AB_ALIASED_OBJECT_NAME        = (PT_TSTRING or (       ULONG($804D) shl 16 ));
const PR_EMS_AB_ALIASED_OBJECT_NAME_A      = (PT_STRING8 or (       ULONG($804D) shl 16 ));
const PR_EMS_AB_ALIASED_OBJECT_NAME_W      = (PT_UNICODE or (       ULONG($804D) shl 16 ));
const PR_EMS_AB_ALIASED_OBJECT_NAME_O      = (PT_OBJECT or (        ULONG($804D) shl 16 ));
const PR_EMS_AB_ALIASED_OBJECT_NAME_T      = (PT_TSTRING or (       ULONG($804D) shl 16 ));
const PR_EMS_AB_ALT_RECIPIENT              = (PT_TSTRING or (       ULONG($804E) shl 16 ));
const PR_EMS_AB_ALT_RECIPIENT_A            = (PT_STRING8 or (       ULONG($804E) shl 16 ));
const PR_EMS_AB_ALT_RECIPIENT_W            = (PT_UNICODE or (       ULONG($804E) shl 16 ));
const PR_EMS_AB_ALT_RECIPIENT_O            = (PT_OBJECT or (        ULONG($804E) shl 16 ));
const PR_EMS_AB_ALT_RECIPIENT_T            = (PT_TSTRING or (       ULONG($804E) shl 16 ));
const PR_EMS_AB_ALT_RECIPIENT_BL           = (PT_MV_TSTRING or (    ULONG($804F) shl 16 ));
const PR_EMS_AB_ALT_RECIPIENT_BL_A         = (PT_MV_STRING8 or (    ULONG($804F) shl 16 ));
const PR_EMS_AB_ALT_RECIPIENT_BL_W         = (PT_MV_UNICODE or (    ULONG($804F) shl 16 ));
const PR_EMS_AB_ALT_RECIPIENT_BL_O         = (PT_OBJECT or (        ULONG($804F) shl 16 ));
const PR_EMS_AB_ALT_RECIPIENT_BL_T         = (PT_MV_TSTRING or (    ULONG($804F) shl 16 ));
const PR_EMS_AB_ANCESTOR_ID                = (PT_BINARY or (        ULONG($8050) shl 16 ));
const PR_EMS_AB_ASSOC_NT_ACCOUNT           = (PT_BINARY or (        ULONG($8027) shl 16 ));
const PR_EMS_AB_ASSOC_REMOTE_DXA           = (PT_MV_TSTRING or (    ULONG($8051) shl 16 ));
const PR_EMS_AB_ASSOC_REMOTE_DXA_A         = (PT_MV_STRING8 or (    ULONG($8051) shl 16 ));
const PR_EMS_AB_ASSOC_REMOTE_DXA_W         = (PT_MV_UNICODE or (    ULONG($8051) shl 16 ));
const PR_EMS_AB_ASSOC_REMOTE_DXA_O         = (PT_OBJECT or (        ULONG($8051) shl 16 ));
const PR_EMS_AB_ASSOC_REMOTE_DXA_T         = (PT_MV_TSTRING or (    ULONG($8051) shl 16 ));
const PR_EMS_AB_ASSOCIATION_LIFETIME       = (PT_LONG or (          ULONG($8052) shl 16 ));
const PR_EMS_AB_AUTH_ORIG_BL               = (PT_MV_TSTRING or (    ULONG($8053) shl 16 ));
const PR_EMS_AB_AUTH_ORIG_BL_A             = (PT_MV_STRING8 or (    ULONG($8053) shl 16 ));
const PR_EMS_AB_AUTH_ORIG_BL_W             = (PT_MV_UNICODE or (    ULONG($8053) shl 16 ));
const PR_EMS_AB_AUTH_ORIG_BL_O             = (PT_OBJECT or (        ULONG($8053) shl 16 ));
const PR_EMS_AB_AUTH_ORIG_BL_T             = (PT_MV_TSTRING or (    ULONG($8053) shl 16 ));
const PR_EMS_AB_AUTHORITY_REVOCATION_LIST  = (PT_MV_BINARY or (     ULONG($8026) shl 16 ));
const PR_EMS_AB_AUTHORIZED_DOMAIN          = (PT_TSTRING or (       ULONG($8054) shl 16 ));
const PR_EMS_AB_AUTHORIZED_DOMAIN_A        = (PT_STRING8 or (       ULONG($8054) shl 16 ));
const PR_EMS_AB_AUTHORIZED_DOMAIN_W        = (PT_UNICODE or (       ULONG($8054) shl 16 ));
const PR_EMS_AB_AUTHORIZED_PASSWORD        = (PT_BINARY or (        ULONG($8055) shl 16 ));
const PR_EMS_AB_AUTHORIZED_USER            = (PT_TSTRING or (       ULONG($8056) shl 16 ));
const PR_EMS_AB_AUTHORIZED_USER_A          = (PT_STRING8 or (       ULONG($8056) shl 16 ));
const PR_EMS_AB_AUTHORIZED_USER_W          = (PT_UNICODE or (       ULONG($8056) shl 16 ));
const PR_EMS_AB_AUTOREPLY                  = (PT_BOOLEAN or (       ULONG($800B) shl 16 ));
const PR_EMS_AB_AUTOREPLY_MESSAGE          = (PT_TSTRING or (       ULONG($800A) shl 16 ));
const PR_EMS_AB_AUTOREPLY_MESSAGE_A        = (PT_STRING8 or (       ULONG($800A) shl 16 ));
const PR_EMS_AB_AUTOREPLY_MESSAGE_W        = (PT_UNICODE or (       ULONG($800A) shl 16 ));
const PR_EMS_AB_AUTOREPLY_SUBJECT          = (PT_TSTRING or (       ULONG($803E) shl 16 ));
const PR_EMS_AB_AUTOREPLY_SUBJECT_A        = (PT_STRING8 or (       ULONG($803E) shl 16 ));
const PR_EMS_AB_AUTOREPLY_SUBJECT_W        = (PT_UNICODE or (       ULONG($803E) shl 16 ));
const PR_EMS_AB_BRIDGEHEAD_SERVERS         = (PT_MV_TSTRING or (    ULONG($8174) shl 16 ));
const PR_EMS_AB_BRIDGEHEAD_SERVERS_A       = (PT_MV_STRING8 or (    ULONG($8174) shl 16 ));
const PR_EMS_AB_BRIDGEHEAD_SERVERS_W       = (PT_MV_UNICODE or (    ULONG($8174) shl 16 ));
const PR_EMS_AB_BRIDGEHEAD_SERVERS_O       = (PT_OBJECT or (        ULONG($8174) shl 16 ));
const PR_EMS_AB_BRIDGEHEAD_SERVERS_T       = (PT_MV_TSTRING or (    ULONG($8174) shl 16 ));
const PR_EMS_AB_BUSINESS_CATEGORY          = (PT_MV_TSTRING or (    ULONG($8057) shl 16 ));
const PR_EMS_AB_BUSINESS_CATEGORY_A        = (PT_MV_STRING8 or (    ULONG($8057) shl 16 ));
const PR_EMS_AB_BUSINESS_CATEGORY_W        = (PT_MV_UNICODE or (    ULONG($8057) shl 16 ));
const PR_EMS_AB_BUSINESS_ROLES             = (PT_BINARY or (        ULONG($8023) shl 16 ));
const PR_EMS_AB_CA_CERTIFICATE             = (PT_MV_BINARY or (     ULONG($8003) shl 16 ));
const PR_EMS_AB_CAN_CREATE_PF              = (PT_MV_TSTRING or (    ULONG($8058) shl 16 ));
const PR_EMS_AB_CAN_CREATE_PF_A            = (PT_MV_STRING8 or (    ULONG($8058) shl 16 ));
const PR_EMS_AB_CAN_CREATE_PF_W            = (PT_MV_UNICODE or (    ULONG($8058) shl 16 ));
const PR_EMS_AB_CAN_CREATE_PF_O            = (PT_OBJECT or (        ULONG($8058) shl 16 ));
const PR_EMS_AB_CAN_CREATE_PF_T            = (PT_MV_TSTRING or (    ULONG($8058) shl 16 ));
const PR_EMS_AB_CAN_CREATE_PF_BL           = (PT_MV_TSTRING or (    ULONG($8059) shl 16 ));
const PR_EMS_AB_CAN_CREATE_PF_BL_A         = (PT_MV_STRING8 or (    ULONG($8059) shl 16 ));
const PR_EMS_AB_CAN_CREATE_PF_BL_W         = (PT_MV_UNICODE or (    ULONG($8059) shl 16 ));
const PR_EMS_AB_CAN_CREATE_PF_BL_O         = (PT_OBJECT or (        ULONG($8059) shl 16 ));
const PR_EMS_AB_CAN_CREATE_PF_BL_T         = (PT_MV_TSTRING or (    ULONG($8059) shl 16 ));
const PR_EMS_AB_CAN_CREATE_PF_DL           = (PT_MV_TSTRING or (    ULONG($805A) shl 16 ));
const PR_EMS_AB_CAN_CREATE_PF_DL_A         = (PT_MV_STRING8 or (    ULONG($805A) shl 16 ));
const PR_EMS_AB_CAN_CREATE_PF_DL_W         = (PT_MV_UNICODE or (    ULONG($805A) shl 16 ));
const PR_EMS_AB_CAN_CREATE_PF_DL_O         = (PT_OBJECT or (        ULONG($805A) shl 16 ));
const PR_EMS_AB_CAN_CREATE_PF_DL_T         = (PT_MV_TSTRING or (    ULONG($805A) shl 16 ));
const PR_EMS_AB_CAN_CREATE_PF_DL_BL        = (PT_MV_TSTRING or (    ULONG($805B) shl 16 ));
const PR_EMS_AB_CAN_CREATE_PF_DL_BL_A      = (PT_MV_STRING8 or (    ULONG($805B) shl 16 ));
const PR_EMS_AB_CAN_CREATE_PF_DL_BL_W      = (PT_MV_UNICODE or (    ULONG($805B) shl 16 ));
const PR_EMS_AB_CAN_CREATE_PF_DL_BL_O      = (PT_OBJECT or (        ULONG($805B) shl 16 ));
const PR_EMS_AB_CAN_CREATE_PF_DL_BL_T      = (PT_MV_TSTRING or (    ULONG($805B) shl 16 ));
const PR_EMS_AB_CAN_NOT_CREATE_PF          = (PT_MV_TSTRING or (    ULONG($805C) shl 16 ));
const PR_EMS_AB_CAN_NOT_CREATE_PF_A        = (PT_MV_STRING8 or (    ULONG($805C) shl 16 ));
const PR_EMS_AB_CAN_NOT_CREATE_PF_W        = (PT_MV_UNICODE or (    ULONG($805C) shl 16 ));
const PR_EMS_AB_CAN_NOT_CREATE_PF_O        = (PT_OBJECT or (        ULONG($805C) shl 16 ));
const PR_EMS_AB_CAN_NOT_CREATE_PF_T        = (PT_MV_TSTRING or (    ULONG($805C) shl 16 ));
const PR_EMS_AB_CAN_NOT_CREATE_PF_BL       = (PT_MV_TSTRING or (    ULONG($805D) shl 16 ));
const PR_EMS_AB_CAN_NOT_CREATE_PF_BL_A     = (PT_MV_STRING8 or (    ULONG($805D) shl 16 ));
const PR_EMS_AB_CAN_NOT_CREATE_PF_BL_W     = (PT_MV_UNICODE or (    ULONG($805D) shl 16 ));
const PR_EMS_AB_CAN_NOT_CREATE_PF_BL_O     = (PT_OBJECT or (        ULONG($805D) shl 16 ));
const PR_EMS_AB_CAN_NOT_CREATE_PF_BL_T     = (PT_MV_TSTRING or (    ULONG($805D) shl 16 ));
const PR_EMS_AB_CAN_NOT_CREATE_PF_DL       = (PT_MV_TSTRING or (    ULONG($805E) shl 16 ));
const PR_EMS_AB_CAN_NOT_CREATE_PF_DL_A     = (PT_MV_STRING8 or (    ULONG($805E) shl 16 ));
const PR_EMS_AB_CAN_NOT_CREATE_PF_DL_W     = (PT_MV_UNICODE or (    ULONG($805E) shl 16 ));
const PR_EMS_AB_CAN_NOT_CREATE_PF_DL_O     = (PT_OBJECT or (        ULONG($805E) shl 16 ));
const PR_EMS_AB_CAN_NOT_CREATE_PF_DL_T     = (PT_MV_TSTRING or (    ULONG($805E) shl 16 ));
const PR_EMS_AB_CAN_NOT_CREATE_PF_DL_BL    = (PT_MV_TSTRING or (    ULONG($805F) shl 16 ));
const PR_EMS_AB_CAN_NOT_CREATE_PF_DL_BL_A  = (PT_MV_STRING8 or (    ULONG($805F) shl 16 ));
const PR_EMS_AB_CAN_NOT_CREATE_PF_DL_BL_W  = (PT_MV_UNICODE or (    ULONG($805F) shl 16 ));
const PR_EMS_AB_CAN_NOT_CREATE_PF_DL_BL_O  = (PT_OBJECT or (        ULONG($805F) shl 16 ));
const PR_EMS_AB_CAN_NOT_CREATE_PF_DL_BL_T  = (PT_MV_TSTRING or (    ULONG($805F) shl 16 ));
const PR_EMS_AB_CAN_PRESERVE_DNS           = (PT_BOOLEAN or (       ULONG($8060) shl 16 ));
const PR_EMS_AB_CERTIFICATE_REVOCATION_LIST = (PT_BINARY or (        ULONG($8016) shl 16 ));
const PR_EMS_AB_CLOCK_ALERT_OFFSET         = (PT_LONG or (          ULONG($8061) shl 16 ));
const PR_EMS_AB_CLOCK_ALERT_REPAIR         = (PT_BOOLEAN or (       ULONG($8062) shl 16 ));
const PR_EMS_AB_CLOCK_WARNING_OFFSET       = (PT_LONG or (          ULONG($8063) shl 16 ));
const PR_EMS_AB_CLOCK_WARNING_REPAIR       = (PT_BOOLEAN or (       ULONG($8064) shl 16 ));
const PR_EMS_AB_COMPUTER_NAME              = (PT_TSTRING or (       ULONG($8065) shl 16 ));
const PR_EMS_AB_COMPUTER_NAME_A            = (PT_STRING8 or (       ULONG($8065) shl 16 ));
const PR_EMS_AB_COMPUTER_NAME_W            = (PT_UNICODE or (       ULONG($8065) shl 16 ));
const PR_EMS_AB_CONNECTED_DOMAINS          = (PT_MV_TSTRING or (    ULONG($8066) shl 16 ));
const PR_EMS_AB_CONNECTED_DOMAINS_A        = (PT_MV_STRING8 or (    ULONG($8066) shl 16 ));
const PR_EMS_AB_CONNECTED_DOMAINS_W        = (PT_MV_UNICODE or (    ULONG($8066) shl 16 ));
const PR_EMS_AB_CONTAINER_INFO             = (PT_LONG or (          ULONG($8067) shl 16 ));
const PR_EMS_AB_COST                       = (PT_LONG or (          ULONG($8068) shl 16 ));
const PR_EMS_AB_COUNTRY_NAME               = (PT_TSTRING or (       ULONG($8069) shl 16 ));
const PR_EMS_AB_COUNTRY_NAME_A             = (PT_STRING8 or (       ULONG($8069) shl 16 ));
const PR_EMS_AB_COUNTRY_NAME_W             = (PT_UNICODE or (       ULONG($8069) shl 16 ));
const PR_EMS_AB_CROSS_CERTIFICATE_PAIR     = (PT_MV_BINARY or (     ULONG($8025) shl 16 ));
const PR_EMS_AB_DELIV_CONT_LENGTH          = (PT_LONG or (          ULONG($806A) shl 16 ));
const PR_EMS_AB_DELIV_EITS                 = (PT_MV_BINARY or (     ULONG($806B) shl 16 ));
const PR_EMS_AB_DELIV_EXT_CONT_TYPES       = (PT_MV_BINARY or (     ULONG($806C) shl 16 ));
const PR_EMS_AB_DELIVER_AND_REDIRECT       = (PT_BOOLEAN or (       ULONG($806D) shl 16 ));
const PR_EMS_AB_DELIVERY_MECHANISM         = (PT_LONG or (          ULONG($806E) shl 16 ));
const PR_EMS_AB_DESCRIPTION                = (PT_MV_TSTRING or (    ULONG($806F) shl 16 ));
const PR_EMS_AB_DESCRIPTION_A              = (PT_MV_STRING8 or (    ULONG($806F) shl 16 ));
const PR_EMS_AB_DESCRIPTION_W              = (PT_MV_UNICODE or (    ULONG($806F) shl 16 ));
const PR_EMS_AB_DESTINATION_INDICATOR      = (PT_MV_TSTRING or (    ULONG($8070) shl 16 ));
const PR_EMS_AB_DESTINATION_INDICATOR_A    = (PT_MV_STRING8 or (    ULONG($8070) shl 16 ));
const PR_EMS_AB_DESTINATION_INDICATOR_W    = (PT_MV_UNICODE or (    ULONG($8070) shl 16 ));
const PR_EMS_AB_DIAGNOSTIC_REG_KEY         = (PT_TSTRING or (       ULONG($8071) shl 16 ));
const PR_EMS_AB_DIAGNOSTIC_REG_KEY_A       = (PT_STRING8 or (       ULONG($8071) shl 16 ));
const PR_EMS_AB_DIAGNOSTIC_REG_KEY_W       = (PT_UNICODE or (       ULONG($8071) shl 16 ));
const PR_EMS_AB_DISPLAY_NAME_OVERRIDE      = (PT_BOOLEAN or (       ULONG($8001) shl 16 ));
const PR_EMS_AB_DL_MEM_REJECT_PERMS_BL     = (PT_MV_TSTRING or (    ULONG($8072) shl 16 ));
const PR_EMS_AB_DL_MEM_REJECT_PERMS_BL_A   = (PT_MV_STRING8 or (    ULONG($8072) shl 16 ));
const PR_EMS_AB_DL_MEM_REJECT_PERMS_BL_W   = (PT_MV_UNICODE or (    ULONG($8072) shl 16 ));
const PR_EMS_AB_DL_MEM_REJECT_PERMS_BL_O   = (PT_OBJECT or (        ULONG($8072) shl 16 ));
const PR_EMS_AB_DL_MEM_REJECT_PERMS_BL_T   = (PT_MV_TSTRING or (    ULONG($8072) shl 16 ));
const PR_EMS_AB_DL_MEM_SUBMIT_PERMS_BL     = (PT_MV_TSTRING or (    ULONG($8073) shl 16 ));
const PR_EMS_AB_DL_MEM_SUBMIT_PERMS_BL_A   = (PT_MV_STRING8 or (    ULONG($8073) shl 16 ));
const PR_EMS_AB_DL_MEM_SUBMIT_PERMS_BL_W   = (PT_MV_UNICODE or (    ULONG($8073) shl 16 ));
const PR_EMS_AB_DL_MEM_SUBMIT_PERMS_BL_O   = (PT_OBJECT or (        ULONG($8073) shl 16 ));
const PR_EMS_AB_DL_MEM_SUBMIT_PERMS_BL_T   = (PT_MV_TSTRING or (    ULONG($8073) shl 16 ));
const PR_EMS_AB_DL_MEMBER_RULE             = (PT_MV_BINARY or (     ULONG($8074) shl 16 ));
const PR_EMS_AB_DOMAIN_DEF_ALT_RECIP       = (PT_TSTRING or (       ULONG($8075) shl 16 ));
const PR_EMS_AB_DOMAIN_DEF_ALT_RECIP_A     = (PT_STRING8 or (       ULONG($8075) shl 16 ));
const PR_EMS_AB_DOMAIN_DEF_ALT_RECIP_W     = (PT_UNICODE or (       ULONG($8075) shl 16 ));
const PR_EMS_AB_DOMAIN_DEF_ALT_RECIP_O     = (PT_OBJECT or (        ULONG($8075) shl 16 ));
const PR_EMS_AB_DOMAIN_DEF_ALT_RECIP_T     = (PT_TSTRING or (       ULONG($8075) shl 16 ));
const PR_EMS_AB_DOMAIN_NAME                = (PT_TSTRING or (       ULONG($8076) shl 16 ));
const PR_EMS_AB_DOMAIN_NAME_A              = (PT_STRING8 or (       ULONG($8076) shl 16 ));
const PR_EMS_AB_DOMAIN_NAME_W              = (PT_UNICODE or (       ULONG($8076) shl 16 ));
const PR_EMS_AB_DSA_SIGNATURE              = (PT_BINARY or (        ULONG($8077) shl 16 ));
const PR_EMS_AB_DXA_ADMIN_COPY             = (PT_BOOLEAN or (       ULONG($8078) shl 16 ));
const PR_EMS_AB_DXA_ADMIN_FORWARD          = (PT_BOOLEAN or (       ULONG($8079) shl 16 ));
const PR_EMS_AB_DXA_ADMIN_UPDATE           = (PT_LONG or (          ULONG($807A) shl 16 ));
const PR_EMS_AB_DXA_APPEND_REQCN           = (PT_BOOLEAN or (       ULONG($807B) shl 16 ));
const PR_EMS_AB_DXA_CONF_CONTAINER_LIST    = (PT_MV_TSTRING or (    ULONG($807C) shl 16 ));
const PR_EMS_AB_DXA_CONF_CONTAINER_LIST_A  = (PT_MV_STRING8 or (    ULONG($807C) shl 16 ));
const PR_EMS_AB_DXA_CONF_CONTAINER_LIST_W  = (PT_MV_UNICODE or (    ULONG($807C) shl 16 ));
const PR_EMS_AB_DXA_CONF_CONTAINER_LIST_O  = (PT_OBJECT or (        ULONG($807C) shl 16 ));
const PR_EMS_AB_DXA_CONF_CONTAINER_LIST_T  = (PT_MV_TSTRING or (    ULONG($807C) shl 16 ));
const PR_EMS_AB_DXA_CONF_REQ_TIME          = (PT_SYSTIME or (       ULONG($807D) shl 16 ));
const PR_EMS_AB_DXA_CONF_SEQ               = (PT_TSTRING or (       ULONG($807E) shl 16 ));
const PR_EMS_AB_DXA_CONF_SEQ_A             = (PT_STRING8 or (       ULONG($807E) shl 16 ));
const PR_EMS_AB_DXA_CONF_SEQ_W             = (PT_UNICODE or (       ULONG($807E) shl 16 ));
const PR_EMS_AB_DXA_CONF_SEQ_USN           = (PT_LONG or (          ULONG($807F) shl 16 ));
const PR_EMS_AB_DXA_EXCHANGE_OPTIONS       = (PT_LONG or (          ULONG($8080) shl 16 ));
const PR_EMS_AB_DXA_EXPORT_NOW             = (PT_BOOLEAN or (       ULONG($8081) shl 16 ));
const PR_EMS_AB_DXA_FLAGS                  = (PT_LONG or (          ULONG($8082) shl 16 ));
const PR_EMS_AB_DXA_IMP_SEQ                = (PT_TSTRING or (       ULONG($8083) shl 16 ));
const PR_EMS_AB_DXA_IMP_SEQ_A              = (PT_STRING8 or (       ULONG($8083) shl 16 ));
const PR_EMS_AB_DXA_IMP_SEQ_W              = (PT_UNICODE or (       ULONG($8083) shl 16 ));
const PR_EMS_AB_DXA_IMP_SEQ_TIME           = (PT_SYSTIME or (       ULONG($8084) shl 16 ));
const PR_EMS_AB_DXA_IMP_SEQ_USN            = (PT_LONG or (          ULONG($8085) shl 16 ));
const PR_EMS_AB_DXA_IMPORT_NOW             = (PT_BOOLEAN or (       ULONG($8086) shl 16 ));
const PR_EMS_AB_DXA_IN_TEMPLATE_MAP        = (PT_MV_TSTRING or (    ULONG($8087) shl 16 ));
const PR_EMS_AB_DXA_IN_TEMPLATE_MAP_A      = (PT_MV_STRING8 or (    ULONG($8087) shl 16 ));
const PR_EMS_AB_DXA_IN_TEMPLATE_MAP_W      = (PT_MV_UNICODE or (    ULONG($8087) shl 16 ));
const PR_EMS_AB_DXA_LOCAL_ADMIN            = (PT_TSTRING or (       ULONG($8088) shl 16 ));
const PR_EMS_AB_DXA_LOCAL_ADMIN_A          = (PT_STRING8 or (       ULONG($8088) shl 16 ));
const PR_EMS_AB_DXA_LOCAL_ADMIN_W          = (PT_UNICODE or (       ULONG($8088) shl 16 ));
const PR_EMS_AB_DXA_LOCAL_ADMIN_O          = (PT_OBJECT or (        ULONG($8088) shl 16 ));
const PR_EMS_AB_DXA_LOCAL_ADMIN_T          = (PT_TSTRING or (       ULONG($8088) shl 16 ));
const PR_EMS_AB_DXA_LOGGING_LEVEL          = (PT_LONG or (          ULONG($8089) shl 16 ));
const PR_EMS_AB_DXA_NATIVE_ADDRESS_TYPE    = (PT_TSTRING or (       ULONG($808A) shl 16 ));
const PR_EMS_AB_DXA_NATIVE_ADDRESS_TYPE_A  = (PT_STRING8 or (       ULONG($808A) shl 16 ));
const PR_EMS_AB_DXA_NATIVE_ADDRESS_TYPE_W  = (PT_UNICODE or (       ULONG($808A) shl 16 ));
const PR_EMS_AB_DXA_OUT_TEMPLATE_MAP       = (PT_MV_TSTRING or (    ULONG($808B) shl 16 ));
const PR_EMS_AB_DXA_OUT_TEMPLATE_MAP_A     = (PT_MV_STRING8 or (    ULONG($808B) shl 16 ));
const PR_EMS_AB_DXA_OUT_TEMPLATE_MAP_W     = (PT_MV_UNICODE or (    ULONG($808B) shl 16 ));
const PR_EMS_AB_DXA_PASSWORD               = (PT_TSTRING or (       ULONG($808C) shl 16 ));
const PR_EMS_AB_DXA_PASSWORD_A             = (PT_STRING8 or (       ULONG($808C) shl 16 ));
const PR_EMS_AB_DXA_PASSWORD_W             = (PT_UNICODE or (       ULONG($808C) shl 16 ));
const PR_EMS_AB_DXA_PREV_EXCHANGE_OPTIONS  = (PT_LONG or (          ULONG($808D) shl 16 ));
const PR_EMS_AB_DXA_PREV_EXPORT_NATIVE_ONLY = (PT_BOOLEAN or (       ULONG($808E) shl 16 ));
const PR_EMS_AB_DXA_PREV_IN_EXCHANGE_SENSITIVITY = (PT_LONG or (          ULONG($808F) shl 16 ));
const PR_EMS_AB_DXA_PREV_REMOTE_ENTRIES    = (PT_TSTRING or (       ULONG($8090) shl 16 ));
const PR_EMS_AB_DXA_PREV_REMOTE_ENTRIES_A  = (PT_STRING8 or (       ULONG($8090) shl 16 ));
const PR_EMS_AB_DXA_PREV_REMOTE_ENTRIES_W  = (PT_UNICODE or (       ULONG($8090) shl 16 ));
const PR_EMS_AB_DXA_PREV_REMOTE_ENTRIES_O  = (PT_OBJECT or (        ULONG($8090) shl 16 ));
const PR_EMS_AB_DXA_PREV_REMOTE_ENTRIES_T  = (PT_TSTRING or (       ULONG($8090) shl 16 ));
const PR_EMS_AB_DXA_PREV_REPLICATION_SENSITIVITY = (PT_LONG or (          ULONG($8091) shl 16 ));
const PR_EMS_AB_DXA_PREV_TEMPLATE_OPTIONS  = (PT_LONG or (          ULONG($8092) shl 16 ));
const PR_EMS_AB_DXA_PREV_TYPES             = (PT_LONG or (          ULONG($8093) shl 16 ));
const PR_EMS_AB_DXA_RECIPIENT_CP           = (PT_TSTRING or (       ULONG($8094) shl 16 ));
const PR_EMS_AB_DXA_RECIPIENT_CP_A         = (PT_STRING8 or (       ULONG($8094) shl 16 ));
const PR_EMS_AB_DXA_RECIPIENT_CP_W         = (PT_UNICODE or (       ULONG($8094) shl 16 ));
const PR_EMS_AB_DXA_REMOTE_CLIENT          = (PT_TSTRING or (       ULONG($8095) shl 16 ));
const PR_EMS_AB_DXA_REMOTE_CLIENT_A        = (PT_STRING8 or (       ULONG($8095) shl 16 ));
const PR_EMS_AB_DXA_REMOTE_CLIENT_W        = (PT_UNICODE or (       ULONG($8095) shl 16 ));
const PR_EMS_AB_DXA_REMOTE_CLIENT_O        = (PT_OBJECT or (        ULONG($8095) shl 16 ));
const PR_EMS_AB_DXA_REMOTE_CLIENT_T        = (PT_TSTRING or (       ULONG($8095) shl 16 ));
const PR_EMS_AB_DXA_REQ_SEQ                = (PT_TSTRING or (       ULONG($8096) shl 16 ));
const PR_EMS_AB_DXA_REQ_SEQ_A              = (PT_STRING8 or (       ULONG($8096) shl 16 ));
const PR_EMS_AB_DXA_REQ_SEQ_W              = (PT_UNICODE or (       ULONG($8096) shl 16 ));
const PR_EMS_AB_DXA_REQ_SEQ_TIME           = (PT_SYSTIME or (       ULONG($8097) shl 16 ));
const PR_EMS_AB_DXA_REQ_SEQ_USN            = (PT_LONG or (          ULONG($8098) shl 16 ));
const PR_EMS_AB_DXA_REQNAME                = (PT_TSTRING or (       ULONG($8099) shl 16 ));
const PR_EMS_AB_DXA_REQNAME_A              = (PT_STRING8 or (       ULONG($8099) shl 16 ));
const PR_EMS_AB_DXA_REQNAME_W              = (PT_UNICODE or (       ULONG($8099) shl 16 ));
const PR_EMS_AB_DXA_SVR_SEQ                = (PT_TSTRING or (       ULONG($809A) shl 16 ));
const PR_EMS_AB_DXA_SVR_SEQ_A              = (PT_STRING8 or (       ULONG($809A) shl 16 ));
const PR_EMS_AB_DXA_SVR_SEQ_W              = (PT_UNICODE or (       ULONG($809A) shl 16 ));
const PR_EMS_AB_DXA_SVR_SEQ_TIME           = (PT_SYSTIME or (       ULONG($809B) shl 16 ));
const PR_EMS_AB_DXA_SVR_SEQ_USN            = (PT_LONG or (          ULONG($809C) shl 16 ));
const PR_EMS_AB_DXA_TASK                   = (PT_LONG or (          ULONG($809D) shl 16 ));
const PR_EMS_AB_DXA_TEMPLATE_OPTIONS       = (PT_LONG or (          ULONG($809E) shl 16 ));
const PR_EMS_AB_DXA_TEMPLATE_TIMESTAMP     = (PT_SYSTIME or (       ULONG($809F) shl 16 ));
const PR_EMS_AB_DXA_TYPES                  = (PT_LONG or (          ULONG($80A0) shl 16 ));
const PR_EMS_AB_DXA_UNCONF_CONTAINER_LIST  = (PT_MV_TSTRING or (    ULONG($80A1) shl 16 ));
const PR_EMS_AB_DXA_UNCONF_CONTAINER_LIST_A = (PT_MV_STRING8 or (    ULONG($80A1) shl 16 ));
const PR_EMS_AB_DXA_UNCONF_CONTAINER_LIST_W = (PT_MV_UNICODE or (    ULONG($80A1) shl 16 ));
const PR_EMS_AB_DXA_UNCONF_CONTAINER_LIST_O = (PT_OBJECT or (        ULONG($80A1) shl 16 ));
const PR_EMS_AB_DXA_UNCONF_CONTAINER_LIST_T = (PT_MV_TSTRING or (    ULONG($80A1) shl 16 ));
const PR_EMS_AB_ENABLED_PROTOCOLS          = (PT_LONG or (          ULONG($817F) shl 16 ));
const PR_EMS_AB_ENCAPSULATION_METHOD       = (PT_LONG or (          ULONG($80A2) shl 16 ));
const PR_EMS_AB_ENCRYPT                    = (PT_BOOLEAN or (       ULONG($80A3) shl 16 ));
const PR_EMS_AB_ENCRYPT_ALG_LIST_NA        = (PT_MV_TSTRING or (    ULONG($8040) shl 16 ));
const PR_EMS_AB_ENCRYPT_ALG_LIST_NA_A      = (PT_MV_STRING8 or (    ULONG($8040) shl 16 ));
const PR_EMS_AB_ENCRYPT_ALG_LIST_NA_W      = (PT_MV_UNICODE or (    ULONG($8040) shl 16 ));
const PR_EMS_AB_ENCRYPT_ALG_LIST_OTHER     = (PT_MV_TSTRING or (    ULONG($8041) shl 16 ));
const PR_EMS_AB_ENCRYPT_ALG_LIST_OTHER_A   = (PT_MV_STRING8 or (    ULONG($8041) shl 16 ));
const PR_EMS_AB_ENCRYPT_ALG_LIST_OTHER_W   = (PT_MV_UNICODE or (    ULONG($8041) shl 16 ));
const PR_EMS_AB_ENCRYPT_ALG_SELECTED_NA    = (PT_TSTRING or (       ULONG($8043) shl 16 ));
const PR_EMS_AB_ENCRYPT_ALG_SELECTED_NA_A  = (PT_STRING8 or (       ULONG($8043) shl 16 ));
const PR_EMS_AB_ENCRYPT_ALG_SELECTED_NA_W  = (PT_UNICODE or (       ULONG($8043) shl 16 ));
const PR_EMS_AB_ENCRYPT_ALG_SELECTED_OTHER = (PT_TSTRING or (       ULONG($803D) shl 16 ));
const PR_EMS_AB_ENCRYPT_ALG_SELECTED_OTHER_A = (PT_STRING8 or (       ULONG($803D) shl 16 ));
const PR_EMS_AB_ENCRYPT_ALG_SELECTED_OTHER_W = (PT_UNICODE or (       ULONG($803D) shl 16 ));
const PR_EMS_AB_EXPAND_DLS_LOCALLY         = (PT_BOOLEAN or (       ULONG($80A4) shl 16 ));
const PR_EMS_AB_EXPIRATION_TIME            = (PT_SYSTIME or (       ULONG($8028) shl 16 ));
const PR_EMS_AB_EXPORT_CONTAINERS          = (PT_MV_TSTRING or (    ULONG($80A5) shl 16 ));
const PR_EMS_AB_EXPORT_CONTAINERS_A        = (PT_MV_STRING8 or (    ULONG($80A5) shl 16 ));
const PR_EMS_AB_EXPORT_CONTAINERS_W        = (PT_MV_UNICODE or (    ULONG($80A5) shl 16 ));
const PR_EMS_AB_EXPORT_CONTAINERS_O        = (PT_OBJECT or (        ULONG($80A5) shl 16 ));
const PR_EMS_AB_EXPORT_CONTAINERS_T        = (PT_MV_TSTRING or (    ULONG($80A5) shl 16 ));
const PR_EMS_AB_EXPORT_CUSTOM_RECIPIENTS   = (PT_BOOLEAN or (       ULONG($80A6) shl 16 ));
const PR_EMS_AB_EXTENDED_CHARS_ALLOWED     = (PT_BOOLEAN or (       ULONG($80A7) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_1      = (PT_TSTRING or (       ULONG($802D) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_1_A    = (PT_STRING8 or (       ULONG($802D) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_1_W    = (PT_UNICODE or (       ULONG($802D) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_10     = (PT_TSTRING or (       ULONG($8036) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_10_A   = (PT_STRING8 or (       ULONG($8036) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_10_W   = (PT_UNICODE or (       ULONG($8036) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_2      = (PT_TSTRING or (       ULONG($802E) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_2_A    = (PT_STRING8 or (       ULONG($802E) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_2_W    = (PT_UNICODE or (       ULONG($802E) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_3      = (PT_TSTRING or (       ULONG($802F) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_3_A    = (PT_STRING8 or (       ULONG($802F) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_3_W    = (PT_UNICODE or (       ULONG($802F) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_4      = (PT_TSTRING or (       ULONG($8030) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_4_A    = (PT_STRING8 or (       ULONG($8030) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_4_W    = (PT_UNICODE or (       ULONG($8030) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_5      = (PT_TSTRING or (       ULONG($8031) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_5_A    = (PT_STRING8 or (       ULONG($8031) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_5_W    = (PT_UNICODE or (       ULONG($8031) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_6      = (PT_TSTRING or (       ULONG($8032) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_6_A    = (PT_STRING8 or (       ULONG($8032) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_6_W    = (PT_UNICODE or (       ULONG($8032) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_7      = (PT_TSTRING or (       ULONG($8033) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_7_A    = (PT_STRING8 or (       ULONG($8033) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_7_W    = (PT_UNICODE or (       ULONG($8033) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_8      = (PT_TSTRING or (       ULONG($8034) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_8_A    = (PT_STRING8 or (       ULONG($8034) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_8_W    = (PT_UNICODE or (       ULONG($8034) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_9      = (PT_TSTRING or (       ULONG($8035) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_9_A    = (PT_STRING8 or (       ULONG($8035) shl 16 ));
const PR_EMS_AB_EXTENSION_ATTRIBUTE_9_W    = (PT_UNICODE or (       ULONG($8035) shl 16 ));
const PR_EMS_AB_EXTENSION_DATA             = (PT_MV_BINARY or (     ULONG($80A8) shl 16 ));
const PR_EMS_AB_EXTENSION_NAME             = (PT_MV_TSTRING or (    ULONG($80A9) shl 16 ));
const PR_EMS_AB_EXTENSION_NAME_A           = (PT_MV_STRING8 or (    ULONG($80A9) shl 16 ));
const PR_EMS_AB_EXTENSION_NAME_W           = (PT_MV_UNICODE or (    ULONG($80A9) shl 16 ));
const PR_EMS_AB_EXTENSION_NAME_INHERITED   = (PT_MV_TSTRING or (    ULONG($80AA) shl 16 ));
const PR_EMS_AB_EXTENSION_NAME_INHERITED_A = (PT_MV_STRING8 or (    ULONG($80AA) shl 16 ));
const PR_EMS_AB_EXTENSION_NAME_INHERITED_W = (PT_MV_UNICODE or (    ULONG($80AA) shl 16 ));
const PR_EMS_AB_FACSIMILE_TELEPHONE_NUMBER = (PT_MV_BINARY or (     ULONG($80AB) shl 16 ));
const PR_EMS_AB_FILE_VERSION               = (PT_BINARY or (        ULONG($80AC) shl 16 ));
const PR_EMS_AB_FILTER_LOCAL_ADDRESSES     = (PT_BOOLEAN or (       ULONG($80AD) shl 16 ));
const PR_EMS_AB_FOLDER_PATHNAME            = (PT_TSTRING or (       ULONG($8004) shl 16 ));
const PR_EMS_AB_FOLDER_PATHNAME_A          = (PT_STRING8 or (       ULONG($8004) shl 16 ));
const PR_EMS_AB_FOLDER_PATHNAME_W          = (PT_UNICODE or (       ULONG($8004) shl 16 ));
const PR_EMS_AB_FOLDERS_CONTAINER          = (PT_TSTRING or (       ULONG($80AE) shl 16 ));
const PR_EMS_AB_FOLDERS_CONTAINER_A        = (PT_STRING8 or (       ULONG($80AE) shl 16 ));
const PR_EMS_AB_FOLDERS_CONTAINER_W        = (PT_UNICODE or (       ULONG($80AE) shl 16 ));
const PR_EMS_AB_FOLDERS_CONTAINER_O        = (PT_OBJECT or (        ULONG($80AE) shl 16 ));
const PR_EMS_AB_FOLDERS_CONTAINER_T        = (PT_TSTRING or (       ULONG($80AE) shl 16 ));
const PR_EMS_AB_GARBAGE_COLL_PERIOD        = (PT_LONG or (          ULONG($80AF) shl 16 ));
const PR_EMS_AB_GATEWAY_LOCAL_CRED         = (PT_TSTRING or (       ULONG($80B0) shl 16 ));
const PR_EMS_AB_GATEWAY_LOCAL_CRED_A       = (PT_STRING8 or (       ULONG($80B0) shl 16 ));
const PR_EMS_AB_GATEWAY_LOCAL_CRED_W       = (PT_UNICODE or (       ULONG($80B0) shl 16 ));
const PR_EMS_AB_GATEWAY_LOCAL_DESIG        = (PT_TSTRING or (       ULONG($80B1) shl 16 ));
const PR_EMS_AB_GATEWAY_LOCAL_DESIG_A      = (PT_STRING8 or (       ULONG($80B1) shl 16 ));
const PR_EMS_AB_GATEWAY_LOCAL_DESIG_W      = (PT_UNICODE or (       ULONG($80B1) shl 16 ));
const PR_EMS_AB_GATEWAY_PROXY              = (PT_MV_TSTRING or (    ULONG($80B2) shl 16 ));
const PR_EMS_AB_GATEWAY_PROXY_A            = (PT_MV_STRING8 or (    ULONG($80B2) shl 16 ));
const PR_EMS_AB_GATEWAY_PROXY_W            = (PT_MV_UNICODE or (    ULONG($80B2) shl 16 ));
const PR_EMS_AB_GATEWAY_ROUTING_TREE       = (PT_BINARY or (        ULONG($80B3) shl 16 ));
const PR_EMS_AB_GWART_LAST_MODIFIED        = (PT_SYSTIME or (       ULONG($80B4) shl 16 ));
const PR_EMS_AB_HAS_FULL_REPLICA_NCS       = (PT_MV_TSTRING or (    ULONG($80B5) shl 16 ));
const PR_EMS_AB_HAS_FULL_REPLICA_NCS_A     = (PT_MV_STRING8 or (    ULONG($80B5) shl 16 ));
const PR_EMS_AB_HAS_FULL_REPLICA_NCS_W     = (PT_MV_UNICODE or (    ULONG($80B5) shl 16 ));
const PR_EMS_AB_HAS_FULL_REPLICA_NCS_O     = (PT_OBJECT or (        ULONG($80B5) shl 16 ));
const PR_EMS_AB_HAS_FULL_REPLICA_NCS_T     = (PT_MV_TSTRING or (    ULONG($80B5) shl 16 ));
const PR_EMS_AB_HAS_MASTER_NCS             = (PT_MV_TSTRING or (    ULONG($80B6) shl 16 ));
const PR_EMS_AB_HAS_MASTER_NCS_A           = (PT_MV_STRING8 or (    ULONG($80B6) shl 16 ));
const PR_EMS_AB_HAS_MASTER_NCS_W           = (PT_MV_UNICODE or (    ULONG($80B6) shl 16 ));
const PR_EMS_AB_HAS_MASTER_NCS_O           = (PT_OBJECT or (        ULONG($80B6) shl 16 ));
const PR_EMS_AB_HAS_MASTER_NCS_T           = (PT_MV_TSTRING or (    ULONG($80B6) shl 16 ));
const PR_EMS_AB_HELP_DATA16                = (PT_BINARY or (        ULONG($803A) shl 16 ));
const PR_EMS_AB_HELP_DATA32                = (PT_BINARY or (        ULONG($8010) shl 16 ));
const PR_EMS_AB_HELP_FILE_NAME             = (PT_TSTRING or (       ULONG($803B) shl 16 ));
const PR_EMS_AB_HELP_FILE_NAME_A           = (PT_STRING8 or (       ULONG($803B) shl 16 ));
const PR_EMS_AB_HELP_FILE_NAME_W           = (PT_UNICODE or (       ULONG($803B) shl 16 ));
const PR_EMS_AB_HEURISTICS                 = (PT_LONG or (          ULONG($80B7) shl 16 ));
const PR_EMS_AB_HIDE_DL_MEMBERSHIP         = (PT_BOOLEAN or (       ULONG($80B8) shl 16 ));
const PR_EMS_AB_HIDE_FROM_ADDRESS_BOOK     = (PT_BOOLEAN or (       ULONG($80B9) shl 16 ));
const PR_EMS_AB_HOME_MDB                   = (PT_TSTRING or (       ULONG($8006) shl 16 ));
const PR_EMS_AB_HOME_MDB_A                 = (PT_STRING8 or (       ULONG($8006) shl 16 ));
const PR_EMS_AB_HOME_MDB_W                 = (PT_UNICODE or (       ULONG($8006) shl 16 ));
const PR_EMS_AB_HOME_MDB_O                 = (PT_OBJECT or (        ULONG($8006) shl 16 ));
const PR_EMS_AB_HOME_MDB_T                 = (PT_TSTRING or (       ULONG($8006) shl 16 ));
const PR_EMS_AB_HOME_MDB_BL                = (PT_MV_TSTRING or (    ULONG($8014) shl 16 ));
const PR_EMS_AB_HOME_MDB_BL_A              = (PT_MV_STRING8 or (    ULONG($8014) shl 16 ));
const PR_EMS_AB_HOME_MDB_BL_W              = (PT_MV_UNICODE or (    ULONG($8014) shl 16 ));
const PR_EMS_AB_HOME_MDB_BL_O              = (PT_OBJECT or (        ULONG($8014) shl 16 ));
const PR_EMS_AB_HOME_MDB_BL_T              = (PT_MV_TSTRING or (    ULONG($8014) shl 16 ));
const PR_EMS_AB_HOME_MTA                   = (PT_TSTRING or (       ULONG($8007) shl 16 ));
const PR_EMS_AB_HOME_MTA_A                 = (PT_STRING8 or (       ULONG($8007) shl 16 ));
const PR_EMS_AB_HOME_MTA_W                 = (PT_UNICODE or (       ULONG($8007) shl 16 ));
const PR_EMS_AB_HOME_MTA_O                 = (PT_OBJECT or (        ULONG($8007) shl 16 ));
const PR_EMS_AB_HOME_MTA_T                 = (PT_TSTRING or (       ULONG($8007) shl 16 ));
const PR_EMS_AB_HOME_PUBLIC_SERVER         = (PT_TSTRING or (       ULONG($803F) shl 16 ));
const PR_EMS_AB_HOME_PUBLIC_SERVER_A       = (PT_STRING8 or (       ULONG($803F) shl 16 ));
const PR_EMS_AB_HOME_PUBLIC_SERVER_W       = (PT_UNICODE or (       ULONG($803F) shl 16 ));
const PR_EMS_AB_HOME_PUBLIC_SERVER_O       = (PT_OBJECT or (        ULONG($803F) shl 16 ));
const PR_EMS_AB_HOME_PUBLIC_SERVER_T       = (PT_TSTRING or (       ULONG($803F) shl 16 ));
const PR_EMS_AB_IMPORT_CONTAINER           = (PT_TSTRING or (       ULONG($80BA) shl 16 ));
const PR_EMS_AB_IMPORT_CONTAINER_A         = (PT_STRING8 or (       ULONG($80BA) shl 16 ));
const PR_EMS_AB_IMPORT_CONTAINER_W         = (PT_UNICODE or (       ULONG($80BA) shl 16 ));
const PR_EMS_AB_IMPORT_CONTAINER_O         = (PT_OBJECT or (        ULONG($80BA) shl 16 ));
const PR_EMS_AB_IMPORT_CONTAINER_T         = (PT_TSTRING or (       ULONG($80BA) shl 16 ));
const PR_EMS_AB_IMPORT_SENSITIVITY         = (PT_LONG or (          ULONG($80BB) shl 16 ));
const PR_EMS_AB_IMPORTED_FROM              = (PT_TSTRING or (       ULONG($8042) shl 16 ));
const PR_EMS_AB_IMPORTED_FROM_A            = (PT_STRING8 or (       ULONG($8042) shl 16 ));
const PR_EMS_AB_IMPORTED_FROM_W            = (PT_UNICODE or (       ULONG($8042) shl 16 ));
const PR_EMS_AB_INBOUND_SITES              = (PT_MV_TSTRING or (    ULONG($80BC) shl 16 ));
const PR_EMS_AB_INBOUND_SITES_A            = (PT_MV_STRING8 or (    ULONG($80BC) shl 16 ));
const PR_EMS_AB_INBOUND_SITES_W            = (PT_MV_UNICODE or (    ULONG($80BC) shl 16 ));
const PR_EMS_AB_INBOUND_SITES_O            = (PT_OBJECT or (        ULONG($80BC) shl 16 ));
const PR_EMS_AB_INBOUND_SITES_T            = (PT_MV_TSTRING or (    ULONG($80BC) shl 16 ));
const PR_EMS_AB_INSTANCE_TYPE              = (PT_LONG or (          ULONG($80BD) shl 16 ));
const PR_EMS_AB_INTERNATIONAL_ISDN_NUMBER  = (PT_MV_TSTRING or (    ULONG($80BE) shl 16 ));
const PR_EMS_AB_INTERNATIONAL_ISDN_NUMBER_A = (PT_MV_STRING8 or (    ULONG($80BE) shl 16 ));
const PR_EMS_AB_INTERNATIONAL_ISDN_NUMBER_W = (PT_MV_UNICODE or (    ULONG($80BE) shl 16 ));
const PR_EMS_AB_INVOCATION_ID              = (PT_BINARY or (        ULONG($80BF) shl 16 ));
const PR_EMS_AB_IS_DELETED                 = (PT_BOOLEAN or (       ULONG($80C0) shl 16 ));
const PR_EMS_AB_IS_MEMBER_OF_DL            = (PT_OBJECT or (	 ULONG($8008) shl 16 ));
const PR_EMS_AB_IS_MEMBER_OF_DL_A          = (PT_MV_STRING8 or (    ULONG($8008) shl 16 ));
const PR_EMS_AB_IS_MEMBER_OF_DL_W          = (PT_MV_UNICODE or (    ULONG($8008) shl 16 ));
const PR_EMS_AB_IS_MEMBER_OF_DL_O          = (PT_OBJECT or (        ULONG($8008) shl 16 ));
const PR_EMS_AB_IS_MEMBER_OF_DL_T          = (PT_MV_TSTRING or (    ULONG($8008) shl 16 ));
const PR_EMS_AB_IS_SINGLE_VALUED           = (PT_BOOLEAN or (       ULONG($80C1) shl 16 ));
const PR_EMS_AB_KCC_STATUS                 = (PT_MV_BINARY or (     ULONG($80C2) shl 16 ));
const PR_EMS_AB_KM_SERVER                  = (PT_TSTRING or (       ULONG($800D) shl 16 ));
const PR_EMS_AB_KM_SERVER_A                = (PT_STRING8 or (       ULONG($800D) shl 16 ));
const PR_EMS_AB_KM_SERVER_W                = (PT_UNICODE or (       ULONG($800D) shl 16 ));
const PR_EMS_AB_KM_SERVER_O                = (PT_OBJECT or (        ULONG($800D) shl 16 ));
const PR_EMS_AB_KM_SERVER_T                = (PT_TSTRING or (       ULONG($800D) shl 16 ));
const PR_EMS_AB_KNOWLEDGE_INFORMATION      = (PT_MV_TSTRING or (    ULONG($80C3) shl 16 ));
const PR_EMS_AB_KNOWLEDGE_INFORMATION_A    = (PT_MV_STRING8 or (    ULONG($80C3) shl 16 ));
const PR_EMS_AB_KNOWLEDGE_INFORMATION_W    = (PT_MV_UNICODE or (    ULONG($80C3) shl 16 ));
const PR_EMS_AB_LANGUAGE                   = (PT_LONG or (          ULONG($8178) shl 16 ));
const PR_EMS_AB_LDAP_DISPLAY_NAME          = (PT_MV_TSTRING or (    ULONG($8171) shl 16 ));
const PR_EMS_AB_LDAP_DISPLAY_NAME_A        = (PT_MV_STRING8 or (    ULONG($8171) shl 16 ));
const PR_EMS_AB_LDAP_DISPLAY_NAME_W        = (PT_MV_UNICODE or (    ULONG($8171) shl 16 ));
const PR_EMS_AB_LINE_WRAP                  = (PT_LONG or (          ULONG($80C4) shl 16 ));
const PR_EMS_AB_LINK_ID                    = (PT_LONG or (          ULONG($80C5) shl 16 ));
const PR_EMS_AB_LOCAL_BRIDGE_HEAD          = (PT_TSTRING or (       ULONG($80C6) shl 16 ));
const PR_EMS_AB_LOCAL_BRIDGE_HEAD_A        = (PT_STRING8 or (       ULONG($80C6) shl 16 ));
const PR_EMS_AB_LOCAL_BRIDGE_HEAD_W        = (PT_UNICODE or (       ULONG($80C6) shl 16 ));
const PR_EMS_AB_LOCAL_BRIDGE_HEAD_ADDRESS  = (PT_TSTRING or (       ULONG($80C7) shl 16 ));
const PR_EMS_AB_LOCAL_BRIDGE_HEAD_ADDRESS_A = (PT_STRING8 or (       ULONG($80C7) shl 16 ));
const PR_EMS_AB_LOCAL_BRIDGE_HEAD_ADDRESS_W = (PT_UNICODE or (       ULONG($80C7) shl 16 ));
const PR_EMS_AB_LOCAL_INITIAL_TURN         = (PT_BOOLEAN or (       ULONG($80C8) shl 16 ));
const PR_EMS_AB_LOCAL_SCOPE                = (PT_MV_TSTRING or (    ULONG($80C9) shl 16 ));
const PR_EMS_AB_LOCAL_SCOPE_A              = (PT_MV_STRING8 or (    ULONG($80C9) shl 16 ));
const PR_EMS_AB_LOCAL_SCOPE_W              = (PT_MV_UNICODE or (    ULONG($80C9) shl 16 ));
const PR_EMS_AB_LOCAL_SCOPE_O              = (PT_OBJECT or (        ULONG($80C9) shl 16 ));
const PR_EMS_AB_LOCAL_SCOPE_T              = (PT_MV_TSTRING or (    ULONG($80C9) shl 16 ));
const PR_EMS_AB_LOG_FILENAME               = (PT_TSTRING or (       ULONG($80CA) shl 16 ));
const PR_EMS_AB_LOG_FILENAME_A             = (PT_STRING8 or (       ULONG($80CA) shl 16 ));
const PR_EMS_AB_LOG_FILENAME_W             = (PT_UNICODE or (       ULONG($80CA) shl 16 ));
const PR_EMS_AB_LOG_ROLLOVER_INTERVAL      = (PT_LONG or (          ULONG($80CB) shl 16 ));
const PR_EMS_AB_MAINTAIN_AUTOREPLY_HISTORY = (PT_BOOLEAN or (       ULONG($80CC) shl 16 ));
const PR_EMS_AB_MANAGER                    = (PT_OBJECT or (        ULONG($8005) shl 16 ));
const PR_EMS_AB_MANAGER_A                  = (PT_STRING8 or (       ULONG($8005) shl 16 ));
const PR_EMS_AB_MANAGER_W                  = (PT_UNICODE or (       ULONG($8005) shl 16 ));
const PR_EMS_AB_MANAGER_O                  = (PT_OBJECT or (        ULONG($8005) shl 16 ));
const PR_EMS_AB_MANAGER_T                  = (PT_TSTRING or (       ULONG($8005) shl 16 ));
const PR_EMS_AB_MAPI_DISPLAY_TYPE          = (PT_LONG or (          ULONG($80CD) shl 16 ));
const PR_EMS_AB_MAPI_ID                    = (PT_LONG or (          ULONG($80CE) shl 16 ));
const PR_EMS_AB_MAXIMUM_OBJECT_ID          = (PT_BINARY or (        ULONG($8169) shl 16 ));
const PR_EMS_AB_MDB_BACKOFF_INTERVAL       = (PT_LONG or (          ULONG($80CF) shl 16 ));
const PR_EMS_AB_MDB_MSG_TIME_OUT_PERIOD    = (PT_LONG or (          ULONG($80D0) shl 16 ));
const PR_EMS_AB_MDB_OVER_QUOTA_LIMIT       = (PT_LONG or (          ULONG($80D1) shl 16 ));
const PR_EMS_AB_MDB_STORAGE_QUOTA          = (PT_LONG or (          ULONG($80D2) shl 16 ));
const PR_EMS_AB_MDB_UNREAD_LIMIT           = (PT_LONG or (          ULONG($80D3) shl 16 ));
const PR_EMS_AB_MDB_USE_DEFAULTS           = (PT_BOOLEAN or (       ULONG($80D4) shl 16 ));
const PR_EMS_AB_MEMBER                     = (PT_OBJECT or (        ULONG($8009) shl 16 ));
const PR_EMS_AB_MEMBER_A                   = (PT_MV_STRING8 or (    ULONG($8009) shl 16 ));
const PR_EMS_AB_MEMBER_W                   = (PT_MV_UNICODE or (    ULONG($8009) shl 16 ));
const PR_EMS_AB_MEMBER_O                   = (PT_OBJECT or (        ULONG($8009) shl 16 ));
const PR_EMS_AB_MEMBER_T                   = (PT_MV_TSTRING or (    ULONG($8009) shl 16 ));
const PR_EMS_AB_MESSAGE_TRACKING_ENABLED   = (PT_BOOLEAN or (       ULONG($80D5) shl 16 ));
const PR_EMS_AB_MONITOR_CLOCK              = (PT_BOOLEAN or (       ULONG($80D6) shl 16 ));
const PR_EMS_AB_MONITOR_SERVERS            = (PT_BOOLEAN or (       ULONG($80D7) shl 16 ));
const PR_EMS_AB_MONITOR_SERVICES           = (PT_BOOLEAN or (       ULONG($80D8) shl 16 ));
const PR_EMS_AB_MONITORED_CONFIGURATIONS   = (PT_MV_TSTRING or (    ULONG($80D9) shl 16 ));
const PR_EMS_AB_MONITORED_CONFIGURATIONS_A = (PT_MV_STRING8 or (    ULONG($80D9) shl 16 ));
const PR_EMS_AB_MONITORED_CONFIGURATIONS_W = (PT_MV_UNICODE or (    ULONG($80D9) shl 16 ));
const PR_EMS_AB_MONITORED_CONFIGURATIONS_O = (PT_OBJECT or (        ULONG($80D9) shl 16 ));
const PR_EMS_AB_MONITORED_CONFIGURATIONS_T = (PT_MV_TSTRING or (    ULONG($80D9) shl 16 ));
const PR_EMS_AB_MONITORED_SERVERS          = (PT_MV_TSTRING or (    ULONG($80DA) shl 16 ));
const PR_EMS_AB_MONITORED_SERVERS_A        = (PT_MV_STRING8 or (    ULONG($80DA) shl 16 ));
const PR_EMS_AB_MONITORED_SERVERS_W        = (PT_MV_UNICODE or (    ULONG($80DA) shl 16 ));
const PR_EMS_AB_MONITORED_SERVERS_O        = (PT_OBJECT or (        ULONG($80DA) shl 16 ));
const PR_EMS_AB_MONITORED_SERVERS_T        = (PT_MV_TSTRING or (    ULONG($80DA) shl 16 ));
const PR_EMS_AB_MONITORED_SERVICES         = (PT_MV_TSTRING or (    ULONG($80DB) shl 16 ));
const PR_EMS_AB_MONITORED_SERVICES_A       = (PT_MV_STRING8 or (    ULONG($80DB) shl 16 ));
const PR_EMS_AB_MONITORED_SERVICES_W       = (PT_MV_UNICODE or (    ULONG($80DB) shl 16 ));
const PR_EMS_AB_MONITORING_ALERT_DELAY     = (PT_LONG or (          ULONG($80DC) shl 16 ));
const PR_EMS_AB_MONITORING_ALERT_UNITS     = (PT_LONG or (          ULONG($80DD) shl 16 ));
const PR_EMS_AB_MONITORING_AVAILABILITY_STYLE = (PT_LONG or (          ULONG($80DE) shl 16 ));
const PR_EMS_AB_MONITORING_AVAILABILITY_WINDOW = (PT_BINARY or (        ULONG($80DF) shl 16 ));
const PR_EMS_AB_MONITORING_CACHED_VIA_MAIL = (PT_MV_TSTRING or (    ULONG($80E0) shl 16 ));
const PR_EMS_AB_MONITORING_CACHED_VIA_MAIL_A = (PT_MV_STRING8 or (    ULONG($80E0) shl 16 ));
const PR_EMS_AB_MONITORING_CACHED_VIA_MAIL_W = (PT_MV_UNICODE or (    ULONG($80E0) shl 16 ));
const PR_EMS_AB_MONITORING_CACHED_VIA_MAIL_O = (PT_OBJECT or (        ULONG($80E0) shl 16 ));
const PR_EMS_AB_MONITORING_CACHED_VIA_MAIL_T = (PT_MV_TSTRING or (    ULONG($80E0) shl 16 ));
const PR_EMS_AB_MONITORING_CACHED_VIA_RPC  = (PT_MV_TSTRING or (    ULONG($80E1) shl 16 ));
const PR_EMS_AB_MONITORING_CACHED_VIA_RPC_A = (PT_MV_STRING8 or (    ULONG($80E1) shl 16 ));
const PR_EMS_AB_MONITORING_CACHED_VIA_RPC_W = (PT_MV_UNICODE or (    ULONG($80E1) shl 16 ));
const PR_EMS_AB_MONITORING_CACHED_VIA_RPC_O = (PT_OBJECT or (        ULONG($80E1) shl 16 ));
const PR_EMS_AB_MONITORING_CACHED_VIA_RPC_T = (PT_MV_TSTRING or (    ULONG($80E1) shl 16 ));
const PR_EMS_AB_MONITORING_ESCALATION_PROCEDURE = (PT_MV_BINARY or (     ULONG($80E2) shl 16 ));
const PR_EMS_AB_MONITORING_HOTSITE_POLL_INTERVAL = (PT_LONG or (          ULONG($80E3) shl 16 ));
const PR_EMS_AB_MONITORING_HOTSITE_POLL_UNITS = (PT_LONG or (          ULONG($80E4) shl 16 ));
const PR_EMS_AB_MONITORING_MAIL_UPDATE_INTERVAL = (PT_LONG or (          ULONG($80E5) shl 16 ));
const PR_EMS_AB_MONITORING_MAIL_UPDATE_UNITS = (PT_LONG or (          ULONG($80E6) shl 16 ));
const PR_EMS_AB_MONITORING_NORMAL_POLL_INTERVAL = (PT_LONG or (          ULONG($80E7) shl 16 ));
const PR_EMS_AB_MONITORING_NORMAL_POLL_UNITS = (PT_LONG or (          ULONG($80E8) shl 16 ));
const PR_EMS_AB_MONITORING_RECIPIENTS      = (PT_MV_TSTRING or (    ULONG($80E9) shl 16 ));
const PR_EMS_AB_MONITORING_RECIPIENTS_A    = (PT_MV_STRING8 or (    ULONG($80E9) shl 16 ));
const PR_EMS_AB_MONITORING_RECIPIENTS_W    = (PT_MV_UNICODE or (    ULONG($80E9) shl 16 ));
const PR_EMS_AB_MONITORING_RECIPIENTS_O    = (PT_OBJECT or (        ULONG($80E9) shl 16 ));
const PR_EMS_AB_MONITORING_RECIPIENTS_T    = (PT_MV_TSTRING or (    ULONG($80E9) shl 16 ));
const PR_EMS_AB_MONITORING_RECIPIENTS_NDR  = (PT_MV_TSTRING or (    ULONG($80EA) shl 16 ));
const PR_EMS_AB_MONITORING_RECIPIENTS_NDR_A = (PT_MV_STRING8 or (    ULONG($80EA) shl 16 ));
const PR_EMS_AB_MONITORING_RECIPIENTS_NDR_W = (PT_MV_UNICODE or (    ULONG($80EA) shl 16 ));
const PR_EMS_AB_MONITORING_RECIPIENTS_NDR_O = (PT_OBJECT or (        ULONG($80EA) shl 16 ));
const PR_EMS_AB_MONITORING_RECIPIENTS_NDR_T = (PT_MV_TSTRING or (    ULONG($80EA) shl 16 ));
const PR_EMS_AB_MONITORING_RPC_UPDATE_INTERVAL = (PT_LONG or (          ULONG($80EB) shl 16 ));
const PR_EMS_AB_MONITORING_RPC_UPDATE_UNITS = (PT_LONG or (          ULONG($80EC) shl 16 ));
const PR_EMS_AB_MONITORING_WARNING_DELAY   = (PT_LONG or (          ULONG($80ED) shl 16 ));
const PR_EMS_AB_MONITORING_WARNING_UNITS   = (PT_LONG or (          ULONG($80EE) shl 16 ));
const PR_EMS_AB_MTA_LOCAL_CRED             = (PT_TSTRING or (       ULONG($80EF) shl 16 ));
const PR_EMS_AB_MTA_LOCAL_CRED_A           = (PT_STRING8 or (       ULONG($80EF) shl 16 ));
const PR_EMS_AB_MTA_LOCAL_CRED_W           = (PT_UNICODE or (       ULONG($80EF) shl 16 ));
const PR_EMS_AB_MTA_LOCAL_DESIG            = (PT_TSTRING or (       ULONG($80F0) shl 16 ));
const PR_EMS_AB_MTA_LOCAL_DESIG_A          = (PT_STRING8 or (       ULONG($80F0) shl 16 ));
const PR_EMS_AB_MTA_LOCAL_DESIG_W          = (PT_UNICODE or (       ULONG($80F0) shl 16 ));
const PR_EMS_AB_N_ADDRESS                  = (PT_BINARY or (        ULONG($80F1) shl 16 ));
const PR_EMS_AB_N_ADDRESS_TYPE             = (PT_LONG or (          ULONG($80F2) shl 16 ));
const PR_EMS_AB_NETWORK_ADDRESS            = (PT_MV_TSTRING or (    ULONG($8170) shl 16 ));
const PR_EMS_AB_NETWORK_ADDRESS_A          = (PT_MV_STRING8 or (    ULONG($8170) shl 16 ));
const PR_EMS_AB_NETWORK_ADDRESS_W          = (PT_MV_UNICODE or (    ULONG($8170) shl 16 ));
const PR_EMS_AB_NNTP_CHARACTER_SET         = (PT_TSTRING or (       ULONG($817D) shl 16 ));
const PR_EMS_AB_NNTP_CHARACTER_SET_A       = (PT_STRING8 or (       ULONG($817D) shl 16 ));
const PR_EMS_AB_NNTP_CHARACTER_SET_W       = (PT_UNICODE or (       ULONG($817D) shl 16 ));
const PR_EMS_AB_NNTP_CONTENT_FORMAT        = (PT_TSTRING or (       ULONG($8176) shl 16 ));
const PR_EMS_AB_NNTP_CONTENT_FORMAT_A      = (PT_STRING8 or (       ULONG($8176) shl 16 ));
const PR_EMS_AB_NNTP_CONTENT_FORMAT_W      = (PT_UNICODE or (       ULONG($8176) shl 16 ));
const PR_EMS_AB_NT_MACHINE_NAME            = (PT_TSTRING or (       ULONG($80F3) shl 16 ));
const PR_EMS_AB_NT_MACHINE_NAME_A          = (PT_STRING8 or (       ULONG($80F3) shl 16 ));
const PR_EMS_AB_NT_MACHINE_NAME_W          = (PT_UNICODE or (       ULONG($80F3) shl 16 ));
const PR_EMS_AB_NT_SECURITY_DESCRIPTOR     = (PT_BINARY or (        ULONG($8013) shl 16 ));
const PR_EMS_AB_NUM_OF_OPEN_RETRIES        = (PT_LONG or (          ULONG($80F4) shl 16 ));
const PR_EMS_AB_NUM_OF_TRANSFER_RETRIES    = (PT_LONG or (          ULONG($80F5) shl 16 ));
const PR_EMS_AB_OBJ_DIST_NAME              = (PT_TSTRING or (       ULONG($803C) shl 16 ));
const PR_EMS_AB_OBJ_DIST_NAME_A            = (PT_STRING8 or (       ULONG($803C) shl 16 ));
const PR_EMS_AB_OBJ_DIST_NAME_W            = (PT_UNICODE or (       ULONG($803C) shl 16 ));
const PR_EMS_AB_OBJ_DIST_NAME_O            = (PT_OBJECT or (        ULONG($803C) shl 16 ));
const PR_EMS_AB_OBJ_DIST_NAME_T            = (PT_TSTRING or (       ULONG($803C) shl 16 ));
const PR_EMS_AB_OBJECT_CLASS_CATEGORY      = (PT_LONG or (          ULONG($80F6) shl 16 ));
const PR_EMS_AB_OBJECT_VERSION             = (PT_LONG or (          ULONG($80F7) shl 16 ));
const PR_EMS_AB_OFF_LINE_AB_CONTAINERS     = (PT_MV_TSTRING or (    ULONG($80F8) shl 16 ));
const PR_EMS_AB_OFF_LINE_AB_CONTAINERS_A   = (PT_MV_STRING8 or (    ULONG($80F8) shl 16 ));
const PR_EMS_AB_OFF_LINE_AB_CONTAINERS_W   = (PT_MV_UNICODE or (    ULONG($80F8) shl 16 ));
const PR_EMS_AB_OFF_LINE_AB_CONTAINERS_O   = (PT_OBJECT or (        ULONG($80F8) shl 16 ));
const PR_EMS_AB_OFF_LINE_AB_CONTAINERS_T   = (PT_MV_TSTRING or (    ULONG($80F8) shl 16 ));
const PR_EMS_AB_OFF_LINE_AB_SCHEDULE       = (PT_BINARY or (        ULONG($80F9) shl 16 ));
const PR_EMS_AB_OFF_LINE_AB_SERVER         = (PT_TSTRING or (       ULONG($80FA) shl 16 ));
const PR_EMS_AB_OFF_LINE_AB_SERVER_A       = (PT_STRING8 or (       ULONG($80FA) shl 16 ));
const PR_EMS_AB_OFF_LINE_AB_SERVER_W       = (PT_UNICODE or (       ULONG($80FA) shl 16 ));
const PR_EMS_AB_OFF_LINE_AB_SERVER_O       = (PT_OBJECT or (        ULONG($80FA) shl 16 ));
const PR_EMS_AB_OFF_LINE_AB_SERVER_T       = (PT_TSTRING or (       ULONG($80FA) shl 16 ));
const PR_EMS_AB_OFF_LINE_AB_STYLE          = (PT_LONG or (          ULONG($80FB) shl 16 ));
const PR_EMS_AB_OID_TYPE                   = (PT_LONG or (          ULONG($80FC) shl 16 ));
const PR_EMS_AB_OM_OBJECT_CLASS            = (PT_BINARY or (        ULONG($80FD) shl 16 ));
const PR_EMS_AB_OM_SYNTAX                  = (PT_LONG or (          ULONG($80FE) shl 16 ));
const PR_EMS_AB_OOF_REPLY_TO_ORIGINATOR    = (PT_BOOLEAN or (       ULONG($80FF) shl 16 ));
const PR_EMS_AB_OPEN_RETRY_INTERVAL        = (PT_LONG or (          ULONG($8100) shl 16 ));
const PR_EMS_AB_ORGANIZATION_NAME          = (PT_MV_TSTRING or (    ULONG($8101) shl 16 ));
const PR_EMS_AB_ORGANIZATION_NAME_A        = (PT_MV_STRING8 or (    ULONG($8101) shl 16 ));
const PR_EMS_AB_ORGANIZATION_NAME_W        = (PT_MV_UNICODE or (    ULONG($8101) shl 16 ));
const PR_EMS_AB_ORGANIZATIONAL_UNIT_NAME   = (PT_MV_TSTRING or (    ULONG($8102) shl 16 ));
const PR_EMS_AB_ORGANIZATIONAL_UNIT_NAME_A = (PT_MV_STRING8 or (    ULONG($8102) shl 16 ));
const PR_EMS_AB_ORGANIZATIONAL_UNIT_NAME_W = (PT_MV_UNICODE or (    ULONG($8102) shl 16 ));
const PR_EMS_AB_ORIGINAL_DISPLAY_TABLE     = (PT_BINARY or (        ULONG($8103) shl 16 ));
const PR_EMS_AB_ORIGINAL_DISPLAY_TABLE_MSDOS = (PT_BINARY or (        ULONG($8104) shl 16 ));
const PR_EMS_AB_OUTBOUND_SITES             = (PT_MV_TSTRING or (    ULONG($8105) shl 16 ));
const PR_EMS_AB_OUTBOUND_SITES_A           = (PT_MV_STRING8 or (    ULONG($8105) shl 16 ));
const PR_EMS_AB_OUTBOUND_SITES_W           = (PT_MV_UNICODE or (    ULONG($8105) shl 16 ));
const PR_EMS_AB_OUTBOUND_SITES_O           = (PT_OBJECT or (        ULONG($8105) shl 16 ));
const PR_EMS_AB_OUTBOUND_SITES_T           = (PT_MV_TSTRING or (    ULONG($8105) shl 16 ));
const PR_EMS_AB_OWNER                      = (PT_TSTRING or (       ULONG($800C) shl 16 ));
const PR_EMS_AB_OWNER_A                    = (PT_STRING8 or (       ULONG($800C) shl 16 ));
const PR_EMS_AB_OWNER_W                    = (PT_UNICODE or (       ULONG($800C) shl 16 ));
const PR_EMS_AB_OWNER_O                    = (PT_OBJECT or (        ULONG($800C) shl 16 ));
const PR_EMS_AB_OWNER_T                    = (PT_TSTRING or (       ULONG($800C) shl 16 ));
const PR_EMS_AB_OWNER_BL                   = (PT_TSTRING or (       ULONG($8024) shl 16 ));
const PR_EMS_AB_OWNER_BL_A                 = (PT_STRING8 or (       ULONG($8024) shl 16 ));
const PR_EMS_AB_OWNER_BL_W                 = (PT_UNICODE or (       ULONG($8024) shl 16 ));
const PR_EMS_AB_OWNER_BL_O                 = (PT_OBJECT or (        ULONG($8024) shl 16 ));
const PR_EMS_AB_OWNER_BL_T                 = (PT_TSTRING or (       ULONG($8024) shl 16 ));
const PR_EMS_AB_P_SELECTOR                 = (PT_BINARY or (        ULONG($8106) shl 16 ));
const PR_EMS_AB_P_SELECTOR_INBOUND         = (PT_BINARY or (        ULONG($8107) shl 16 ));
const PR_EMS_AB_PER_MSG_DIALOG_DISPLAY_TABLE = (PT_BINARY or (        ULONG($8108) shl 16 ));
const PR_EMS_AB_PER_RECIP_DIALOG_DISPLAY_TABLE = (PT_BINARY or (        ULONG($8109) shl 16 ));
const PR_EMS_AB_PERIOD_REP_SYNC_TIMES      = (PT_BINARY or (        ULONG($810A) shl 16 ));
const PR_EMS_AB_PERIOD_REPL_STAGGER        = (PT_LONG or (          ULONG($810B) shl 16 ));
const PR_EMS_AB_PF_CONTACTS                = (PT_MV_TSTRING or (    ULONG($8038) shl 16 ));
const PR_EMS_AB_PF_CONTACTS_A              = (PT_MV_STRING8 or (    ULONG($8038) shl 16 ));
const PR_EMS_AB_PF_CONTACTS_W              = (PT_MV_UNICODE or (    ULONG($8038) shl 16 ));
const PR_EMS_AB_PF_CONTACTS_O              = (PT_OBJECT or (        ULONG($8038) shl 16 ));
const PR_EMS_AB_PF_CONTACTS_T              = (PT_MV_TSTRING or (    ULONG($8038) shl 16 ));
const PR_EMS_AB_POP_CHARACTER_SET          = (PT_TSTRING or (       ULONG($8179) shl 16 ));
const PR_EMS_AB_POP_CHARACTER_SET_A        = (PT_STRING8 or (       ULONG($8179) shl 16 ));
const PR_EMS_AB_POP_CHARACTER_SET_W        = (PT_UNICODE or (       ULONG($8179) shl 16 ));
const PR_EMS_AB_POP_CONTENT_FORMAT         = (PT_TSTRING or (       ULONG($8177) shl 16 ));
const PR_EMS_AB_POP_CONTENT_FORMAT_A       = (PT_STRING8 or (       ULONG($8177) shl 16 ));
const PR_EMS_AB_POP_CONTENT_FORMAT_W       = (PT_UNICODE or (       ULONG($8177) shl 16 ));
const PR_EMS_AB_POSTAL_ADDRESS             = (PT_MV_BINARY or (     ULONG($810C) shl 16 ));
const PR_EMS_AB_PREFERRED_DELIVERY_METHOD  = (PT_MV_LONG or (       ULONG($810D) shl 16 ));
const PR_EMS_AB_PRMD                       = (PT_TSTRING or (       ULONG($810E) shl 16 ));
const PR_EMS_AB_PRMD_A                     = (PT_STRING8 or (       ULONG($810E) shl 16 ));
const PR_EMS_AB_PRMD_W                     = (PT_UNICODE or (       ULONG($810E) shl 16 ));
const PR_EMS_AB_PROXY_ADDRESSES            = (PT_MV_TSTRING or (    ULONG($800F) shl 16 ));
const PR_EMS_AB_PROXY_ADDRESSES_A          = (PT_MV_STRING8 or (    ULONG($800F) shl 16 ));
const PR_EMS_AB_PROXY_ADDRESSES_W          = (PT_MV_UNICODE or (    ULONG($800F) shl 16 ));
const PR_EMS_AB_PROXY_GENERATOR_DLL        = (PT_TSTRING or (       ULONG($810F) shl 16 ));
const PR_EMS_AB_PROXY_GENERATOR_DLL_A      = (PT_STRING8 or (       ULONG($810F) shl 16 ));
const PR_EMS_AB_PROXY_GENERATOR_DLL_W      = (PT_UNICODE or (       ULONG($810F) shl 16 ));
const PR_EMS_AB_PUBLIC_DELEGATES           = (PT_OBJECT or (        ULONG($8015) shl 16 ));
const PR_EMS_AB_PUBLIC_DELEGATES_A         = (PT_MV_STRING8 or (    ULONG($8015) shl 16 ));
const PR_EMS_AB_PUBLIC_DELEGATES_W         = (PT_MV_UNICODE or (    ULONG($8015) shl 16 ));
const PR_EMS_AB_PUBLIC_DELEGATES_O         = (PT_OBJECT or (        ULONG($8015) shl 16 ));
const PR_EMS_AB_PUBLIC_DELEGATES_T         = (PT_MV_TSTRING or (    ULONG($8015) shl 16 ));
const PR_EMS_AB_PUBLIC_DELEGATES_BL        = (PT_MV_TSTRING or (    ULONG($8110) shl 16 ));
const PR_EMS_AB_PUBLIC_DELEGATES_BL_A      = (PT_MV_STRING8 or (    ULONG($8110) shl 16 ));
const PR_EMS_AB_PUBLIC_DELEGATES_BL_W      = (PT_MV_UNICODE or (    ULONG($8110) shl 16 ));
const PR_EMS_AB_PUBLIC_DELEGATES_BL_O      = (PT_OBJECT or (        ULONG($8110) shl 16 ));
const PR_EMS_AB_PUBLIC_DELEGATES_BL_T      = (PT_MV_TSTRING or (    ULONG($8110) shl 16 ));
const PR_EMS_AB_QUOTA_NOTIFICATION_SCHEDULE = (PT_BINARY or (        ULONG($8111) shl 16 ));
const PR_EMS_AB_QUOTA_NOTIFICATION_STYLE   = (PT_LONG or (          ULONG($8112) shl 16 ));
const PR_EMS_AB_RANGE_LOWER                = (PT_LONG or (          ULONG($8113) shl 16 ));
const PR_EMS_AB_RANGE_UPPER                = (PT_LONG or (          ULONG($8114) shl 16 ));
const PR_EMS_AB_RAS_CALLBACK_NUMBER        = (PT_TSTRING or (       ULONG($8115) shl 16 ));
const PR_EMS_AB_RAS_CALLBACK_NUMBER_A      = (PT_STRING8 or (       ULONG($8115) shl 16 ));
const PR_EMS_AB_RAS_CALLBACK_NUMBER_W      = (PT_UNICODE or (       ULONG($8115) shl 16 ));
const PR_EMS_AB_RAS_PHONE_NUMBER           = (PT_TSTRING or (       ULONG($8116) shl 16 ));
const PR_EMS_AB_RAS_PHONE_NUMBER_A         = (PT_STRING8 or (       ULONG($8116) shl 16 ));
const PR_EMS_AB_RAS_PHONE_NUMBER_W         = (PT_UNICODE or (       ULONG($8116) shl 16 ));
const PR_EMS_AB_RAS_PHONEBOOK_ENTRY_NAME   = (PT_TSTRING or (       ULONG($8117) shl 16 ));
const PR_EMS_AB_RAS_PHONEBOOK_ENTRY_NAME_A = (PT_STRING8 or (       ULONG($8117) shl 16 ));
const PR_EMS_AB_RAS_PHONEBOOK_ENTRY_NAME_W = (PT_UNICODE or (       ULONG($8117) shl 16 ));
const PR_EMS_AB_RAS_REMOTE_SRVR_NAME       = (PT_TSTRING or (       ULONG($8118) shl 16 ));
const PR_EMS_AB_RAS_REMOTE_SRVR_NAME_A     = (PT_STRING8 or (       ULONG($8118) shl 16 ));
const PR_EMS_AB_RAS_REMOTE_SRVR_NAME_W     = (PT_UNICODE or (       ULONG($8118) shl 16 ));
const PR_EMS_AB_REGISTERED_ADDRESS         = (PT_MV_BINARY or (     ULONG($8119) shl 16 ));
const PR_EMS_AB_REMOTE_BRIDGE_HEAD         = (PT_TSTRING or (       ULONG($811A) shl 16 ));
const PR_EMS_AB_REMOTE_BRIDGE_HEAD_A       = (PT_STRING8 or (       ULONG($811A) shl 16 ));
const PR_EMS_AB_REMOTE_BRIDGE_HEAD_W       = (PT_UNICODE or (       ULONG($811A) shl 16 ));
const PR_EMS_AB_REMOTE_BRIDGE_HEAD_ADDRESS = (PT_TSTRING or (       ULONG($811B) shl 16 ));
const PR_EMS_AB_REMOTE_BRIDGE_HEAD_ADDRESS_A = (PT_STRING8 or (       ULONG($811B) shl 16 ));
const PR_EMS_AB_REMOTE_BRIDGE_HEAD_ADDRESS_W = (PT_UNICODE or (       ULONG($811B) shl 16 ));
const PR_EMS_AB_REMOTE_OUT_BH_SERVER       = (PT_TSTRING or (       ULONG($811C) shl 16 ));
const PR_EMS_AB_REMOTE_OUT_BH_SERVER_A     = (PT_STRING8 or (       ULONG($811C) shl 16 ));
const PR_EMS_AB_REMOTE_OUT_BH_SERVER_W     = (PT_UNICODE or (       ULONG($811C) shl 16 ));
const PR_EMS_AB_REMOTE_OUT_BH_SERVER_O     = (PT_OBJECT or (        ULONG($811C) shl 16 ));
const PR_EMS_AB_REMOTE_OUT_BH_SERVER_T     = (PT_TSTRING or (       ULONG($811C) shl 16 ));
const PR_EMS_AB_REMOTE_SITE                = (PT_TSTRING or (       ULONG($811D) shl 16 ));
const PR_EMS_AB_REMOTE_SITE_A              = (PT_STRING8 or (       ULONG($811D) shl 16 ));
const PR_EMS_AB_REMOTE_SITE_W              = (PT_UNICODE or (       ULONG($811D) shl 16 ));
const PR_EMS_AB_REMOTE_SITE_O              = (PT_OBJECT or (        ULONG($811D) shl 16 ));
const PR_EMS_AB_REMOTE_SITE_T              = (PT_TSTRING or (       ULONG($811D) shl 16 ));
const PR_EMS_AB_REPLICATION_MAIL_MSG_SIZE  = (PT_LONG or (          ULONG($8168) shl 16 ));
const PR_EMS_AB_REPLICATION_SENSITIVITY    = (PT_LONG or (          ULONG($811E) shl 16 ));
const PR_EMS_AB_REPLICATION_STAGGER        = (PT_LONG or (          ULONG($811F) shl 16 ));
const PR_EMS_AB_REPORT_TO_ORIGINATOR       = (PT_BOOLEAN or (       ULONG($8120) shl 16 ));
const PR_EMS_AB_REPORT_TO_OWNER            = (PT_BOOLEAN or (       ULONG($8121) shl 16 ));
const PR_EMS_AB_REPORTS                    = (PT_OBJECT or (        ULONG($800E) shl 16 ));
const PR_EMS_AB_REPORTS_A                  = (PT_MV_STRING8 or (    ULONG($800E) shl 16 ));
const PR_EMS_AB_REPORTS_W                  = (PT_MV_UNICODE or (    ULONG($800E) shl 16 ));
const PR_EMS_AB_REPORTS_O                  = (PT_OBJECT or (        ULONG($800E) shl 16 ));
const PR_EMS_AB_REPORTS_T                  = (PT_MV_TSTRING or (    ULONG($800E) shl 16 ));
const PR_EMS_AB_REQ_SEQ                    = (PT_LONG or (          ULONG($8122) shl 16 ));
const PR_EMS_AB_RESPONSIBLE_LOCAL_DXA      = (PT_TSTRING or (       ULONG($8123) shl 16 ));
const PR_EMS_AB_RESPONSIBLE_LOCAL_DXA_A    = (PT_STRING8 or (       ULONG($8123) shl 16 ));
const PR_EMS_AB_RESPONSIBLE_LOCAL_DXA_W    = (PT_UNICODE or (       ULONG($8123) shl 16 ));
const PR_EMS_AB_RESPONSIBLE_LOCAL_DXA_O    = (PT_OBJECT or (        ULONG($8123) shl 16 ));
const PR_EMS_AB_RESPONSIBLE_LOCAL_DXA_T    = (PT_TSTRING or (       ULONG($8123) shl 16 ));
const PR_EMS_AB_RID_SERVER                 = (PT_TSTRING or (       ULONG($8124) shl 16 ));
const PR_EMS_AB_RID_SERVER_A               = (PT_STRING8 or (       ULONG($8124) shl 16 ));
const PR_EMS_AB_RID_SERVER_W               = (PT_UNICODE or (       ULONG($8124) shl 16 ));
const PR_EMS_AB_RID_SERVER_O               = (PT_OBJECT or (        ULONG($8124) shl 16 ));
const PR_EMS_AB_RID_SERVER_T               = (PT_TSTRING or (       ULONG($8124) shl 16 ));
const PR_EMS_AB_ROLE_OCCUPANT              = (PT_MV_TSTRING or (    ULONG($8125) shl 16 ));
const PR_EMS_AB_ROLE_OCCUPANT_A            = (PT_MV_STRING8 or (    ULONG($8125) shl 16 ));
const PR_EMS_AB_ROLE_OCCUPANT_W            = (PT_MV_UNICODE or (    ULONG($8125) shl 16 ));
const PR_EMS_AB_ROLE_OCCUPANT_O            = (PT_OBJECT or (        ULONG($8125) shl 16 ));
const PR_EMS_AB_ROLE_OCCUPANT_T            = (PT_MV_TSTRING or (    ULONG($8125) shl 16 ));
const PR_EMS_AB_ROUTING_LIST               = (PT_MV_TSTRING or (    ULONG($8126) shl 16 ));
const PR_EMS_AB_ROUTING_LIST_A             = (PT_MV_STRING8 or (    ULONG($8126) shl 16 ));
const PR_EMS_AB_ROUTING_LIST_W             = (PT_MV_UNICODE or (    ULONG($8126) shl 16 ));
const PR_EMS_AB_RTS_CHECKPOINT_SIZE        = (PT_LONG or (          ULONG($8127) shl 16 ));
const PR_EMS_AB_RTS_RECOVERY_TIMEOUT       = (PT_LONG or (          ULONG($8128) shl 16 ));
const PR_EMS_AB_RTS_WINDOW_SIZE            = (PT_LONG or (          ULONG($8129) shl 16 ));
const PR_EMS_AB_RUNS_ON                    = (PT_MV_TSTRING or (    ULONG($812A) shl 16 ));
const PR_EMS_AB_RUNS_ON_A                  = (PT_MV_STRING8 or (    ULONG($812A) shl 16 ));
const PR_EMS_AB_RUNS_ON_W                  = (PT_MV_UNICODE or (    ULONG($812A) shl 16 ));
const PR_EMS_AB_RUNS_ON_O                  = (PT_OBJECT or (        ULONG($812A) shl 16 ));
const PR_EMS_AB_RUNS_ON_T                  = (PT_MV_TSTRING or (    ULONG($812A) shl 16 ));
const PR_EMS_AB_S_SELECTOR                 = (PT_BINARY or (        ULONG($812B) shl 16 ));
const PR_EMS_AB_S_SELECTOR_INBOUND         = (PT_BINARY or (        ULONG($812C) shl 16 ));
const PR_EMS_AB_SCHEMA_FLAGS               = (PT_LONG or (          ULONG($8173) shl 16 ));
const PR_EMS_AB_SCHEMA_VERSION             = (PT_MV_LONG or (       ULONG($817C) shl 16 ));
const PR_EMS_AB_SEARCH_FLAGS               = (PT_LONG or (          ULONG($812D) shl 16 ));
const PR_EMS_AB_SEARCH_GUIDE               = (PT_MV_BINARY or (     ULONG($812E) shl 16 ));
const PR_EMS_AB_SECURITY_PROTOCOL          = (PT_MV_BINARY or (     ULONG($8037) shl 16 ));
const PR_EMS_AB_SEE_ALSO                   = (PT_MV_TSTRING or (    ULONG($812F) shl 16 ));
const PR_EMS_AB_SEE_ALSO_A                 = (PT_MV_STRING8 or (    ULONG($812F) shl 16 ));
const PR_EMS_AB_SEE_ALSO_W                 = (PT_MV_UNICODE or (    ULONG($812F) shl 16 ));
const PR_EMS_AB_SEE_ALSO_O                 = (PT_OBJECT or (        ULONG($812F) shl 16 ));
const PR_EMS_AB_SEE_ALSO_T                 = (PT_MV_TSTRING or (    ULONG($812F) shl 16 ));
const PR_EMS_AB_SERIAL_NUMBER              = (PT_MV_TSTRING or (    ULONG($8130) shl 16 ));
const PR_EMS_AB_SERIAL_NUMBER_A            = (PT_MV_STRING8 or (    ULONG($8130) shl 16 ));
const PR_EMS_AB_SERIAL_NUMBER_W            = (PT_MV_UNICODE or (    ULONG($8130) shl 16 ));
const PR_EMS_AB_SERVICE_ACTION_FIRST       = (PT_LONG or (          ULONG($8131) shl 16 ));
const PR_EMS_AB_SERVICE_ACTION_OTHER       = (PT_LONG or (          ULONG($8132) shl 16 ));
const PR_EMS_AB_SERVICE_ACTION_SECOND      = (PT_LONG or (          ULONG($8133) shl 16 ));
const PR_EMS_AB_SERVICE_RESTART_DELAY      = (PT_LONG or (          ULONG($8134) shl 16 ));
const PR_EMS_AB_SERVICE_RESTART_MESSAGE    = (PT_TSTRING or (       ULONG($8135) shl 16 ));
const PR_EMS_AB_SERVICE_RESTART_MESSAGE_A  = (PT_STRING8 or (       ULONG($8135) shl 16 ));
const PR_EMS_AB_SERVICE_RESTART_MESSAGE_W  = (PT_UNICODE or (       ULONG($8135) shl 16 ));
const PR_EMS_AB_SESSION_DISCONNECT_TIMER   = (PT_LONG or (          ULONG($8136) shl 16 ));
const PR_EMS_AB_SITE_AFFINITY              = (PT_MV_TSTRING or (    ULONG($8137) shl 16 ));
const PR_EMS_AB_SITE_AFFINITY_A            = (PT_MV_STRING8 or (    ULONG($8137) shl 16 ));
const PR_EMS_AB_SITE_AFFINITY_W            = (PT_MV_UNICODE or (    ULONG($8137) shl 16 ));
const PR_EMS_AB_SITE_FOLDER_GUID           = (PT_BINARY or (        ULONG($8166) shl 16 ));
const PR_EMS_AB_SITE_FOLDER_SERVER         = (PT_TSTRING or (       ULONG($8167) shl 16 ));
const PR_EMS_AB_SITE_FOLDER_SERVER_A       = (PT_STRING8 or (       ULONG($8167) shl 16 ));
const PR_EMS_AB_SITE_FOLDER_SERVER_W       = (PT_UNICODE or (       ULONG($8167) shl 16 ));
const PR_EMS_AB_SITE_FOLDER_SERVER_O       = (PT_OBJECT or (        ULONG($8167) shl 16 ));
const PR_EMS_AB_SITE_FOLDER_SERVER_T       = (PT_TSTRING or (       ULONG($8167) shl 16 ));
const PR_EMS_AB_SITE_PROXY_SPACE           = (PT_MV_TSTRING or (    ULONG($8138) shl 16 ));
const PR_EMS_AB_SITE_PROXY_SPACE_A         = (PT_MV_STRING8 or (    ULONG($8138) shl 16 ));
const PR_EMS_AB_SITE_PROXY_SPACE_W         = (PT_MV_UNICODE or (    ULONG($8138) shl 16 ));
const PR_EMS_AB_SPACE_LAST_COMPUTED        = (PT_SYSTIME or (       ULONG($8139) shl 16 ));
const PR_EMS_AB_STREET_ADDRESS             = (PT_TSTRING or (       ULONG($813A) shl 16 ));
const PR_EMS_AB_STREET_ADDRESS_A           = (PT_STRING8 or (       ULONG($813A) shl 16 ));
const PR_EMS_AB_STREET_ADDRESS_W           = (PT_UNICODE or (       ULONG($813A) shl 16 ));
const PR_EMS_AB_SUB_REFS                   = (PT_MV_TSTRING or (    ULONG($813B) shl 16 ));
const PR_EMS_AB_SUB_REFS_A                 = (PT_MV_STRING8 or (    ULONG($813B) shl 16 ));
const PR_EMS_AB_SUB_REFS_W                 = (PT_MV_UNICODE or (    ULONG($813B) shl 16 ));
const PR_EMS_AB_SUB_REFS_O                 = (PT_OBJECT or (        ULONG($813B) shl 16 ));
const PR_EMS_AB_SUB_REFS_T                 = (PT_MV_TSTRING or (    ULONG($813B) shl 16 ));
const PR_EMS_AB_SUB_SITE                   = (PT_TSTRING or (       ULONG($817B) shl 16 ));
const PR_EMS_AB_SUB_SITE_A                 = (PT_STRING8 or (       ULONG($817B) shl 16 ));
const PR_EMS_AB_SUB_SITE_W                 = (PT_UNICODE or (       ULONG($817B) shl 16 ));
const PR_EMS_AB_SUBMISSION_CONT_LENGTH     = (PT_LONG or (          ULONG($813C) shl 16 ));
const PR_EMS_AB_SUPPORTED_APPLICATION_CONTEXT = (PT_MV_BINARY or (     ULONG($813D) shl 16 ));
const PR_EMS_AB_SUPPORTING_STACK           = (PT_MV_TSTRING or (    ULONG($813E) shl 16 ));
const PR_EMS_AB_SUPPORTING_STACK_A         = (PT_MV_STRING8 or (    ULONG($813E) shl 16 ));
const PR_EMS_AB_SUPPORTING_STACK_W         = (PT_MV_UNICODE or (    ULONG($813E) shl 16 ));
const PR_EMS_AB_SUPPORTING_STACK_O         = (PT_OBJECT or (        ULONG($813E) shl 16 ));
const PR_EMS_AB_SUPPORTING_STACK_T         = (PT_MV_TSTRING or (    ULONG($813E) shl 16 ));
const PR_EMS_AB_SUPPORTING_STACK_BL        = (PT_MV_TSTRING or (    ULONG($813F) shl 16 ));
const PR_EMS_AB_SUPPORTING_STACK_BL_A      = (PT_MV_STRING8 or (    ULONG($813F) shl 16 ));
const PR_EMS_AB_SUPPORTING_STACK_BL_W      = (PT_MV_UNICODE or (    ULONG($813F) shl 16 ));
const PR_EMS_AB_SUPPORTING_STACK_BL_O      = (PT_OBJECT or (        ULONG($813F) shl 16 ));
const PR_EMS_AB_SUPPORTING_STACK_BL_T      = (PT_MV_TSTRING or (    ULONG($813F) shl 16 ));
const PR_EMS_AB_T_SELECTOR                 = (PT_BINARY or (        ULONG($8140) shl 16 ));
const PR_EMS_AB_T_SELECTOR_INBOUND         = (PT_BINARY or (        ULONG($8141) shl 16 ));
const PR_EMS_AB_TARGET_ADDRESS             = (PT_TSTRING or (       ULONG($8011) shl 16 ));
const PR_EMS_AB_TARGET_ADDRESS_A           = (PT_STRING8 or (       ULONG($8011) shl 16 ));
const PR_EMS_AB_TARGET_ADDRESS_W           = (PT_UNICODE or (       ULONG($8011) shl 16 ));
const PR_EMS_AB_TARGET_MTAS                = (PT_MV_TSTRING or (    ULONG($8142) shl 16 ));
const PR_EMS_AB_TARGET_MTAS_A              = (PT_MV_STRING8 or (    ULONG($8142) shl 16 ));
const PR_EMS_AB_TARGET_MTAS_W              = (PT_MV_UNICODE or (    ULONG($8142) shl 16 ));
const PR_EMS_AB_TELEPHONE_NUMBER           = (PT_MV_TSTRING or (    ULONG($8012) shl 16 ));
const PR_EMS_AB_TELEPHONE_NUMBER_A         = (PT_MV_STRING8 or (    ULONG($8012) shl 16 ));
const PR_EMS_AB_TELEPHONE_NUMBER_W         = (PT_MV_UNICODE or (    ULONG($8012) shl 16 ));
const PR_EMS_AB_TELETEX_TERMINAL_IDENTIFIER = (PT_MV_BINARY or (     ULONG($8143) shl 16 ));
const PR_EMS_AB_TEMP_ASSOC_THRESHOLD       = (PT_LONG or (          ULONG($8144) shl 16 ));
const PR_EMS_AB_TOMBSTONE_LIFETIME         = (PT_LONG or (          ULONG($8145) shl 16 ));
const PR_EMS_AB_TRACKING_LOG_PATH_NAME     = (PT_TSTRING or (       ULONG($8146) shl 16 ));
const PR_EMS_AB_TRACKING_LOG_PATH_NAME_A   = (PT_STRING8 or (       ULONG($8146) shl 16 ));
const PR_EMS_AB_TRACKING_LOG_PATH_NAME_W   = (PT_UNICODE or (       ULONG($8146) shl 16 ));
const PR_EMS_AB_TRANS_RETRY_MINS           = (PT_LONG or (          ULONG($8147) shl 16 ));
const PR_EMS_AB_TRANS_TIMEOUT_MINS         = (PT_LONG or (          ULONG($8148) shl 16 ));
const PR_EMS_AB_TRANSFER_RETRY_INTERVAL    = (PT_LONG or (          ULONG($8149) shl 16 ));
const PR_EMS_AB_TRANSFER_TIMEOUT_NON_URGENT = (PT_LONG or (          ULONG($814A) shl 16 ));
const PR_EMS_AB_TRANSFER_TIMEOUT_NORMAL    = (PT_LONG or (          ULONG($814B) shl 16 ));
const PR_EMS_AB_TRANSFER_TIMEOUT_URGENT    = (PT_LONG or (          ULONG($814C) shl 16 ));
const PR_EMS_AB_TRANSLATION_TABLE_USED     = (PT_LONG or (          ULONG($814D) shl 16 ));
const PR_EMS_AB_TRANSPORT_EXPEDITED_DATA   = (PT_BOOLEAN or (       ULONG($814E) shl 16 ));
const PR_EMS_AB_TRUST_LEVEL                = (PT_LONG or (          ULONG($814F) shl 16 ));
const PR_EMS_AB_TURN_REQUEST_THRESHOLD     = (PT_LONG or (          ULONG($8150) shl 16 ));
const PR_EMS_AB_TWO_WAY_ALTERNATE_FACILITY = (PT_BOOLEAN or (       ULONG($8151) shl 16 ));
const PR_EMS_AB_UNAUTH_ORIG_BL             = (PT_MV_TSTRING or (    ULONG($8152) shl 16 ));
const PR_EMS_AB_UNAUTH_ORIG_BL_A           = (PT_MV_STRING8 or (    ULONG($8152) shl 16 ));
const PR_EMS_AB_UNAUTH_ORIG_BL_W           = (PT_MV_UNICODE or (    ULONG($8152) shl 16 ));
const PR_EMS_AB_UNAUTH_ORIG_BL_O           = (PT_OBJECT or (        ULONG($8152) shl 16 ));
const PR_EMS_AB_UNAUTH_ORIG_BL_T           = (PT_MV_TSTRING or (    ULONG($8152) shl 16 ));
const PR_EMS_AB_USE_SERVER_VALUES          = (PT_BOOLEAN or (       ULONG($817E) shl 16 ));
const PR_EMS_AB_USER_PASSWORD              = (PT_MV_BINARY or (     ULONG($8153) shl 16 ));
const PR_EMS_AB_USN_CHANGED                = (PT_LONG or (          ULONG($8029) shl 16 ));
const PR_EMS_AB_USN_CREATED                = (PT_LONG or (          ULONG($8154) shl 16 ));
const PR_EMS_AB_USN_DSA_LAST_OBJ_REMOVED   = (PT_LONG or (          ULONG($8155) shl 16 ));
const PR_EMS_AB_USN_INTERSITE              = (PT_LONG or (          ULONG($817A) shl 16 ));
const PR_EMS_AB_USN_LAST_OBJ_REM           = (PT_LONG or (          ULONG($8156) shl 16 ));
const PR_EMS_AB_USN_SOURCE                 = (PT_LONG or (          ULONG($8157) shl 16 ));
const PR_EMS_AB_WWW_HOME_PAGE              = (PT_TSTRING or (       ULONG($8175) shl 16 ));
const PR_EMS_AB_WWW_HOME_PAGE_A            = (PT_STRING8 or (       ULONG($8175) shl 16 ));
const PR_EMS_AB_WWW_HOME_PAGE_W            = (PT_UNICODE or (       ULONG($8175) shl 16 ));
const PR_EMS_AB_X121_ADDRESS               = (PT_MV_TSTRING or (    ULONG($8158) shl 16 ));
const PR_EMS_AB_X121_ADDRESS_A             = (PT_MV_STRING8 or (    ULONG($8158) shl 16 ));
const PR_EMS_AB_X121_ADDRESS_W             = (PT_MV_UNICODE or (    ULONG($8158) shl 16 ));
const PR_EMS_AB_X25_CALL_USER_DATA_INCOMING = (PT_BINARY or (        ULONG($8159) shl 16 ));
const PR_EMS_AB_X25_CALL_USER_DATA_OUTGOING = (PT_BINARY or (        ULONG($815A) shl 16 ));
const PR_EMS_AB_X25_FACILITIES_DATA_INCOMING = (PT_BINARY or (        ULONG($815B) shl 16 ));
const PR_EMS_AB_X25_FACILITIES_DATA_OUTGOING = (PT_BINARY or (        ULONG($815C) shl 16 ));
const PR_EMS_AB_X25_LEASED_LINE_PORT       = (PT_BINARY or (        ULONG($815D) shl 16 ));
const PR_EMS_AB_X25_LEASED_OR_SWITCHED     = (PT_BOOLEAN or (       ULONG($815E) shl 16 ));
const PR_EMS_AB_X25_REMOTE_MTA_PHONE       = (PT_TSTRING or (       ULONG($815F) shl 16 ));
const PR_EMS_AB_X25_REMOTE_MTA_PHONE_A     = (PT_STRING8 or (       ULONG($815F) shl 16 ));
const PR_EMS_AB_X25_REMOTE_MTA_PHONE_W     = (PT_UNICODE or (       ULONG($815F) shl 16 ));
const PR_EMS_AB_X400_ATTACHMENT_TYPE       = (PT_BINARY or (        ULONG($8160) shl 16 ));
const PR_EMS_AB_X400_SELECTOR_SYNTAX       = (PT_LONG or (          ULONG($8161) shl 16 ));
const PR_EMS_AB_X500_ACCESS_CONTROL_LIST   = (PT_BINARY or (        ULONG($8162) shl 16 ));
const PR_EMS_AB_XMIT_TIMEOUT_NON_URGENT    = (PT_LONG or (          ULONG($8163) shl 16 ));
const PR_EMS_AB_XMIT_TIMEOUT_NORMAL        = (PT_LONG or (          ULONG($8164) shl 16 ));
const PR_EMS_AB_XMIT_TIMEOUT_URGENT        = (PT_LONG or (          ULONG($8165) shl 16 ));

implementation

end.



